        subroutine gpinit (komna, prompt, npar, p1, p2, p3, p4, p5)
C ***              ======
C ***
C ***	Junk (Sun)-Version	 29-MAR-1988 17:21:50 
C ***
C ***	Modifications:
C ***
C ***	14-APR-1994 22:08:57.00		ML / IoA Cambs.  komnam was a bit short
C ***	22-JUL-1994 11:48:48.00		ML / IoA Cambs.  Put in comments from
C ***					VMS version (third time now -
C ***					connection always crashing)
C ***	 4-NOV-1994 19:27:35.00		ML / IoA.  Add filename completion
C ***					to GFILE via GNU's readline library
C ***	 9-NOV-1994 11:54:25.00		ML / IoA.  Added support for up-arrow
C ***					to get invoking command back like on
C ***					VMS.  Uses GNU's add_history.
C ***	24-NOV-1994 14:02:29.00		ML / IoA.  Removed path from history
C ***					in up-arrow business on invocation
C ***	28-NOV-1994 22:18:12.00		ML / IoA.  Added calls to isatty.
C ***					GNU's readline is braindead and chokes
C ***					if not reading from a terminal.
C ***	15-FEB-1995 11:14:41.00		ML / IoA.  open( stderr, form='print')
C ***					and related formats.  Conflict for
C ***                                   GMENU.
C ***	28-APR-1995 16:11:46.00		ML / IoA.  Convert komna to lower case
C ***					and append .cmd if missing.
C ***   10-MAY-1997 15:56:06.00         ML / Bamberg.  Linux version.
C ***   11-MAY-1997 17:33:20.00         ML / Bamberg.  Cut trailing spaces in
C ***                                   calls to access et al.
C ***   28-NOV-1999 16:04:22.00		ML / McAl.  Fixed line break in getpar/
C ***					igetpar as before.
C ***	 5-OCT-2000 15:37:00.00		ML / McAl.  Replaced komnam with new
C ***					variable line for line input.  Got
C ***					overwritten but was referred to later.
C ***	23-APR-2001 23:37:17.00		ML / Stegaurach.  Allow for 7 figure
C ***					process ids (Windows98).
C ***	26-AUG-2001 16:48:00.00		ML / Stegaurach.  Chop off .exe from
C ***					cmd file name if on Windows.
C ***					Added implicit none.
C ***   25-MAY-2002 12:52:00.00         ML / Stegaurach.  Fixed (old) bug when
C ***                                   called on readonly directory.
C ***    5-NOV-2002 00:18:44.00         ML / Stegaurach.  Allow for even longer
C ***                                   process ids (9 figures).
C ***   13-JUN-2004 21:47:00.00         ML / Stegaurach.  Fix #ifdef for Solaris
C ***                                   with g77.
C ***   
C ******************************************************************************
C ***
C ***               Package for easy interactive data input.
C ***
C ***	In normal operation mode, the user is prompted for required values.
C ***	Every answer is checked for syntactical errors and if correct the answer
C ***	is written into a protocol file. Optionally, the answers can be read
C ***	from a file, which might be the protocol file written in an earlier run.
C ***	Thus, no syntactically valid input gets lost.
C ***
C ***	The numerical data is read with list-directed I/O, while character 
C ***	data is read in A-format.
C ***
C ***	If the optional input file is incomplete, the user is prompted for
C ***	missing values. The input file name can be given on the command line.
C ***
C ***	The package consists of the following routines:
C ***
C ***	GPINIT  Initializes package and reads up to five real values
C ***	GPAR	REAL input 	Reads up to five real values.
C ***	IGPAR	INTEGER input   Reads up to five integer values
C ***	GPARNY	LOGICAL input   Returns answer to a question which should be
C ***			        answered with yes or no.
C ***	GTEXT	CHARACTER input Reads character string.
C ***	GFILE	Asks for file specification; allows use of wildcards
C ***	GMENU	Allows to print arbitrary text on screen
C ***   GLIST   Gets a list of numbers, like 1,2,3,7-9,4,30-25
C ***	GPCLOS  Closes files
C ***
C ***
C ***
C ***	Call of GPINIT:
C ***
C ***	KOMNA:	command file name for save of commands		CHARACTER   READ
C ***	PROMPT:	prompt                                          CHARACTER   READ
C ***	NPAR:   number of values to be read                     INTEGER     READ
C ***	P1-P5:  values to read                                  REAL       WRITE
C ***
C ***
C ******************************************************************************
C ***
	implicit none
        character komnam*255, komna*(*), prompt*(*), in*1, string*(*), 
     >	  stat*7, komna1*255, line*255
	integer stdin, stderr, getpid
#ifndef __GNUC__
        integer rename
#endif
        integer status, ignore
        logical file, ant, temp_file
        common /gpfile/ file, stdin, stderr

	external add_history	!$pragma c( add_history )
	integer verstart, versname, result, context, access, idx
	logical isatty
        integer ii(5), npar, i1, i2, i3, i4, i5
        real p(5), p1, p2, p3, p4, p5

        integer label, i, ic, il, l, leng, j

	data context /0/
        save status, context, komnam, temp_file, label


	stderr = 0
#ifdef sun
#ifndef __GNUC__
	open( stderr, form = 'print' )
#endif
#endif

C
C
c        write(6, '(/,2A)') 'Wenn Kommandos in einem File sind, ',
c     $    'Filenamen angeben, sonst <return>. '

	if( iargc() .eq. 0 ) then
           write( stderr, '(/,2A)') ' If commands are in a file, ',
     $       'enter filename, if not press <return>. '
	   file = .false.

	   if( isatty(5) ) then
              call getarg( 0, komnam )
              do i = len(komnam), 1, -1
	         if( komnam(i:i) .eq. '/' ) then
	            go to 1
	         end if
	      end do
1	      continue
#ifdef __CYGWIN__
	      komna1 = ' '
	      call kleinb( komnam, komna1 )
	      ic = index( komna1, '.exe' )
	      il = idx( komna1 )
	      if( ic .eq. il - 3 ) komnam(ic:) = ' ' ! chop off .exe
#endif
	      komnam = komnam( i+1:idx(komnam) )//'.cmd'//char(0)
	      call add_history( komnam )

              call getfile( char(0), komnam, l )   ! read(5,'(a)') komnam
           else
	      read( 5, '(a)', end = 114 ) komnam
           end if
           result = versname( komnam, 'OLD', komnam, context )
	   if( result .lt. 0 ) then
              komnam = ' '
	   else if( result .eq. 0 ) then
	      if( access(komnam, 'r') .ne. 0 ) then
                 komnam = ' '
	      end if
	   end if
	else
	   call getarg( 1, komnam )
	end if
c
        file=komnam.gt.' '
        if(file) then
	   stdin = 47
	   open( stdin, file = komnam, status = 'old' )
	   stat = 'new'
	else
	   stdin = 5
	end if
c
        komna1 = ' '
	call kleinb( komna, komna1 )
        ic = index( komna1, '.cmd' )
	il = idx( komna1 )
	if( ic .ne. il - 3 ) then	! no '.cmd',
	   komna1(il+1:) = '.cmd'       ! append it
        end if
	if( komnam .eq. komna1 ) then
	   temp_file = .true.
	   write( komnam(:9), '(i9.9)' ) getpid()
	   komnam(10:) = komna1
	else
	   temp_file = .false.
	   komnam = komna1
	end if
        open( 2, file = komnam, status = 'unknown', iostat = status )
        if( status .ne. 0 ) then
           write( stderr, * ) 'Warning: Can''t save your answers.'
        end if

C
        entry gpar(prompt,npar,p1,p2,p3,p4,p5)
C ***         ====
C ******************************************************************************
C ***
C ***	Reads up to five real values.
C ***
C ***	PROMPT:	prompt                                          CHARACTER   READ
C ***	NPAR:   number of values to be read                     INTEGER     READ
C ***	P1-P5:  values to read                                  REAL       WRITE
C ***
C ******************************************************************************
C ***

        if(npar.le.0) return
        p(1)=p1
        p(2)=p2
        p(3)=p3
        p(4)=p4
        p(5)=p5
        assign 112 to label
112     if(.not.file) write( stderr, '(/,1x,2a,$)')
     >                prompt(:idx(prompt)), ' ?  '
        read(stdin, *,err=112,end=114) (p(i),i=1,npar)
        write(line,*, iostat = ignore ) (p(i),i=1,npar),'  ',
     >                                    prompt(:idx(prompt))
	write( 2, '(a)', iostat = ignore ) line(:idx(line))
        p1=p(1)
        p2=p(2)
        p3=p(3)
        p4=p(4)
        p5=p(5)
        return
c------------------------------------------------------------------------------

        entry igpar(prompt,npar,i1,i2,i3,i4,i5)
C ***         =====
C ******************************************************************************
C ***
C ***	Reads up to five integer values
C ***
C ***	PROMPT:	prompt                                          CHARACTER   READ
C ***	NPAR:   number of values to be read                     INTEGER     READ
C ***	I1-I5:  values to read                                  INTEGER    WRITE
C ***
C ******************************************************************************
C ***

        if(npar.le.0) return
        ii(1)=i1
        ii(2)=i2
        ii(3)=i3
        ii(4)=i4
        ii(5)=i5
        assign 113 to label
113     if(.not.file) write( stderr, '(/,1x,2a,$)')
     >                prompt(:idx(prompt)), ' ?  '
        read(stdin, *,err=113,end=114) (ii(i),i=1,npar)
        write(line,*, iostat = ignore ) (ii(i),i=1,npar),'  ', 
     >                                    prompt(:idx(prompt))
	write( 2, '(a)', iostat = ignore ) line(:idx(line))
        i1=ii(1)
        i2=ii(2)
        i3=ii(3)
        i4=ii(4)
        i5=ii(5)
        return
c------------------------------------------------------------------------------

c       Fehler-'Routine'

114     if(file) then
           close( stdin )
           file=.false.
           stdin = 5
           go to label
        else
           call exit
        end if
c------------------------------------------------------------------------------

        entry gparny(prompt,ant)
C ***         ======
C ******************************************************************************
C ***
C ***	Returns answer to a question which should be answered with yes or no.
C ***
C ***	PROMPT:	prompt                                          CHARACTER   READ
C ***	ANT:    answer, true if answer was YES; default: NO     LOGICAL    WRITE
C ***
C ******************************************************************************
C ***

        assign 115 to label
115     if(.not.file) write( stderr, '(/,1x,2a,$)') 
     >                prompt(:idx(prompt)), ' (y/n) ?  '
        read(stdin, '(a)',err=115,end=114) in
        write(2,'(3a)', iostat = ignore ) in,'  ', prompt(:idx(prompt))
        ant=in.eq.'y'.or.in.eq.'Y'
        return
c------------------------------------------------------------------------------


        entry gtext(prompt,string)
C ***         =====
C ******************************************************************************
C ***
C ***	Reads character string.
C ***
C ***	PROMPT:	prompt                                          CHARACTER   READ
C ***	STRING: string to read                                  CHARACTER  WRITE
C ***
C ******************************************************************************
C ***

121     assign 116 to label
116     if(.not.file) then
	   write( stderr, '(/,1x,2a,$)') prompt(:idx(prompt)), ' ?  '
	end if
        read(stdin, '(a)',err=116,end=114) string
        write(2,'(3a)', iostat = ignore ) string,'  ',
     >                                    prompt(:idx(prompt))
        return
c------------------------------------------------------------------------------
	entry gfile( prompt, string, komna )
c             =====
C ******************************************************************************
C ***
C ***	Asks for file specification. Looks up disk for existing file. To get 
C ***	name for non-existing file, set STRING to 'NEW' before calling this 
C ***	routine.  This routine has problems with spaces in filenames - can't
C ***	access them.  Hard to fix without major recoding.  Default file spec
C ***	doesn't work - sort of nonsensical in Unix.
C ***
C ***
C ***	PROMPT:	prompt                                     CHARACTER*255    READ
C ***	STRING: resultant complete file specification      CHARACTER  READ/WRITE
C ***	KOMNA:  default file specification                 CHARACTER        READ
C ***
C ******************************************************************************
C ***
        if( string .eq. 'NEW' ) then
	   stat = 'NEW'
	else if( string .eq. 'JUNK' ) then
	   stat = 'UJUNK'	! hack for plodep
	else
	   stat = 'OLD'
	end if
	assign 117 to label
117	continue
        if( .not.file ) then
	   write( stderr, '(/,1x,2a,$)') prompt(:idx(prompt)), ' ?  '
           if( isatty(5) ) then
	      call getfile( char(0), string, leng )
              if( leng .eq. -1 ) go to 114 			! eof
	   else
	      read( 5, '(a)', err = 117, end = 114 ) string
              leng = idx( string )	! q format requires seekable device
	   end if
	else
	   read( stdin, '(a)', err = 117, end = 114 ) string
           leng = idx( string )
C ***
C ***      Ersetze TAB's durch Blanks
C ***
           do i = 1, leng
              if ( string( i:i ) .eq. char(9) ) string( i:i ) = ' '
           end do
C ***      
C ***      Finde fuehrende Blanks
C ***
           i = 1
           do while ( (i .lt. leng) .and. (string(i:i) .eq. ' ') )
              i = i + 1
           end do
C ***
           string = string( i: )
c          string = string( str$find_first_not_in_set(string,'     '): )
           if( string .eq. prompt ) string = ' '
           string = string( :index(string, ' ' ) )
	end if
	if( stat .eq. 'NEW' ) then
C ***
C ***	   Never return a version number or write one to file
C ***
	   leng = verstart( string )
	   string = string(:leng)		! strip off version #
	else
C ***
C ***	   If there was no version number entered interactively or in
C ***	   file don't add one, if there was one, keep it (same behavior
C ***      as versname).
C ***
	   leng = max( 1, idx(string) )		! remember end of string
	end if
        context = 0
	result = versname( string, stat, string, context ) ! add version
        l = idx(string)
        if( result .lt. 0 ) then
           if( result .eq. -1 ) then
	      if( stat .eq. 'NEW' ) then
                 write( stderr, '(3a)' ) ' Can''t create ',
     >                                   string(:l),
     >                                   ': file exists'
	      else
                 write( stderr, '(3a)' ) ' Can''t read ',
     >                                   string(:l),
     >                                   ': No such file or directory'
	      end if
	   end if
	   if( stat .ne. 'UJUNK' ) go to 117		! something wrong
!		UJUNK is a hack to allow for invalid file specs (plodep)
	else if( result .eq. 0 ) then
           if( stat .eq. 'NEW' ) then
	      if( access( string(:l), ' ' ) .eq. 0 ) then
                 write( stderr, '(3a)' ) ' Can''t create ',
     >                                   string(:l),
     >                                   ': file exists'
	         go to 117
	      else if( access( string(:l), 'w' ) .ne. 0 ) then
                 write( stderr, '(2a)' ) ' Can''t write ',
     >	                                 string(:l)
                 call perror( 'GFILE' )
	         go to 117
	      end if
	   else
	      if( access( string(:l), 'r' ) .ne. 0 ) then
                 write( stderr, '(2a)' ) ' Can''t read ',
     >	                                 string(:l)
                 call perror( 'GFILE' )
	         go to 117
	      end if
	   end if
	end if

        write(2,'(3a)', iostat = ignore ) string(:leng),'  ',
     >                                    prompt(:idx(prompt))

        return
c------------------------------------------------------------------------------
	entry gmenu( prompt )
C ***         =====
C ******************************************************************************
C ***
C ***	Allows to print arbitrary text on screen, suppressed if reading from
C ***	file.
C ***
C ***	PROMPT:	standard FORTRAN format                         CHARACTER   READ
C ***           ex.: (/,10X,'Head',/,x,'Version 0.0')
C ***
C ***
C ******************************************************************************
C ***
	if( .not. file ) then
	   write( stderr, prompt )
	end if
	return
c------------------------------------------------------------------------------
        entry gpclos
C ***         ======
C ******************************************************************************
C ***
C ***	Closes files
C ***
C ******************************************************************************
C ***

        if(file) close( stdin )
        close(2, iostat = ignore )
	if( temp_file ) then
           if( status .ne. 0 ) then
              write( stderr, * ) 'Warning: Couldn''t save your ',
     >                           'answers, sorry.'
           else
              j = idx(komnam)
#ifdef __GNUC__
              call rename( './'//komnam(:j),
     >                     './'//komnam(10:j), i )
#else
              i = rename( './'//komnam(:j), './'//komnam(10:) )
#endif
	      if( i .ne. 0 ) call perror( 'GPCLOS '//komnam(:j) )
           end if
        end if
        return
        end
	subroutine glist( prompt, list, nelem, sort, clean )
C ***
C ******************************************************************************
C ***
C ***	
C ***	Accepts string like 1,2,5,4,2-9,21-17 to return an integer array LIST,
C ***   where 2-9 is replaced by individual numbers 2,3,4,5...9.
C ***	If neither option SORT nor CLEAN is used only this replacement is done,
C ***   i.e. on return LIST(1)=1, LIST(2)=2, LIST(3)=5, LIST(4)=4, LIST(5)=2,...
C ***	Numbers must be positive.
C ***
C ***
C ***	PROMPT:	prompt                                     CHARACTER        READ
C ***	LIST:   array with decoded list elements           INTEGER         WRITE
C ***	NELEM:  number of decoded list elements            INTEGER    READ/WRITE
C ***   SORT:   sort list in ascending order               LOGICAL          READ
C ***   CLEAN:  remove duplicate entries                   LOGICAL          READ
C ***
C ***
C ***	 2-NOV-1990 00:30:21.85
C ***
C ******************************************************************************
C ***
C ***	Parameters
C ***
	character*(*) prompt
	integer list(nelem)
	logical sort, clean
C ***
C ***	Variables
C ***
	character*255 answer, elem, number_1*10, number_2*10, check*10
	logical done

	done = .false.
	do while( .not.done )
           done = .true.
	   call gtext( prompt, answer )
           do i = 1, idx(answer)
	      if( answer(i:i) .eq. ',' ) answer(i:i) = ' '
	   end do
           call compress( answer, answer )
	   ielem = 0
           jelem = 0
           call element( elem, ielem, ' ', answer )
           do while( elem .ne. ' ' )
              call element( number_1, 0, '-', elem )
              call element( number_2, 1, '-', elem )
              call element( check,    2, '-', elem )
              if( check .ne. '-' ) go to 98
              read( number_1, *, err = 98 ) n1
              n2 = n1
              if( number_2 .ne. '-' ) read( number_2, *, err = 98 ) n2
              do i = n1, n2, sign( 1, n2-n1 )
                 if( jelem .gt. nelem- 1) then
	            print *, 'GLIST: Too many list elements. Rest',
     >	              ' ignored.'
                    jelem = nelem
                    go to 99
                 end if
                 jelem = jelem + 1
                 list(jelem) = i
              end do
              ielem = ielem + 1
              call element( elem, ielem, ' ', answer )
	   end do
           go to 99
98	      done = .false.
99	   continue
	end do
        if( clean ) then
           do i = 1, jelem-1
              j = i + 1
              do while( j .le. jelem )
                 if( list(i) .eq. list(j) ) then
                    do k = j, jelem-1
                       list(k) = list(k+1)
                    end do
                    list(jelem) = 0
                    jelem = jelem - 1
                 else
                    j = j + 1
                 end if
              end do
           end do
        end if
        if( sort ) call intqsort( list, jelem, .false. )
        nelem = jelem
	end
