        subroutine achsiz(siz)
C ***
C ***   $Log: achse.f,v $
C ***   Revision 1.3  2003/01/03 14:58:30  michael
C ***   Fixed roundoff errors, various clean ups.
C ***   Tick mark labels correctly centered.
C ***
C ***   Revision 1.2  2003/01/02 19:40:32  michael
C ***   Preparation for date support.
C ***   Still working, but roundoff errors when determining whether tick mark
C ***   label should be plotted or not.
C ***
C ***
        implicit none
C ***
C ***   Arguments
C ***
        real siz
        real xx, yy
        integer nchar
        real axlen, theta, first, delta, last
        double precision dfirst, ddelta, dlast
        character*(*) texti

C ***
C ***   Local variables
C ***
        character zahl*21, text*255
        double precision firstv, lastv, deltav
        double precision tm, tm00
        integer i, leng
        integer minexp, maxexp, iexpo, ncha
        real therad, stheta, ctheta, offset
        real size, expo, expdel, scal
        real d, dm, y, x0, y0, dum, tlen
        real stlen, bemax, xleng, sq, xlcm
        logical beschr, inv, dax
        real xecke, yecke, xlast, ylast

C ***
C ***   Functions
C ***
        integer lint
        double precision jdnext
        external lint, jdnext

        save size
        data size/0.4/

C ***
C ***   Code
C ***
        size = siz
        return

        entry dachse0( xx, yy, nchar, axlen, theta, 
     $                 dfirst, ddelta, dlast )
        dax = .true.   ! date axis without tick mark labels
        go to 5

        entry achse0( xx, yy, nchar, axlen, theta, 
     $                first, delta, last )
        dax = .false.  ! ordinary axis without tick mark labels

5       continue
        beschr = .false.
        text = ' '
        go to 3

        entry dachse( xx, yy, texti, nchar, axlen, theta, 
     $                dfirst, ddelta, dlast )
        dax = .true.   ! date axis with tick mark labelling
        go to 4


        entry achse( xx, yy, texti, nchar, axlen, theta, 
     $               first, delta, last )
        dax = .false.  ! ordinary axis with tick labels

4       continue
        beschr = .true.
        text = texti

3       continue
        therad = theta*.0174532925
        stheta = sin(therad)
        ctheta = cos(therad)
        offset = size

        if( .not.dax ) then
           firstv = dble(first)
           lastv = dble(last)
           deltav = dble(delta)
C ***      find biggest and smallest number and exponent
           call stelle( real(firstv), zahl, leng, minexp )
           call stelle( real(lastv), zahl, leng, maxexp )
           maxexp = max( maxexp, minexp )
           expo = 10.**maxexp
        else
           firstv = dfirst
           lastv = dlast
           deltav = ddelta
           expo = 1.
           maxexp = 0  ! largest exponent
        end if

        inv = firstv .gt. lastv

        firstv = firstv/expo
        lastv = lastv/expo
        deltav = deltav/expo
        if( deltav .eq. 0.d0 ) then
C ***
C ***      Determine tick mark interval
C ***
           if( .not.dax ) then
              deltav = abs((lastv - firstv)*.8/axlen/size)
              expdel = log10(deltav)
              if( expdel .lt. 0 ) then
                 expdel = expdel - 0.9
              else
                 expdel = expdel + 0.1
              endif
              expdel = 10.**int(expdel)
              deltav = deltav/expdel
              if( deltav .gt. 3.5 ) then
                 deltav = 5.
              else if( deltav .gt. 1.5 ) then
                 deltav = 2.
              else
                 deltav = 1.
              end if
              deltav = deltav*expdel
              if( inv ) deltav = -deltav
           else
              ! do something clever to find good date intervals
           end if
        end if
        scal = (lastv - firstv)/axlen           ! units/cm

C ***   Find start value for first tick mark

        tm00 = lint( firstv/deltav )*deltav


        ncha = nchar
        if( ncha .eq. 0 ) ncha = 1
        stlen = sign( 1., float(ncha) )
        ncha = abs( ncha )

C ***   determine length of last labeled number
        if( .not.dax ) then
           bemax = tm00 + deltav*int( (lastv - firstv)/deltav )
          !? bemax = lint( lastv/deltav )*deltav
           call stelle( bemax, zahl, leng, i )
           call textlk( dum, tlen, size, zahl(:leng), dum, dum )
           xleng = tlen
           call stelle( real(bemax - deltav), zahl, leng, i )
           call textlk( dum, tlen, size, zahl(:leng), dum, dum )
           xleng = max( xleng, tlen )               ! string length in cm
           xleng = xleng + 2.*size                  ! allow for extra space
        else  ! under construction
           bemax = tm00 + deltav*int( (lastv - firstv)/deltav )
           call formatJD( dble(bemax), zahl )
           call formatJD( dble(bemax - deltav), zahl )
           xleng = 21*size
        end if

        call pltsyn( .true. )
C ***
C ***   Draw axis
C ***
        call plot( axlen*ctheta + xx, axlen*stheta + yy, 3 )
        call mplot( xx, yy, 2, 3 )
C ***
C ***   Draw tick marks and tick mark labels
C ***
        dm = 0.
        xlast = -xx     ! no label plotted yet: make sure we plot first one
        ylast = -yy
        i = 0
1       continue
           if( dax ) then
              tm = jdnext( tm00, deltav, i )    ! next tick mark
           else
              tm = tm00 + i*deltav
           end if
           y = (tm - firstv)/scal               ! next tick mark in cm

           i = i + 1
           if( .not.inv ) then
              if( tm - firstv .lt. 1.d-6*firstv ) go to 1     ! next value
              if( tm - lastv .gt. 1.d-6*lastv ) go to 2       ! exit loop
           else
              if( tm - firstv .gt. 1.d-6*firstv ) go to 1     ! next value
              if( tm - lastv .lt. 1.d-6*lastv ) go to 2       ! exit loop
           end if
           x0 = y*ctheta + xx
           y0 = y*stheta + yy
c
c          Markierungen zeichnen
c
           call plot( x0, y0, 3 )
           call mplot( x0 + stlen*.2*stheta, 
     >                 y0 - stlen*.2*ctheta, 2, 3 )

           if( beschr ) then
C ***         create tick mark label and determine its length
              if( .not.dax ) then
                 call fstelle( real(tm), zahl, leng, iexpo )
                 call textlk( dum, xlcm, size, zahl(:leng), dum, dum )
C ***                              ^^^^ string length in cm
              else
                 call formatJD( tm, zahl ) ! rounding/cut hours/dates...
                 xlcm = 42
              end if

C ***         compute position of tick mark label

              sq = sqrt( size*size + xlcm*xlcm )  ! label box diagonal in cm
              d = sq*.5*sin( acos(xlcm/sq) + therad ) ! height of label box
                                                      ! perpendicular to axis
              d = d + offset       ! add minimum distance to axis
              dm = max( d, dm )    ! remember max label width for axis label
              
              xecke = x0 - d*stheta*stlen - xlcm/2.  ! new label position
              yecke = y0 + d*ctheta*stlen - size/2.  ! new label position
              

C ***         plot label if not overlapping with previous one

              if( (x0 .ge. xlast + xleng) .or.
     >            (y0 .ge. ylast + size*2.) .or.
     >            (xlast .ge. x0 + xleng) .or.
     >            (ylast .ge. y0 + size*2.) ) then
                 call symblk( xecke, yecke, size, 
     >                        zahl(:leng), 0., leng )
                 xlast = x0
                 ylast = y0
              endif

           end if
        go to 1
2       continue
        if( beschr ) then
C ***
C ***      plot exponent and axis labels
C ***
           d = 2.*dm
           if( stlen .lt. 0 ) d = d + size
           if( maxexp .ne. 0 ) then
C ***         numbers were scaled (won't happen with dates) so plot exponent
              if( stlen .lt. 0 ) d = d + size/2.
              y = axlen/2. - .8
              x0 = y*ctheta - d*stheta*stlen + xx
              y0 = y*stheta + d*ctheta*stlen + yy
              call stelle( float(maxexp), zahl, leng, iexpo )
              call symblk( x0, y0, size, '* 10&H'//zahl(:leng), theta, 
     >                     6 + leng )
              d = d + offset + size
              if( stlen.ge.0 ) d = d + size/3.
           end if
           if( abs(nchar) .gt. 0 ) then
C ***         plot axis label
              call textlk( dum, tlen, size, text(:ncha), dum, dum )
              y = (axlen - tlen)/2.
              x0 = y*ctheta - d*stheta*stlen + xx
              y0 = y*stheta + d*ctheta*stlen + yy
              call symblk( x0, y0, size, text(:ncha), theta, ncha )
           end if
        end if

        call pltsyn( .false. )

        end
