        subroutine cdash( x, y, ipen, dshlen )
c ***
c ******************************************************************************
c ***
c ***   Zeichnet gestrichelte Linie von aktueller Stiftposition zu Punkt X,Y 
c ***   mit Strichlaenge DSHLEN (typ real!). 
c ***   Zum Plotten wird CPLOT benutzt, der Cliprahmen muss vorher gesetzt
c ***   werden. 
c ***   Der Stift wird nach Durchlaufen von einer Bogenlaenge der Strecke
c ***   DSHLEN gehoben bzw. gesenkt, so dass bei kleinerem Abstand als DSHLEN
c ***   zwischen den Punkten ein kuerzeres Stueck gezeichnet wird. Das Ergebnis
c ***   ist daher in jedem Fall eine Kurve, die aus Strichen der Laenge DSHLEN
c ***   besteht. 
c ***   Daher muss CDASH mit IPEN = 3 initialisiert werden.
c ***
c ***   x,y     : Koordinaten des Punktes [ cm ]
c ***   ipen    : 2 oder 3, bei 3  wird auf den Anfang eines zu strichelnden
c ***             Polygonzuges positioniert; 2 zeichnet.
c ***   dshlen  : Strichlaenge [ cm ]
C ***
c ***                     7-DEC-1989 17:26:17.33
c ***
C ***   Modified:
C ***
C ***   27-MAY-1992 18:52:14.78         ML / UT Austin
C ***                                   Test added for call of atan2 for both
C ***                                   arguments .eq. 0.
C ***   10-JUN-1992 17:46:56.29         ML / UT Austin
C ***                                   Made test work!
C ***    9-JUN-1994 18:29:43.00         ML / IoA  Added crappy emergency brake
C ***                                for loop (no more than 10,000 iterations)
C ***   29-SEP-1994 14:30:40.00         ML / IoA.  Stupid test.  Now really,
C ***                                   really works.  Maybe...
C ***	 3-OCT-1994 21:24:33.00		ML / IoA.  Changed expression for
C ***                                   abs((xpm-x)/x) in test.  Would crash
C ***                                   if either x or y .eq. 0
C ***
c ***
c ******************************************************************************
c ***
        implicit none

C ***
C ***   Arguments
C ***
        real x, y, dshlen
        integer ipen

C ***
C ***   Local variables
C ***
        real xl, yl
        parameter( xl = 200., yl = 200. )

        integer i, iipen
        real alpha, blen, xold, yold, xlp, ylp, xpm, ypm, x0, y0
        real xi, yi, xs, ys, xp, yp

        intrinsic abs, mod, sqrt, sign, sin, cos
        external plot, cplot

        save blen, iipen, xold, yold, xlp, ylp

        data alpha /0./

        if( ipen .eq. 3 ) then
           blen = 0.
           iipen = 2
           xold = x
           yold = y
           xlp = x
           ylp = y
           call plot( x, y, 3 )

           return
        else
           if( x .ne. xold .or. y .ne. yold ) then
              xs = sign( 1., x - xold ) 
              ys = sign( 1., y - yold ) 

              alpha = atan2( y - yold, x - xold )

              xi = dshlen*cos( alpha )
              yi = dshlen*sin( alpha )

              x0 = xold - blen*cos( alpha )
              y0 = yold - blen*sin( alpha )

c             call dwhr( xw, yw, xf, yf )               ! Notbremse bei
c             i = max( 1., (abs(xw/xf - x0) - xl)/xi )  ! Kilometer-
c             i = max( float(i), max( 1., (abs(yw/yf - y0) - yl)/yi ) )! zeichnungen
c             type *, x, y, xold, yold, xw, yw, xf, yf, 
c     >         (abs(xw/xf - x0) - xl)/xi, (abs(yw/yf - y0) - yl)/yi, i

C ***      
C ***         sicherheitshalber, falls jemand zwischen zwei Aufrufen noch Text
C ***         schreibt... schadet nicht bei intelligenten Treibern
C ***      
              call plot( xold, yold, 3 )

              xold = x
              yold = y
C ***
              i = 1
1             continue
                 xp = x0 + i*xi
                 yp = y0 + i*yi
                 if( xs*(x - xp ) .le. 0. ) then
                    xpm = x
                 else
                    xpm = xp
                 end if
                 if( ys*(y - yp ) .le. 0. ) then
                    ypm = y
                 else
                    ypm = yp
                 end if
                 call cplot( xpm, ypm, iipen )
                 blen = blen + sqrt( (xpm-xlp)*(xpm-xlp) + 
     >                               (ypm-ylp)*(ypm-ylp) )
                 if( (blen-dshlen)/dshlen .ge. -1.e-4 ) then
                    iipen = mod( iipen-1, 2 ) + 2
                    blen = 0.
                 end if
                 xlp = xpm
                 ylp = ypm
                 if( abs(xpm-x) .le. 1.e-4*abs(x) .and. 
     >               abs(ypm-y) .le. 1.e-4*abs(y) ) then
                    return
                 end if
                 i = i + 1
              if( i .lt. 10000 ) go to 1        ! emergency brake
           end if
        end if
        end
