      function jd( YY, MM, DD, H, MN, SS )
C ***
C ******************************************************************************
C ***
C ***   Compute modified Julian date.
C ***   Assumes input time is UTC.
C ***   No provision for time zones or DST.
C ***
C ***   YY      > I     Year
C ***   MM      > I     Month
C ***   DD      > I     Day
C ***   H       > I     Hour
C ***   MN      > I     Minute
C ***   SS      > R     Second (with fraction)
C ***
C ***   JD      < D     modified Julian date
C ***
C ***
C ***   $Log: jd.f,v $
C ***   Revision 1.1  2002/12/15 14:05:43  michael
C ***   Initial version.
C ***
C ***
C ******************************************************************************
C ***
      implicit none

      double precision jd
      integer yy, mm, dd, h, mn
      real ss
      
      double precision hr
      real a
      integer j1, ggg, s


      HR = H + MN/60. + SS/3600.
      GGG = 1
      if( YY .lt. 1582 ) GGG = 0
      if( YY .le. 1582 .and. MM .lt. 10 ) GGG = 0
      if( YY .le. 1582 .and. MM .eq. 10 .and. DD .lt. 5 ) GGG = 0
      JD = -1.0d0 * int( 7.*(int( (MM + 9)/12 ) + YY)/4. )
      S = 1
      if( (MM - 9) .lt. 0 ) S = -1
      A = abs(MM - 9)
      J1 = int( YY + S*int(A/7) )
      J1 = -1*int( (int(J1/100) + 1) * 3/4 )
      JD = JD + int( 275*MM/9 ) + DD + GGG*J1
!      JD = JD + 1721027 + 2 * GGG + 367 * YY - 0.5
      JD = JD + 1721027.d0 - 2400000.5d0 + 2*GGG + 367*YY - 0.5

      JD = JD + HR/24.d0

      end
