	function istr( string )
C ***
C ******************************************************************************
C ***
C ***	Converts string with ASCII representation of real number into
C ***	Integer, similar as * format. Does not react to errors the same way as
C ***	the * format!
C ***
C ***	29-MAY-1990 15:46:37.30
C ***   14-AUG-1997 18:49:18.29		ML / Bamberg.  Removed overlapping
C ***                                   strings
C ***
C ******************************************************************************
C ***
        character*(*) string, mant*12, mant1*12, expo*7,
     &                expind(8)*1, form*5
	data expind /'e', 'E', 'q', 'Q', 'd', 'D', '-', '+'/

	l = idx( string )
	if( l .le. 0 ) then
	   write( 6, * ) 'ISTR: String must not be empty!'
	   return
	end if
C ***
C ***	find decimal point
C ***
	ipoint = index( string, '.' )
	ip = ipoint
	if ( ipoint .eq. 0 ) ip = l + 1

	mant = string( :ip-1 )
C ***
C ***	remove possible exponent from mantissa
C ***
	do i = 1, 8
	   iexp = index( mant, expind(i) )
	   if ( iexp .ne. 0 ) go to 1
	end do
1	continue
        if( iexp .gt. 1 ) then
          mant1 = mant( :iexp-1 )	! stupid Fortran
          mant = mant1
        end if
C ***
C ***	find exponent in STRING
C ***
	do i = 1, 8
	   iexp = index( string, expind(i) )
	   if ( iexp .ne. 0 ) go to 2
	end do
2	continue
C ***
C ***	shift number, i.e. multiply by exponent on character basis
C ***
	if( iexp .gt. 1 ) then
	   iexpo = iexp
	   if( string(iexp:iexp) .ne. '+' .and. string(iexp:iexp) .ne.
     >	     '-' ) iexp = iexp + 1
	   expo = string( iexp: )
	   i = idx( expo )
	   if( i .le. 9 ) then
	      write( form, '(''(i'', i1, '')'')' ) idx(expo)
	   else 
	      go to 999
	   end if
           read( expo, form ) iexp
C ***
C ***	   positive exponent
C ***
           j = idx( mant ) + 1
           iexpo = iexpo - 1
	   do i = 1, iexp
              ipi = ip + i
	      if( ipi .le. iexpo ) then
	         mant( j:j ) = string( ipi:ipi )
	      else
                 mant( j:j ) = '0'
	      end if
              j = j + 1
              if( j .gt. len(mant) ) goto 999
	   end do
C ***
C ***	   negative exponent
C ***
           j = j - 1
	   do i = iexp, - 1
              mant( j:j ) = ' '
	      j = j - 1
           end do
           if( mant .eq. ' ' .or. mant .eq. '-' ) mant = '0'
	end if

	i = idx( mant )
	if( i .le. 9 ) then
	   write( form, '(''(i'', i1, '')'')' ) i
	else 
	   write( form, '(''(i'', i2, '')'')' ) i
	end if
        read( mant, form, err = 999 ) istr

	return

999	write( 6, * ) 'ISTR: Input conversion error: ', string

	end
