/*	Inititialization routine for GNU's readline routine.
 *	Sets word delimiters such that files with $ signs will be
 *	completed and ~ expanded.
 *
 *	Modifications:
 *
 *	 8-NOV-1994 17:12:45.00		ML/IoA.  Created.
 *      25-AUG-2001 18:09:12.00		ML/Stegaurach.  Fix for new readline 4.2
 */
#include <stdio.h>
#include <readline/readline.h>
#ifdef __GNUC__
#define readline_init_ readline_init__
#endif
char **my_completion();
void
readline_init_()
{
        rl_basic_word_break_characters = "";
	rl_completer_word_break_characters = rl_basic_word_break_characters;
	rl_parse_and_bind( "set show-all-if-ambiguous on" );
	rl_parse_and_bind( "set expand-tilde on" );

	/* an atempt to get the username completion like in tcsh. */
	rl_attempted_completion_function = (CPPFunction *)my_completion;
}

char **
my_completion( text, start, end )
char *text;
int start, end;
{
	char **matches = (char **)NULL;

/*	for username completion.  doesn't quite work but the readline stuff
 *	seems strange anyway.
 */
	if( start == 0 && *text == '~' ) {
	   if( end == 1 ) {	     /* line is ~ only -- append '/'  */
              *(text+end++) = '/';   /* this should update the line but */
	      *(text+end) = '\0';    /* doesn't (rl_redisplay() doesn't help */
	   } else if( *(text + end - 1) != '/' ) { /* no '/' at end -- */
	      matches =                            /* try username completion */
                 rl_completion_matches( text, rl_username_completion_function );
	   }
	}

	return( matches );

}
