
	character*(*) function vax_date( dt )
C ***
C ******************************************************************************
C ***
C ***	Converts Unix type date format to VAX format
C ***
C ***	DT	>	CHARACTER	Unix date string of type
C ***					Tue Sep 29 12:04:30 1992
C ***	VAX_DATE <	CHARACTER	VAX formatted date string.  Will be
C ***                                   dd-mmm-yy hh:mm:ss if 
C ***					18 <= len(VAX_DATE) <= 19 or
C ***                                   dd-mm-yyyy hh:mm:ss if
C ***					20 <= len(VAX_DATE) <= 22 or
C ***                                   dd-mm-yyyy hh:mm:ss.ss if
C ***					23 <= len(VAX_DATE)
C ***
C ***	29-SEP-1992 12:33:43.00		ML / UT Austin.  First version.
C ***
C ******************************************************************************
C ***
	implicit none
	character*(*) dt

	vax_date = ' '
	vax_date(:2) = dt(9:10)
	vax_date(3:3) = '-'
	vax_date(4:6) = dt(5:7)
	vax_date(7:7) = '-'
	if( len(vax_date) .le. 19 ) then
	   vax_date(8:9) = dt(23:24)
	   vax_date(11:) = dt(12:19)
	else if( len(vax_date) .le. 22 ) then
	   vax_date(8:11) = dt(21:24)
	   vax_date(13:) = dt(12:19)
	else
	   vax_date(8:11) = dt(21:24)
	   vax_date(13:) = dt(12:19)//'.00'
	end if

	end
