	subroutine get_image_id( iname, idate )
C ***
C ******************************************************************************
C ***
C ***	Crude Unix approximations for accessing linker information in VMS image
C ***
C ***	INAME	<	CHARACTER	Name of image; actually name of current
C ***                                   disk file -- Unix can't do it right
C ***	IDATE	<	CHARACTER	Date image was linked; actually last
C ***                                   modification date of disk file -- Unix
C ***                                   can't do it right
C ***
C ***	29-SEP-1992 14:02:51.00		ML / UT Austin.  First version
C ***   21-APR-1997 02:48:01.00         ML / Bamberg.  Linux version.
C ***    1-APR-2001 18:19:20.00		ML / Stegaurach.  st(9) -> st(10) as
C ***					per original comment.  For Cygwin.
C ***					Should be correct for Solaris as well
C ***					but not checked yet.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	character*(*) iname, idate


C ***
C ***	Functions
C ***
        character ctime*24, vax_date*23
        integer stat

C ***
C ***	Local variables
C ***
!	structure /stat/
!          integer   st_dev        ! device file resides on */
!          integer   st_ino        ! the file serial number */
!          integer   st_mode       ! file mode */
!          integer   st_nlink      ! number of hard links to the file */
!          integer   st_uid        ! user ID of owner */
!          integer   st_gid        ! group ID of owner */
!          integer   st_rdev       ! the device identifier (special files only)*/
!          integer   st_size       ! total size of file, in bytes */
!          integer   st_atime      ! file last access time */
!          integer   st_mtime      ! file last modify time */
!          integer   st_ctime      ! file last status change time */
!          integer   st_blksize    ! preferred blocksize for file system I/O*/
!          integer   st_blocks     ! actual number of blocks allocated */
!	end structure

!	record /stat/ st
        integer st(13)

	integer i, l
	character*1024 image_name

	call getimagename( image_name, l )

	i = l
	do while( image_name(i:i) .ne. '/' )
	   i = i - 1
	end do

	iname = image_name( i+1:l )

	i = stat( image_name(:l), st )
!	idate = vax_date( ctime( st.st_mtime ) )
!        idate = vax_date( ctime( st(9) ) ) ! this should be st(10) but that 
        idate = vax_date( ctime( st(10) ) ) ! this should be st(10) but that 
					   ! returns st_ctime here on 
					   ! Solaris/g77 (28-NOV-1999 ML)

	end
