	subroutine bfac( depth, k, cfact, bfact )
C ***
C ******************************************************************************
C ***
C ***	Returns departure factors for computing opacity.
C ***
C ***	depth	i >	depth point
C ***	k	i >	number of line
C ***	cfact	r <	(b_low - b_up)*stimem/(1 - stimem)
C ***	bfact	r <	b_up
C ***
C ***	23-FEB-1994 15:27:35.00		ML / IoA
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	integer depth, k
	real cfact, bfact

C ***
C ***	Global Variables
C ***
	include 'LINLTE.INC'
	include 'STRUCT.INC'
	include 'NLTE.INC'
	include 'LINE.INC'

C ***
C ***	Local variables
C ***
	real ex

        if( ifnlte .eq. 1 ) then
           ex = exp( -2.85487E4*theta(depth)/lamk(k) )
           cfact = ( b(depth, low(k)) - b(depth, up(k))*ex )/
     >             ( 1. - ex )
           bfact = b( depth, up(k) )
        else
           cfact = 1.
           bfact = 1.
        end if
         
	end
