	implicit none

	integer in, im
	real f, n, m
	real fij(40,40), a(40,40), gam(40)

	real e, ry, lam, c

	real hyp2f1

	parameter( ry = 109678.758, c = 2.997925e10 )

	f(n,m) = (32.*m**4*n**2*(m - n)**(2*int(m) + 2*int(n) - 4)*
     >           (Hyp2F1(-n, -m + 1., 1., (-4.*n*m)/(m - n)**2)**2 - 
     >            Hyp2F1(-n + 1., -m, 1., (-4.*m*n)/(m - n)**2)**2))/
     >           (3.*(m + n)**(2*int(m) + 2*int(n) + 3))

	e(n) = ry*( 1. - 1./n/n )
	lam(m,n) = 1/( e(n) - e(m) )
	do m = 1., 20.
           im = m
	   do n = m+1., 40.
              in = n
              fij(im,in) = f(m,n)
              a(in,im) = 8.028619e9*m*m/(n*n)*(1./(m*m)-1./(n*n))**2*
     >                   fij(im,in)
	   end do      
	end do
	do in = 2, 40
           gam(in) = 0.
           do im = in-1, 1, -1
              gam(in) = gam(in) + a(in,im)
           end do
           type *, in, gam(in)
	end do
	do im = 1, 20
	   do in = im+1, 40
	      type '(1x, i5, 1x, i5, 1x, 1p, 7g12.5)',
     >             im, in, 1.e8*lam(im,in), fij(im,in), a(in,im),
     >             gam(in) + gam(im),
     >             (gam(in) + gam(im))*c*2.*3.1415926535/
     >             lam(im,in)/lam(im,in)
	   end do      
	   type *
	end do

	end


	function hyp2f1( a, b, c, x )
C ***
C ******************************************************************************
C ***
C ***	Hypergeometric Function.
C ***
C ***	 2-JUN-1994 15:54:16.00
C ***
C ******************************************************************************
C ***
	implicit none
	real a, b, c, x, hyp2f1

	real si
	real i

	si = 1.

	hyp2f1 = si
	i = 0.
	do while( abs(si/hyp2f1) .gt. 1.e-4 )
	   si = si*(a+i)*(b+i)/((i+1)*(c+i))*x
           hyp2f1 = hyp2f1 + si
           i = i + 1.
	end do

	end
