	subroutine get_limits( mode, x, y, cmd, status, speech )
C ***
C ******************************************************************************
C ***
C ***   $Id: get_limits.f,v 1.2 2003/12/05 00:00:22 michael Exp $
C ***
C ***	Select fit limits interactively.  Called from resize.
C ***
C ***	mode	> I	0: initialize routine
C ***			1: print commands
C ***			2: act on cursor commands
C ***	x	> R	x coordinate of key pressed [user coord]
C ***	y	> R	y coordinate of key pressed [user coord]
C ***	cmd	> C	key pressed
C ***	status	< I	return code
C ***	speech	< L	set to .true. if menu needs reprinting
C ***
C ***	22-NOV-1994 11:51:28.00		ML / IoA.  Created.
C ***   16-APR-1997 22:34:51.00         ML / Stegaurach.  SAVE J.
C ***	16-JAN-1998 20:14:14.18		ML / Bamberg.  Return status if
C ***					cmd == 'q' || cmd == 'Q'
C ***    4-DEC-2003 20:14:05.00         ML / Stegaurach.  Adjust prompt format
C ***                                   to match new resize.
C ***
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	integer mode
	real x, y
	character*(*) cmd
	integer status
	logical speech

C ***
C ***	Global variables
C ***
	include 'LINLTE.INC'
	include 'OBS.INC'
	include 'PROFIL.INC'
	include 'MON_CODES.INC'

C ***
C ***	Local variables
C ***
	logical first_point
	integer i, j, k

	save first_point, j


	if( mode .eq. 0 ) then
C ***
C ***	   Initialization
C ***
	   first_point = .true.
	else if( mode .eq. 1 ) then
C ***
C ***	   Print menu
C ***
1          format( a18, 2x, a )
           write( stdout, * ) 
     >       'Specify region to eliminate.'
	   write( stdout, 1 )
     >       'Press  Q', 'to quit and start fitting,'
	   write( stdout, 1 )
     >       'M', 'to mark region to eliminate,'
	   write( stdout, 1 )
     >       'A', 'to abort program;'
	   write( stdout, * )
	else
C ***
C ***	   Act on commands
C ***
C ***	   open LIMITS.DAT, status=new/unknown.  Done in ANALYZE
C ***
           speech = .false.
           if( cmd .eq. 'a' .or. cmd .eq. 'A' ) then
C ***
C ***	      Abort fitting
C ***
              status = end_fit
           else if( cmd .eq. 'm' .or. cmd .eq. 'M' ) then
C ***
C ***	      get fit ranges
C ***
              if( first_point ) then
                 j = 1
                 do while( lamobs(j) .lt. x .and. j .lt. mobs )
                    j = j + 1
                 end do
                 fit_mask( j ) = 0.	! to make plotout(2) work
                 call plotout( 2 )	! slightly inefficient
	      else
                 k = 1
                 do while( lamobs(k) .lt. x .and. k .lt. mobs )
                    k = k + 1
                 end do

                 i = j
                 j = min( i, k )
                 k = max( i, k )
                 do j = j, k
                    fit_mask(j) = 0.
                 end do

                 call plotout( 2 )	! slightly inefficient

              end if
	      first_point = .not.first_point
	      status = 0
           else if( cmd .eq. 'q' .or. cmd .eq. 'Q' ) then
	      status = cont_fit
           end if
        end if	!mode
	end
