        function h( a, v )
C ***
C ***	VOIGT FUNCTION
C ***
	implicit none

C ***
C ***	Arguments
C ***
	real h, a, v

C ***
C ***	Local variables
C ***
        logical q
	real aa, vv, u, uu, ho, h1, h2, hh1, hh2, hh3, hh4

        vv = v*v
        q = a .lt. 0.2
        if( q .and. v .gt. 5. ) then
           h = ( (2.12/vv + .8463)/vv + .5642 )*a/vv

        else if( .not. q .and. (a .gt. 1.4 .or. a + v .gt. 3.2) ) then
           aa = a*a
           u = ( aa + vv )*1.4142
           uu = u*u
           h = ( (((aa - 10.*vv)*aa*3. + 15.*vv*vv)/uu + 3.*vv - aa)/
     >         uu + 1. )*a*.79788/u

        else
           ho = exp( -vv )
           h2 = ( 1. - 2.*vv )*ho
           if( v .gt. 2.4 ) then
              h1 = ( (-.0032783*vv + .0429913*v - .188326)*vv +
     >             .278712*v + .55415 )/( vv - 1.5 )

           else if( v .gt. 1.3 ) then
              h1 = ( -.220416*vv + 1.989196*v - 6.61487 )*vv +
     >             9.39456*v - 4.4848

           else
              h1 = ( .42139*vv - 2.34358*v + 3.28868 )*vv - .15517*v -
     >             1.1247
           end if

           if( q ) then
              h = ( h2*a + h1 )*a + ho

           else
              hh1 = h1 + ho*1.12838
              hh2 = h2 + hh1*1.12838 - ho
              hh3 = ( 1. - h2 )*.37613 - hh1*.66667*vv + hh2*1.12838
              hh4 = ( 3.*hh3 - hh1 )*.37613 + ho*.66667*vv*vv
              h = ( (((hh4*a + hh3)*a + hh2)*a + hh1)*a + ho )*
     >            ( ((-.122727278*a + .532770573)*a - .96284325)*a +
     >            .979895032 )
           end if

        end if

        end
