	function he1( k )
C ***
C ******************************************************************************
C ***
C ***	Select profile for He I lines.
C ***   No guarantee is made that profile is available.
C ***	This must not be called if current line is not He I.
C ***
C ***	k	> I  number of blend line
C ***	he1	< I  PHEBCSS: BCSS wanted
C ***		     PHEGRIEM: Griem tables wanted  (see linehe1.for)
C ***		     more can be added
C ***
C ***		     Voigt profiles are used with Griem tables but
C ***                with a wavelength shift.  The shift is what requires a
C ***		     special profile function until we implement Stark shifts
C ***                in general.
C ***
C ***	30-APR-1997 16:21:57.31		ML / Bamberg.  Created.
C ***    8-MAY-1997 14:48:43.00		ML / Stegaurach.  C4LG.eq.-2 for Griem.
C ***                                   C4LG .eq. -3 for BCSS
C ***	14-SEP-1997 17:48:25.00		ML / Stegaurach.  New profile selection
C ***	22-OCT-1997 15:08:42.78		ML / Bamberg.  Beauchamp tables.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	integer k
	integer he1

C ***
C ***	Global variables
C ***
	include 'LINLTE.INC'
	include 'LINDAT.INC'
	include 'LINE.INC'


	if( namk(k) .eq. 200 ) then
          if( c4lg(k) .eq. -4. ) then
	      he1 = PHEBWB
          else if( c4lg(k) .eq. -3. ) then
	      he1 = PHEBCSS		! BCSS
           else if( c4lg(k) .eq. -2. ) then
	      he1 = PHEGRIEM		! Griem
	   else
	      he1 = PVOIGT
	   end if
	else
           write( stdout, * ) 'LINLTE>>  Illegal call of HE1.'
	   call exit
	end if

	end
