	function hebwb( k )
C ***
C ******************************************************************************
C ***
C ***	Return index into BWB He I broadening table for line #k.
C ***	Assumes BWB.DAT has been read.
C ***
C ***	k	> i	Line number
C ***	hebwb	< i	Index into BWB table
C ***			-1: no BWB table available for this line
C ***			-2: not a He I line
C ***
C ***
C ***	22-OCT-1997 15:38:51.03		ML / Bamberg.  Made.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	integer k
	integer hebwb

C ***
C ***	Global variables
C ***
	include 'LINLTE.INC'
	include 'LINE.INC'
	include 'LINDAT.INC'
	include 'BWB.INC'


C ***
C ***	Local variables
C ***
	integer i
	logical bwb_open

	save bwb_open
	data bwb_open /.false./

C ***
C ***	Code
C ***
	if( namk(k) .eq. 200 ) then
	   if( .not.bwb_open ) then
	      call inibwb
	      bwb_open = .true.
           end if
	   do i = 1, nbwb
	      if( abs(lamk(k) - lam0bwb(i)) .lt. 1. ) then
	         hebwb = i
	         go to 1
	      end if
	   end do
           hebwb = -1
	else
	   hebwb = -2
	end if

1	continue
	end
