	function mon( )
C ***
C ******************************************************************************
C ***
C ***	Monitor function to choose different options after a fit has been
C ***	made.
C ***
C ***	mon	i <	0: resume fitting, .ne. 0: finish
C ***
C ***	Modifications:
C ***
C ***	23-SEP-1994 19:58:50.00		ML / IoA.  Created
C ***	28-SEP-1994 18:49:06.00		ML / IoA.  Added refit option
C ***	22-NOV-1994 12:35:26.00		ML / IoA.  Updated resize call
C ***	 8-MAY-1996 18:08:55.97		ML / Bamberg.  Added LINLTE>> prompt.
C ***                                   Uses $ format, might not be portable.
C ***   21-APR-1997 13:37:33.00         ML / Bamberg.  Funky Exit prompt toy...
C ***	18-DEC-1997 17:22:12.00		ML / Bamberg.  iflimits .eq. 3
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	integer mon

C ***
C ***	Global variables
C ***
	include 'LINLTE.INC'
	include 'IF.INC'
	include 'CALCUL.INC'
	include 'MON_CODES.INC'	
	include 'ERASURE.INC'

C ***
C ***	Local variables
C ***
	integer status
	logical done
	character cmd

C ***
C ***	Functions
C ***
	external null, eofexit
	character*6 eofchar

	done = .false.
        do while( .not.done )
	   write( stdout, * ) 'Type return for new iteration, '
           if( itv .eq. 2 ) then
	      write( stdout, * ) '     R      to resize plot,'
           end if
           if( iflimits .eq. 1 ) then
	      write( stdout, * ) '     A      to fit again from ',
     >                           'current solution,'
           end if
	   write( stdout, * ) '     ', eofchar(), ' to exit this fit.'
           write( stdout, '(a,$)' ) ' LINLTE>> '
	   read( 5, '(a)', iostat = status ) cmd
           if( status .lt. 0 ) then
C ***
C ***	      user pressed EOF
C ***
              call eofexit	! Some funny prompt
              status = end_fit
              done = .true.
	   else if( (cmd .eq. 'r' .or. cmd .eq. 'R') .and.
     >              itv .eq. 2 ) then
C ***
C ***	      resize plot
C ***
	      call resize( null, status )
              call tplane( noErase, Single_plane ) ! resize leaves us in grafix
              status = resize_fit
           else if( (cmd .eq. 'a' .or. cmd .eq. 'A') .and.
     >              (iflimits .eq. 1 .or. iflimits .eq. 3) ) then
C ***
C ***	      fit again
C ***
              status = again_fit
              done = .true.
	   else
C ***
C ***         just continue
C ***
              write( stdout, * ) 'Doing another iteration...'
              status  = cont_fit
              done = .true.
	   end if
	end do

	mon = status
	end                         
