* Program to fit the correlation peak
	SUBROUTINE PEAKFIT(NPT,VELOCITY,VMIN,VMAX,CFN,CENTER,
     :                                           WIDTH,A,ERROR)
*
* History:  Original version J. Tonry.
* Modified: KS 22-SEP-1983. VMIN and VMAX made parameters, test
*           that fit is to at least 3 pixels added.

	REAL*4 VELOCITY(NPT), CFN(NPT)
	REAL*4 LPOLY, SCALE(2)
	REAL*8 A(3)
	LOGICAL*1 ERROR
	PARAMETER( PEAKFRAC = .75 )

	ERROR = .FALSE.
	CMAX = 0
	DO I = .1*NPT,.9*NPT
	    IF(VELOCITY(I).GT.VMIN.AND.VELOCITY(I).LT.VMAX) THEN
	    	IF(CFN(I).GT.CMAX) THEN
	    	    CMAX = CFN(I)
	    	    IMAX = I
	    	END IF	    
	    END IF
	END DO
	SCALE(1) = VELOCITY(IMAX-2)
	SCALE(2) = VELOCITY(IMAX+2)
	CALL FITLPOLY(5,VELOCITY(IMAX-2),CFN(IMAX-2),SCALE,3,A)
	CALL POLYC(3,SCALE,A,A)
	CALL PARAMS(A,V0,PEAK,WIDTH)

	IL = 0
	IR = 0
	NSEARCH = 50
	I = 1
	DO WHILE((IL.EQ.0.OR.IR.EQ.0).AND.I.LT.NSEARCH)
	    IF(CFN(IMAX+I).LE.PEAK*PEAKFRAC.AND.IR.EQ.0) THEN
	    	IR = IMAX+I
	    END IF
	    IF(CFN(IMAX-I).LE.PEAK*PEAKFRAC.AND.IL.EQ.0) THEN
	    	IL = IMAX-I
	    END IF
	    I = I + 1
	END DO

C                            (test for at least 3 pixels added KS)
	IF(IL.EQ.0 .OR. IR.EQ.0 .OR. (IR-IL).LT.4) THEN
	    IL = IMAX - 2
	    IR = IMAX + 2
	END IF
	SCALE(1) = VELOCITY(IL)
	SCALE(2) = VELOCITY(IR)
	CALL FITLPOLY(IR-IL+1,VELOCITY(IL),CFN(IL),SCALE,3,A)
	CALL POLYC(3,SCALE,A,A)
	CALL PARAMS(A,VL,HL,WL)

	SCALE(1) = VELOCITY(IL+1)
	SCALE(2) = VELOCITY(IR-1)
	CALL FITLPOLY(IR-IL-1,VELOCITY(IL+1),CFN(IL+1),SCALE,3,A)
	CALL POLYC(3,SCALE,A,A)
	CALL PARAMS(A,VU,HU,WU)
	AVHL = .5*(CFN(IL) + CFN(IR))
	AVHU = .5*(CFN(IL+1) + CFN(IR-1))
	FRAC = (PEAK*PEAKFRAC - AVHL) / (AVHU - AVHL)

	CENTER = FRAC * VU + (1-FRAC) * VL
	WIDTH = FRAC * WU + (1-FRAC) * WL

	RETURN
	END

	SUBROUTINE PARAMS(A,CENTER,HEIGHT,WIDTH)
* Routine to convert parabola polynomial coefficients to height, center, width
	REAL*8 A(3)
	CENTER = -A(2) / (2*A(3))
	HEIGHT = A(1) - A(2)*A(2) / (4*A(3))
	WIDTH = -2*HEIGHT / A(3)
	IF(WIDTH.GE.0) THEN
	    WIDTH = SQRT(WIDTH)
	ELSE
	    WIDTH = -SQRT(-WIDTH)
	END IF
	RETURN
	END
