	function selprof( k )
C ***
C ******************************************************************************
C ***
C ***   Select profile type for spectrum line.
C ***
C ***	k	> I	number of blend line
C ***	selprof < I	profile type.  Types are defined in LINE.INC.
C ***
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	integer k
	integer selprof

C ***
C ***	Global variables
C ***
	include 'LINLTE.INC'
	include 'LINDAT.INC'
	include 'LINE.INC'

C ***
C ***	Functions
C ***
	integer he1, he2
	external he1, he2


C ***
C ***	Code
C ***

	if( namk(k) .gt. 201 ) then
C ***
C ***	   catch most common case first:
C ***      Metal lines
C ***
	   selprof = PVOIGT	! Voigt function

	else if( namk(k) .eq. 100 ) then
C ***
C ***	   Hydrogen
C ***
	   if( drrca(k) .ge. 0. ) then
	      selprof = PHY	! old simple H profiles
	   else
	      selprof = PVCS	! VCS tables
	   end if
	else if( namk(k) .eq. 102 ) then
C ***
C ***	   more Hydrogen
C ***
	   selprof = PHOP	! fake catch-all H opacity
	else if( namk(k) .eq. 200 ) then
C ***
C ***	   He I
C ***
	   selprof = he1( k )
	else if( namk(k) .eq. 201 ) then
C ***
C ***	   He II
C ***
	   selprof = he2(k)
	else
C ***
C ***	   just in case...
C ***
	   selprof = PVOIGT
	end if

	end
