	subroutine phard       
C ***
C ******************************************************************************
C ***
C ***	Print hardcopy.  This is a plot package dependent function.
C ***
C ***	Kalhoff version.
C ***	Accepts env var LINLTE_PRINT which must be valid Fortran format
C ***	for constructing print command.  Default: ('PRINT/NOTIFY ', a)
C ***
C ***	Modifications:
C ***
C ***	25-JAN-1996 14:08:36.04		ML / IoA.  Created.
C ***
C ******************************************************************************
C ***
	implicit none

	include '($clidef)'
	include 'LINLTE.INC'
	character*255 file_name, format, command

	integer fil, fol
	integer status, lib$spawn

	call post_file_name( file_name, fil )

	call lib$get_symbol( 'LINLTE_PRINT', format, fol )
	if( fol .le. 0 ) then
	   format = '(''PRINT/NOTIFY '', a)'
           fol = 20
	end if
	command = ' '
	write( command, format(:fol) ) file_name(:fil)
        status = lib$spawn( command, , ,
     >                      cli$m_nowait .and. cli$m_nokeypad )
	if( .not.status ) then
	   write( stdout, * ) 'LINLTE>> Couldn''t print.'
	   call lib$signal( %val(status) )
	end if

	end
	subroutine post_file_name( file_name, length )
C ***
C ***	Return basename of postscript file used by Mongo.
C ***
C ***	file_name	< C 	postscript file name
C ***	length		< I	# of characters in file_name
C ***
	implicit none

	character*(*) file_name
	integer length

	include '($jpidef)'
	integer i, ierr
	integer ex_fname, lib$getjpi

	
        ierr = lib$getjpi( jpi$_imagname,,,,file_name, i )
	ierr = ex_fname( file_name, file_name, length )
	file_name(length+1:) = '.ps'
	length = length + 3

	end
	function ex_fname( full_spec, name, length )
C ***
C ******************************************************************************
C ***
C ***	Returns file _name_ from full file specification.  Full_spec must
C ***	be a complete file spec or unpredicted behavior results.
C ***
C ******************************************************************************
C ***
	implicit none

	character*(*) full_spec, name
	integer ex_fname, length

	include '($fscndef)'

	structure /item_2/
           union
           map
	      integer*2 length
	      integer*2 code
	      integer address
	   end map
	   map
	      integer*4 end /0/
	   end map
	   end union
	end structure

	integer i, sys$filescan
	record /item_2/ item(2)

	item(1).code = fscn$_name

	ex_fname = sys$filescan( full_spec, item, , , )
        i = item(1).address - %loc(full_spec) + 1
	name = full_spec(i:i+item(1).length-1)
	length = item(1).length

	end
