	subroutine ploto( x, y, screen, paper )
C ***
C ******************************************************************************
C ***
C ***	Opens plot device.  System dependent. UNIX/mongo Version
C ***
C ***	x, y   (REAL)    >  Dimension of plot surface in cm
C ***	screen (LOGICAL) >  Open terminal device
C ***	paper  (LOGICAL) >  Open paper device
C ***
C ***	Assumes it is impossible to write to screen and paper at the same time.
C ***
C ***	Shitix/mongo version accepts environment variables LINLTE_PAPER and
C ***	LINLTE_SCREEN to define graphics device, e.g. 13, or 8, i.e.,
C ***	everything Mongo PLOTS supports.
C ***	Defaults to unit -2 (post script) for PAPER and 13 for screen.
C ***
C ***	11-JUN-1992 21:29:22.00
C ***	21-NOV-1994 16:56:28.00		ML / IoA.  Added LINLTE_SCALE to scale
C ***					paper plot.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	logical screen, paper
	real x, y

C ***
C ***	Global variables
C ***
	include 'LINLTE.INC'

C ***
C ***	Local variables
C ***
	character*255 symbol
	character sym_name(3)*(13)
	data sym_name /'LINLTE_PAPER', 'LINLTE_SCREEN', 'LINLTE_SCALE'/
	integer def_devs(2), devs(2)
	data def_devs /-2, 13/
	integer i, ist, length

	integer idev, paper_dev, screen_dev
	equivalence ( paper_dev, devs(1) ), ( screen_dev, devs(2) )
	real scale, def_scale
	data def_scale /1./

C ***
C ***	Functions
C ***
	integer idx


C ***
C ***	Get device units for paper (i=1) and screen (i=2), and
C ***	scale factor (i=3)
C ***
	do i = 1, 3
           call getenv( sym_name(i), symbol )
           if( symbol .ne. ' ' ) then
C ***      
C ***         from symbol
C ***
              length = idx( symbol )
              if( i .lt. 3 ) then
                 read( symbol(:length), *, iostat = ist ) devs(i)
              else
                 read( symbol(:length), *, iostat = ist ) scale
              end if
              if( ist .ne. 0 ) then
                 write( stdout, * )
     >             'LINLTE>> ERROR: Can''t read symbol ', 
     >                                               sym_name(i), ':'
                 write( stdout, * )
     >             '                ', symbol(:length)
                 write( stdout, * )
     >             '                Fix assignment to be consistent ',
     >                                                    'with PLOTS!'
                 call exit
              end if
           else
C ***      
C ***         default
C ***      
              if( i .lt. 3 ) then
                 devs(i) = def_devs(i)
	      else
                 scale = def_scale
              end if

           end if

	end do
     
	if( paper ) then
	   idev = paper_dev
	else if( screen ) then
	   idev = screen_dev
	   call plot5( 1., 0., 5 )
	else
	   stop 'Never taken'
	end if

	
	call plots( 1, idev, x*scale, y*scale )
	call factor( scale )

	end
