        PROGRAM ABUSCA
C ***
C ******************************************************************************
C ***
C ***   SKALIERT HAEUFIGKEITEN.
C ***
C ***   INPUT:  ZU SKALIERENDE HAEUFIGKEITEN, ABU.DAT-FORMAT.
C ***           DEFAULT: METEORITISCHE HAEUFIGKEIT (IST FEST VERDRAHTET),
C ***           IST LEERE KARTE AUF DER CRAY, <CR> AUF PDP10
C ***
C ***   OUTPUT: SCAL.ABU (PDP10) BZW. SCALABU (CRAY)
C ***
C ***
C ***   05-NOV-87 12:12:31
C ***	25-APR-1996 19:47:00.78		ML / Bamberg.  Added Boron etc.
C ***	 9-MAR-1998 15:07:01.63		ML / Bamberg.  Interactive version
C ***                                   (PDP10 lines)
C ***   10-JUN-2004 23:53:16.00         ML / Stegaurach.  Ga, Ge, Sn, Pb added
C ***                                   from
C http://astronomy.sierra.cc.ca.us/Resources/Reference/Elements%20and%20Solar%20System%20Abundances%20ap11.htm
C ***                                   (Grevesse 1994).
C ***   25-JUL-2004 19:11.00.00         ML / Stegaurach.  Updated all abundances
C ***                                   to Grevess & Sauval 1998, Space Science
C ***                                   Reviews, 85, 161.  All meteoritic unless
C ***                                   element not available.
C ***
C ***   $Id: abuscal.f,v 1.3 2004/07/25 18:41:48 michael Exp $
C ***
C ******************************************************************************
C ***
        CHARACTER FILNAM*27, EXT*3
        PARAMETER( NELEM = 102, EXT = 'ABU' )
        DIMENSION NAMI(NELEM), WTI(NELEM), ABUI(NELEM)

        DATA MAI /45/
        DATA (NAMI(I), WTI(I), ABUI(I), I = 1, 45)/
     >    100,   1.0080, 12.000,
     >    200,   4.0026, 10.930,
     >    300,   6.9410,  3.310,
     >    400,   9.0122,  1.420,
     >    500,  10.8110,  2.790,
     >    600,  12.0111,  8.520,
     >    700,  14.0067,  7.920,
     >    800,  15.9994,  8.830,
     >   1000,  20.1790,  8.080,
     >   1100,  22.9898,  6.320,
     >   1200,  24.3050,  7.580,
     >   1300,  26.9815,  6.430,
     >   1400,  28.0860,  7.560,
     >   1500,  30.9738,  5.560,
     >   1600,  32.0600,  7.200,
     >   1800,  39.9480,  6.400,
     >   1900,  39.1020,  5.130,
     >   2000,  40.0800,  6.350,
     >   2100,  44.9560,  3.100,
     >   2200,  47.9000,  4.940,
     >   2300,  50.9414,  4.020,
     >   2400,  51.9960,  5.690,
     >   2500,  54.9380,  5.530,
     >   2600,  55.8470,  7.500,
     >   2700,  58.9332,  4.910,
     >   2800,  58.7100,  6.250,
     >   2900,  63.5460,  4.290,
     >   3000,  65.3700,  4.670,
     >   3100,  69.7230,  3.130,
     >   3200,  72.6100,  3.630,
     >   3700,  85.4700,  2.410,
     >   3800,  87.6200,  2.920,
     >   3900,  88.9059,  2.230,
     >   4000,  91.2200,  2.610,
     >   5000, 118.7100,  2.140,
     >   5600, 137.3400,  2.220,
     >   5700, 138.9060,  1.220,
     >   5800, 140.1200,  1.630,
     >   6000, 144.2400,  1.490,
     >   6200, 150.4000,  0.980,
     >   6300, 151.9600,  0.550,
     >   7400, 183.8500,  0.690,
     >   7600, 190.2000,  1.390,
     >   8200, 207.2000,  2.060,
     >   9000, 232.0380,  0.090 /

       CALL PRGID( 'ABUSCA', '25-JUL-2004 19:16:00.00' )                ! PDP10
       WRITE( 6, '(/,2A,$)' ), ' ABUNDANCE FILE (<CR>: SOLAR ',
     >        'COMPOSITION) ?  '
C       WRITE( 5, '(A,$)' ), '0ABUNDANCE FILE ( <CR>: SOLAR COMPOSITION ! PDP10
C     >) /.ABU/ ?  '                                                    ! PDP10
C       ACCEPT '(Q,A)', LENG, FILNAM                                    ! PDP10
C       IEXT = INDEX( FILNAM, '.')                                      ! PDP10
C       IPPN = INDEX( FILNAM, '[' )                                     ! PDP10
C       IF( IEXT .EQ. 0 ) THEN                                          ! PDP10
C          IF( IPPN .EQ. 0 ) THEN                                       ! PDP10
C             FILNAM(LENG+1:) = '.'//EXT                                ! PDP10
C          ELSE                                                         ! PDP10
C             FILNAM = FILNAM(:IPPN-1)//'.'//EXT//FILNAM(IPPN:)         ! PDP10
C          END IF                                                       ! PDP10
C       END IF                                                          ! PDP10
        READ( 5, '(A)', end = 99 ) FILNAM                               ! CRAY
C       TYPE '(A,$)', '0SCALING FACTOR (LOGARITHM) ?  '                 ! PDP10
C       ACCEPT *, SCAL                                                  ! PDP10
        write( 6, '(/,A,$)' ) ' SCALING FACTOR (LOGARITHM) ?  '
        READ( 5, *, end = 99 ) SCAL                                     ! CRAY
C       IF( LENG .NE. 0 ) THEN                                          ! PDP10
        IF( FILNAM .NE. ' ' ) THEN                                      ! CRAY
           OPEN( 31, FILE = FILNAM, STATUS = 'OLD' )
           REWIND 31
           READ( 31, '(I7)' ) MAI
           IF( MAI .GT. NELEM ) THEN
C             WRITE( 5, * ) '?ASCTME TOO MANY ELEMENTS, NOT MORE THAN', ! PDP10
              WRITE( 6, * ) '?ASCTME TOO MANY ELEMENTS, NOT MORE THAN', ! CRAY
     >          NELEM
              STOP
           END IF
           DO 1 I = 1, MAI
              READ( 31, '(I7, F9.4, F7.3)' ) NAMI(I), WTI(I), ABUI(I)
1          CONTINUE
           CLOSE( 31 )
        END IF
C       OPEN( 32, FILE = 'SCAL.ABU' )                                   ! PDP10
        OPEN( 32, FILE = 'SCALABU', status = 'new', iostat = ist )      ! CRAY
        if( ist .ne. 0 ) 
     >    OPEN( 32, FILE = 'SCALABU', status = 'old' )                  ! CRAY
        REWIND 32
        WRITE( 32, '(I7)' ) MAI
        DO 2 I = 1, 2
           WRITE( 32, '(I7, F9.4, F7.3)' ) NAMI(I), WTI(I), ABUI(I)
2       CONTINUE
        DO 3 I = 3, MAI
           WRITE( 32, '(I7, F9.4, F7.3)' ) NAMI(I), WTI(I), ABUI(I)+SCAL
3       CONTINUE
        CLOSE( 32 )
99	continue
        END
