        subroutine ac1bf_nlte( alam, m, alamm, em, gm, am, t )
C       C I LEVEL M:EDGE ALAMM,ENERGY EM,WEIGHT GM,B-F CROSS-SECTION AM
C       HOFSAESS(1979):STF
C       EXCITED LEVELS M>1 SHORTWARD OF EDGE HYDROGENIC
C ***   17-FEB-1995 11:48:03.00         ML / IoA.  NLTE version to read in
C ***                                   departure coefficients for C.
C ***		This only works in combination with RATES and if called
C ***		from special opalam version.  Ordinary OPALAM has no notion
C ***		of depth points which makes selection of correct departure
C ***		impossible.
        implicit none

C ***
C ***   Arguments
C ***
        real alam, alamm, em, gm, am, t
        integer m

	include 'OP.INC'
	include 'MOD_SIZ.INC'
	include 'MODEL_RA.INC'

        real al( 13 ), aa( 13 ), ab( 13 ), ac( 13 ), al1( 23 ),
     >       aa1( 23 )
        real b( m_depth, m_levels + 1 ), a, x
        character*4 lab(13), label( m_levels + 1 ), ident*132
        integer id, k, l, lmax
        integer depart
        parameter( depart = 34 )
        logical first

        save first, lmax

	data lab /'2P3P', '2P1D', '2P1S', '2P5S', '3S3P', '3S1P',
     >            '2P3D', '2P3D', '3P1P', '3P3D', '3P3S', '3P3P',
     >            '3P1D'/
        data ( al(l), l = 1, 13 )/1100., 1239., 1444., 998., 3280.,
     >       3459., 1433., 983., 4552., 4733., 4965., 5127., 5472./
        data ( aa(l), l = 1, 13 )/1.395E-17, 1.478E-17, 1.733E-17,
     >       1.313E-17, 1.455E-19, 1.068E-18, 1.203E-17, 7.269E-18,
     >       2.829E-18, 1.764E-18, 2.257E-18, 2.436E-18, 3.848E-18/
        data ( ab(l), l = 1, 13 )/0.00, 1.26, 2.68, 4.18, 7.49, 7.68,
     >       7.95, 7.95, 8.54, 8.64, 8.77, 8.85, 9.00/
        data ( ac(l), l = 1, 13 )/9., 5., 1., 5., 9., 3., 15., 15., 3.,
     >       15., 3., 9., 5./
        data ( al1(l), l = 1, 23 )/1100., 1087., 1038., 982., 886.,
     >       807., 742., 686., 638., 596., 559., 527., 498., 449., 409.,
     >       375., 346., 322., 300., 282., 265., 251., 238./
        data ( aa1(l), l = 1, 23 )/1.395E-17, 1.396E-17, 1.390E-17,
     >       1.370E-17, 1.289E-17, 1.175E-17, 1.054E-17, 9.380E-18,
     >       8.336E-18, 7.385E-18, 6.567E-18, 5.849E-18, 5.241E-18,
     >       4.223E-18, 3.420E-18, 2.833E-18, 2.347E-18, 1.992E-18,
     >       1.683E-18, 1.436E-18, 1.239E-18, 1.075E-18, 9.534E-19/
        data first/.true./

        if( first ) then
           first = .false.
           open ( depart, file = 'DEPART.C', status = 'old' )
           read( depart, FMT = '(I4, 2x, a)' ) lmax, ident
           read( depart, FMT = '(5(1X,A4))' ) ( label(l), l = 1, lmax )
           read( depart, FMT = '(I8)' )id
           if( id .ne. 600 ) then
              write( 6, FMT = * ) 'AC1BF>> No carbon in DEPART.C: ', id
              call exit( 1 )
           end if
           do 1 id = 1, ndepth
              read( depart, FMT = '(5E15.7)' )( b(id, l), l = 1, lmax )
1          continue
           close( depart )
        end if
        if( m .lt. 1 .or. m .gt. 13 ) then
           em = 0.
           gm = 0.
           am = 0.
           alamm = 0.
        else
           alamm = al( m )
           em = ab( m )
           gm = ac( m )
           am = 0.
           if( alam .le. alamm ) then
              if( m .eq. 1 ) then
C ***
C ***   	 If ALAM not found, L was never set!
C ***   	 Changed 14-NOV-1990 22:06:04.77, M. Lemke
C ***
                 l = 22
                 do 2 k = 1, 22
                    if( alam .le. al1(k) .and.
     >                  alam .ge. al1(k + 1) )l = k
2                continue
                 a = aa1( l ) + ( aa1(l + 1) - aa1(l) )*
     >               ( alam - al1(l) )/( al1(l + 1) - al1(l) )
                 am = a/athoms
              else
                 x = alam/alamm
                 am = aa( m )/athoms*x*x*x
              end if
              do id = 1, ndepth
	         if( temp(id) .eq. t ) then
                    do l = 1, lmax
	               if( label(l) .eq. lab(m) ) then
                           am = am*b(id,l)
                           go to 3
                       end if
                    end do
                    write( 6, * ) 'AC1BF>> No departure for level ',
     >                            lab(m), ' LTE assumed'
	            go to 3
		 end if
	      end do
              write( 6, * ) 'AC1BF>> Can''t find departure for ',
     >                      t, 'K, LTE assumed'
3	      continue
           end if
        end if
        end
                
