      PROGRAM ATM
C ***
C ******************************************************************************
C ***
C ***   ATMOS  KIEL 1981  H.HOLWEGER,M.STEFFEN,W.STEENBOCK
C ***
C ***   Aenderung 27-APR-1988 12:57:41 M. Lemke:
C ***
C ***   Anpassung an VAX, Opazitaets-Plotoutput
C ***
C ***	29-MAR-1994 22:01:12.00		ML / IoA  Version to write all 4 
C ***					ionization stages to ATM
C ***	25-APR-1996 18:36:44.95		ML / Bamberg.  5 ion stage version.
C ***                                   Do away with old ATM -- always
C ***                                   print all ion statges.
C ***   10-JUN-2004 22:15:00.00         ML / Stegaurach.  Parameterize 
C ***                                   output channel #6 as stdout
C ***
C ***   $Id: atm.f,v 1.2 2004/06/13 21:39:01 michael Exp $
C ***
C ******************************************************************************
C ***
      include 'OPALION.INC'
        INCLUDE 'K.INC'
        INCLUDE 'OP.INC'
      COMMON/CONST/ALN10,BOLTZK,HPLANC,CLIGHT
      COMMON/OUT/OLAM(40)
        INCLUDE 'INT.INC'
        INCLUDE 'RE.INC'
      COMMON/ARL/TAU(70),THETA(70),XI(70),ALGK(70),ALGS(70),ALTAU(70),
     *ALTHET(70),ALXI(70),R(70),DENSNC(70),ALP(3,70)
      DIMENSION ABUI(max_elem)
      DIMENSION ZE(max_ion,70),ALKL(40,70),ALSL(40,70)
      LOGICAL PRINT
C ***
      ALN10=LOG(10.)
      BOLTZK=1.38062E-16
      HPLANC=6.62620E-27
      CLIGHT=2.997925E+10
C ***
C *** INPUT COMPOSITION
C ***
      OPEN(UNIT=1,FILE='ABU', STATUS = 'OLD')
      REWIND 1
      READ(1,901) MAI
      AS=0.
      DO 1 I=1,MAI
         READ(1,901) NAMI(I),WTI(I),A
         ABUI(I)=A
         A1=EXP(ALN10*A)
         FRACI(I)=A1
         AS=AS+A1
1     CONTINUE
      REWIND 1
      CLOSE(1)
      DO 3 I=1,MAI
         FRACI(I)=FRACI(I)/AS
3     CONTINUE
      AVEMAT=0.
      DO 4 I=1,MAI
         AVEMAT=AVEMAT+WTI(I)*FRACI(I)
4     CONTINUE
      AVEMAT=AVEMAT*1.660531E-24
C ***
      OPEN(UNIT=1,FILE='ATM', STATUS = 'UNKNOWN')
      REWIND 1
C ***
C *** AT FORMATTING AND PRINTING
C ***
901   FORMAT(I7,F9.4,F7.3,1PE10.3)
902   FORMAT(13H1AT KIEL 1981)
903   FORMAT(///20H INPUT COMPOSITION (,I3,11H ELEMENTS)://
     *31H ELEMENT    WTI    ABUI   FRACI/)
      WRITE(stdout,902)
      WRITE(stdout,903) MAI
      WRITE(1,901) MAI
      DO 2 I=1,MAI
         WRITE(stdout,901)NAMI(I),WTI(I),ABUI(I),FRACI(I)
         WRITE(1,901)NAMI(I),WTI(I),ABUI(I)
2     CONTINUE
C ***
      WRITE(stdout,900)AVEMAT
900   FORMAT(/1X,9H  AVEMAT=,1PE12.5)
C ***
      CALL PTAU
C ***
C *** COMPUTING PARTICLE CONCENTRATIONS AND KAPPA/SIGMA VALUES
C ***
      M=MOD(LPR1,LPRD)
      DO 351 L=1,LMAX
         TEMP=5040./THETA(L)
         PELE=EXP(ALN10*ALP(3,L))
         PRINT = L.GE.LPR1.AND.L.LE.LPR2.AND.MOD(L,LPRD).EQ.M
         IF( IPRINT .EQ. 2 .AND. PRINT ) THEN
            WRITE(stdout,912)L
912         FORMAT(12H1DEPTH POINT,I4/)
            IPR = 2
         ELSE
            IPR = 1
         END IF
         CALL IONDIS(TEMP,PELE,MODE,IPR,PGAS,DNC)
*         DO 353 J=4,JATI,4
*            K=(J-2)/2
*            ZE(K,L)=ZETAJ(J+IONST-4)
*            ZE(K+1,L)=ZETAJ(J+IONST-3)
*353      CONTINUE
         DO 353 J=1, JMOL2
            ZE(J,L)=ZETAJ(J)
353      CONTINUE
         IF(JMOL2-JATI/2.GT.max_ion)CALL TEXT(3)
         IF( KPRINT .EQ. 2 .AND. PRINT ) THEN
            WRITE(stdout,912)L
            KPR=2
         ELSE
            KPR=1
         END IF
         DO 355 I=1,IMAX
            CALL OPALAM(OLAM(I),TEMP,PELE,DNC,KPR,OKAPPA,OSIGMA)
            ALKL(I,L)=LOG10(OKAPPA)
            ALSL(I,L)=LOG10(OSIGMA)
355      CONTINUE
C ***
C ***       Plotfile erzeugen
C ***
         IF( L .EQ. KPID .AND. KPLOT .EQ. 1) THEN
            OPEN( 30, FILE = 'OPAPLOT', STATUS = 'UNKNOWN' )
            REWIND 30
            CALL ZEILE( 0, 30 )
            CALL ZEILE( L, 30 )
            WRITE( 30, '(1X, A, 3I8)' ) DATE, KSCAT, KABS, KPKT
            PLINC = (PLMAX - PLMIN)/(KPKT - 1)
            OKMAX = -1.E38
            OSMAX = -1.E38
            DO 356 I = 0, KPKT - 1
               WAVE = PLMIN + I*PLINC
               CALL OPALAM( WAVE, TEMP, PELE, DNC, 1, OKAPPA, OSIGMA )
               OKMAX = MAX( OKMAX, OKAPPA )
               OSMAX = MAX( OSMAX, OSIGMA )
               WRITE( 30, '(1X, 1P, E11.3, 0P, 42F9.3)' ) WAVE,
     >           LOG10( MAX(1.E-38, OKAPPA) ), LOG10( MAX(1.E-38, 
     >           OSIGMA) ), (LOG10(
     >           AMAX1( 1.E-38, OPAC(IOP)*ATHOMS ) ), IOP = 1, KABS )
356         CONTINUE
            WRITE( 30, '(1X, 2F10.3)' ) LOG10( MAX(1.E-38, OKMAX) ), 
     >        LOG10( MAX(1.E-38, OSMAX) )
            CLOSE( 30 )
         END IF
351   CONTINUE
C ***
C *** OUTPUT OF LOG KAPPA,LOG SIGMA VALUES
C ***
      WRITE(1,905)IMAX
      DO 10 I=1,IMAX
         WRITE(1,909)OLAM(I)
909      FORMAT(//,1X,F9.2)
         WRITE(1,910)(ALKL(I,L),L=1,LMAX)
         WRITE(1,911)
         WRITE(1,910)(ALSL(I,L),L=1,LMAX)
910      FORMAT(1X,5F9.3)
911      FORMAT(/)
10    CONTINUE
C ***
C *** OUTPUT OF PARTICLE CONCENTRATIONS
C ***
      DO 8 K = 1, JMOL2
         DO 9 L=1,LMAX
            ZE(K,L) = LOG10( max( ZE(K,L), 1e-38 ) )
9        CONTINUE
8     CONTINUE
      DO 6 j = 1, jmol2
         WRITE(1,905)NAMJ(J)
         WRITE(1,906)CHIJ(J)
         WRITE(1,907)(ZE(j,L),L=1,LMAX)
6     CONTINUE
905   FORMAT(//1X,I8)
906   FORMAT(1X,F8.3)
907   FORMAT((10F8.3))
      REWIND 1
      CLOSE(1)
      END
