	subroutine chigen
C---READIN OF FREQUENCY QUADRATURE POINTS-------------------------------
C---READIN OF OPACITY SCALING-------------------------------------------
C ***
C ***   14-MAY-1991 18:04:53.41
C ***
C ***   Modifications:
C ***
C ***    9-FEB-1993 05:46:08.36         ML / UT Austin.  Changed FORMAT 2002
C ***   13-MAY-1995 17:27:07.00         ML / IoA.  Include files, zetah
C ***   17-MAY-1995 20:05:51.00         ML / IoA.  Reworked logic, moved
C ***                                   stuff to lineop/lcoeff.
C ***
        implicit none

        include 'MOD_SIZ.INC'

C ***
C ***   Global variables
C ***
        include 'NNS.INC'
        include 'MODEL.INC'
        include 'POP.INC'
        include 'LEVEL.INC'
        include 'LINE.INC'
        include 'OPAC.INC'

C ***
C ***   Local variables
C ***
        integer f_opa, f_bound
        parameter( f_opa = 23, f_bound = 24 )

        integer m_freq
        parameter( m_freq = 30 )

        real epsilon
        parameter( epsilon = 1.e-3 )

	character c1

	character zeile*133
        logical auto, done, first, noline
        integer direc, i, id, ij, ik, ig, mg, imu, ion, nlte_ion, it, j,
     >          n1, nf, ndmax, nfmax, nmu, nsumax, nsumin, idel
	integer iik, in0, n0( m_kma )
	real fak( m_kma )

        real bc0(m_depth), c6_lg, chim1, chind, 
     >       chisca, del, last_del, dbdtau, dgrid, dlam, dlam_d,
     >       dm, drrca, dtau, dx, f, hkc, mulgf, lggf_max, lamt_max,
     >       sum(m_depth), summax, summin, u, vdstd, x
        real lam_min, lam_max, lambda, lggf, exc, lgc4, lgc6, gamr
        real mu( 3 ), frequa( m_freq )
	real mgrid( 2*m_freq*m_kma ), mprof( m_depth, 2*m_freq*m_kma ),
     >       grid( m_grid ), prof( m_depth, m_grid )
	real profl( m_depth ), profw( m_depth ), norm( m_depth ),
     >       sigl( m_depth ),
     >       chi( m_depth, m_grid ), chil( m_depth ), chic( m_depth )
        real chis( m_depth ), sig( m_depth, m_grid ),
     >       wt( m_depth, m_grid ), bc( 3 )

C ***
C ***   Some physics...
C ***
        real pi, sqrt_pi, r_gas, m_e, e, c, hplanck, k, c2
        parameter( pi = 3.14159265358979323846264,
     >             sqrt_pi = 1.77245385090551602729816,
     >             r_gas = 8.31451e7,   ! gas constant
     >             m_e = 9.10939e-28,   ! electron mass
     >             e = 4.803207e-10,    ! electron charge
     >             c = 2.99792458e10,   ! speed of light
     >             hplanck = 6.626076e-27,      ! Planck
     >             k = 1.38066e-16,     ! Boltzmann
     >             c2 = 1.43877e0       ! h/k*c, for (h nu/kT)
     >           )

C ***
C ***   Functions
C ***
        logical get_sp_line
        integer stage
        real profpol, xp


        data nfmax/30/
        data frequa/0., .25, .5, .75, 1., 1.25, 1.5, 1.75, 2., 2.25,
     >       2.5, 2.75, 3., 3.25, 3.5, 3.75, 4., 4.5, 5., 6., 7., 8.,
     >       10., 17.5, 25., 40., 70., 120., 220., 420./
        data nmu/3/, mu/0.8872983346E00, 0.5E00, 0.1127016654E00/

        xp( x ) = exp( x*2.30258E00 )


C ***
C ***   Code
C ***
	c1 = char(1)

        open ( f_opa, file = 'OPA', form = 'UNFORMATTED' )
        open ( f_bound, file = 'BOUND', form = 'UNFORMATTED' )
        rewind f_opa
        rewind f_bound

C ***
C ***   Find standard Doppler velocity
C ***
        x = temp( 1 )
        ndmax = 1
        do id = 2, ndepth
           if( x .lt. temp(id) ) then
              x = temp( id )
              ndmax = id
           end if
        end do
        vdstd = sqrt( xi(ndmax)*xi(ndmax)*1e10 +
     >                2.*r_gas/wei*temp(ndmax) )/c
        write( 6, 9030 )


        dm = m( ndepth ) - m( ndepth - 1 )
        hkc = hk*c*1e8
        do 15 it = 1, nt
           i = low( it )
           j = up( it )
           n1 = nf1( it )

           auto = n1 .eq. 0 .or. back(it)

           call chiscale( chisca, frequa, nfmax, it ) ! continuum fudge factor

C ***
C ***      Continuous opacity
C ***
           do id = 1, ndepth
              chic(id) = akl( id, it )*chisca/avemas
              chis(id) = asl( id, it )/avemas
           end do
C ***
C ******************************************************************************
C ***
C ***      NLTE line opacity/abs coeff.
C ***
C ***
           drrca = max( 1.e-38, abs( rrca(j) - rrca(i) )*xp( dlogc6 ) )
           c6_lg = 32.3867 - log10( drrca )


           nlte_ion = (label( nk + 2 )/100)*100 + stage( i )

C ***
C ***      Strongest line in multiplet, multiplet f-value:
C ***
           lggf_max = -1.e37
	   mulgf = 0.
           do ik = 0, kma(it)
              if( lggf_max .lt. gflg(it,ik) ) then
                 lggf_max = gflg(it,ik)
                 lamt_max = lamt(it,ik)
              end if
              mulgf = mulgf + xp( gflg(it,ik) )
           end do
C ***
C ***	   Compute half of line profile of strongest component, figure number
C ***	   of frequency points required to cover line.
C ***
C ***	   Result: prof(1,1..nf), nf
C ***
           
           ij = 1
           done = .false.
           do while( .not.done .and. ij .le. nfmax )
           
              dlam = frequa(ij)*vdstd*lamt_max
           
              call lcoeff( dlam,
     >                     nlte_ion, lamt_max,
     >                     lggf_max-log10(g(i)), ! hack, get g_i divided out
     >                     eps(i),
     >                     c4lg(it)-dlogc4, c6_lg,
     >                     rad(it)*xp(dloggr),
     >                     prof(1,ij), norm, sig(1,ij), ndepth
     >                   )

              if( .not.auto ) then
                 done = ij .ge. n1
              else

                 call lineop( dlam,
     >                        nlte_ion, lamt_max,
     >                        lggf_max,
     >                        eps(i),
     >                        c4lg(it)-dlogc4, c6_lg,
     >                        rad(it)*xp(dloggr),
     >                        chil, ndepth )

                 done = .true.
                 id = 1
                 do while( done .and. id .le. ndepth )  ! chil/chik <= epsilon for all depths?
                    done = done .and. chil(id)/chic(id) .le. epsilon
                    id = id + 1
                 end do
                 done = done .and. ij .ge. 3  ! at least three points
              end if
              ij = ij + 1
           end do
           nf = ij - 1

C ***
C ***      Combine profiles onto common wavelength scale and weigh with
C ***      gf-value
C ***
C ***      Result:  mgrid(1..mg), mprof(1..ndepth,1..mg)
C ***
C ***	   First: wavelength grid...
C ***
C ***	   Do this on grid of strongest multiplet line,
C ***	   shift line to be on wavelength grid
C ***
C ***
           dlam_d = frequa(2)*vdstd*lamt_max

           mg = 0
	   do ik = 0, kma(it)
              lamt(it,ik) = anint( (lamt(it,ik) - lamt_max)/dlam_d )*
     >                      dlam_d + lamt_max ! shift
              do ij = 1, nf
                 dlam = frequa(ij)*vdstd*lamt_max     ! step size strongest line
                 call check_ig( mg, m_grid, it )
                 call insert( lamt(it,ik) + dlam, mgrid, mg )
                 call check_ig( mg, m_grid, it )
                 call insert( lamt(it,ik) - dlam, mgrid, mg ) ! other half
	      end do
	   end do
C ***
C ***	   Now: profile...
C ***
           do ij = 1, mg
              do id = 1, ndepth
                 mprof(id,ij) = 0.
              end do
           end do
           do ik = 0, kma(it)
              u = lamt(it,ik)
              do ij = 1, mg
                 do id = 1, ndepth
                    mprof(id,ij) = mprof(id,ij) +
     >                             xp(gflg(it,ik))*
     >                             profpol( (mgrid(ij) - u)/vdstd/u,
     >                                      frequa, prof(id,1),
     >                                      m_depth, nf )
                 end do
              end do
           end do
           do ij = 1, mg
              do id = 1, ndepth
                 mprof(id,ij) = mprof(id,ij)/mulgf
              end do
           end do
C ***
C ***	   Initialize wavelength grid for final profile
C ***	   (includes background lines)
C ***
C ***	   Result: grid(1..ig)
C ***
	   ig = mg
	   do ij = 1, ig
	      grid(ij) = mgrid(ij)
	   end do


C ***
C ***      Background lines.  first establish frequency grid; throw away
C ***      line opacity (sigh)
C ***
C ***
           lam_min = grid(1)
           lam_max = grid(ig)

           noline = .true.
           if( back(it) ) then	! no short circuiting on VMS, sigh...
           do while( get_sp_line( lam_min, lam_max,
     >                            ion, lambda, lggf, exc ) )

               lgc4 = 0.   ! if we know something better...
               lgc6 = -1.
               gamr = -1.
               if( ion .ne. nlte_ion .or.
     >             abs(exc - eps(i)) .ge. 0.05 ) then
C ***
C ***             Skip line if same element and excitation potential
C ***             within 0.05 eV of current level
C ***
                  dgrid = lambda - (anint( (lambda - lamt_max)/dlam_d )*
     >                             dlam_d + lamt_max)
                  do direc = 1, -1, -2  ! step up and down in lambda grid
                     ij = 1
                     done = .false.
                     do while( .not.done .and. ij .lt. nfmax )
                        dlam = direc*frequa(ij)*vdstd*lamt_max - dgrid
                        call lineop( dlam, ion, lambda, lggf, exc, lgc4,
     >                               lgc6, gamr, chil, ndepth )

                        done = .true.
                        id = 1
                        do while( done .and. id .le. ndepth )
                           done = done .and. chil(id)*
     >                            profpol( dlam + lambda,
     >                                     mgrid, mprof(id,1), m_depth,
     >                                     mg )/
     >                            chic(id) .le. epsilon
                           id = id + 1
                        end do

                        if( .not.done ) then
C ***
C ***                      Claim we need this line.  Check done here so
C ***                      a complete line can be skipped
C ***
                           call check_ig( ig, m_grid, it )
                           call insert( dlam + lambda, grid, ig )
                           noline = .false.
                        end if
                        ij = ij + 1
                     end do  ! while
                  end do     ! direc
               end if        ! skip
           end do            ! get_sp_line
           end if            ! short circuit


C ***
C ***      Contiuous opacity...
C ***
           do ij = 1, ig
              do id = 1, ndepth
                 chi( id, ij ) = chic(id)
              end do
           end do


C ***
C ***      Now we know the frequency grid.  Compute opacity for *all*
C ***      lines at those points if we've found a background line
C ***
           first = .true.
           if( back(it) .and. .not.noline ) then   ! no short circuit on VMS
           do while( get_sp_line( lam_min, lam_max,
     >                            ion, lambda, lggf, exc ) )

               lgc4 = 0.   ! if we know something better...
               lgc6 = -1.
               gamr = -1.
               if( ion .ne. nlte_ion .or.
     >             abs(exc - eps(i)) .ge. 0.05 ) then
C ***
C ***             Skip line if same element and excitation potential
C ***             within 0.05 eV of current level
C ***
                  last_del = 1e37
                  do ij = 1, ig         ! find point closest to line center
                     del = abs( grid(ij) - lambda )
                     if( del .le. last_del ) then
                        last_del = del
                        idel = ij
                     else               ! stepping beyond => found it
                        go to 1
                     end if
                  end do
1                 continue

                  do direc = 1, -1, -2  ! step up and down in lambda grid
                     if( direc .eq. 1 ) then
                        ij = idel
                     else
                        ij = idel - 1
                     end if
                     done = .false.
                     do while( .not.done .and.
     >                         ij .le. ig .and. ij .ge. 1 )
                        dlam = grid(ij) - lambda
                        call lineop( dlam, ion, lambda, lggf, exc, lgc4,
     >                               lgc6, gamr, chil, ndepth )
                        done = .true.
                        id = 1
                        do while( done .and. id .le. ndepth )
                           done = done .and. chil(id)*
     >                            profpol( dlam + lambda,
     >                                     mgrid, mprof(id,1), m_depth,
     >                                     mg )/
     >                            chic(id) .le. epsilon
                           id = id + 1
                        end do

                        if( .not.done ) then
C ***
C ***                      Add line opacity to total
C ***
                           do id =  1, ndepth
                              chi( id, ij ) = chi( id, ij ) + chil( id )
                           end do

                           if( first ) then
                              first = .false.
                              write( 6, '(/)' )
                              write( zeile, '(1x, i3, 3a, f12.3, 2a,
     >                                    f12.3, 2a, f12.3, a)' )
     >                              it,
     >                              '  B a c k g r o u n d  L i n e s',
     >                              '  for ', c1, u, 'A included in [',
     >                              c1, lam_min, ', ', c1, lam_max, ']:'
                              call sout( 6, zeile, c1 )
                              write( 6, '()' )
                           end if
                           if( ij .eq. idel .and. direc .eq. 1 ) then
                              write( 6, '(1x, i6, x, i2, x, f10.3, x,
     >                                    f6.2, x, f6.2, x, f6.2, x,
     >                                    f6.2, x, f6.2,x i1 )' )
     >                              ion, 0, lambda, exc, lggf,
     >                              32.3867 - lgc6, lgc4, gamr, 0
                           end if
                        end if
                        ij = ij + direc
                     end do  ! while
                  end do     ! direc
               end if        ! skip
           end do            ! get_sp_line
           end if            ! short circuit

C ***
C ***	   Central wavelength of interval
C ***
	   u = ( grid(ig) + grid(1) )/2.

C ***
C ***	   Make use of symmetry of profile...
C ***
	   call symize( it, frequa(nf)*vdstd, nf, grid, ig, .not.noline,
     >                  n0, fak, in0 )

C ***
C ***      Set up integration weights and line profile/abs. coefficient
C ***
           do id = 1, ndepth
              sum(id) = 0.
           end do
           iik = 1
           do ij = 1, ig
              do id = 1, ndepth
                 sig(id,ij) = 0.
                 profw(id) = 0.
              end do
              do ik = 0, kma(it)
                 call lcoeff( grid(ij) - lamt(it,ik),
     >                        nlte_ion, lamt(it,ik),
     >                        gflg(it,ik)-log10(g(i)), ! hack, get g_i divided out
     >                        eps(i),
     >                        c4lg(it)-dlogc4, c6_lg,
     >                        rad(it)*xp(dloggr),
     >                        profl, norm, sigl, ndepth )
                 do id = 1, ndepth
                    sig(id,ij) = sig(id,ij) + sigl(id)
                    profw(id) = profw(id) + profl(id)*norm(id)
                 end do
              end do
              if( ij .eq. 1 ) then
                 dx = ( grid(2) - grid(1) )*fak(iik)
              else if( ij .eq. ig ) then
                 dx = ( grid(ig) - grid(ig - 1) )*fak(iik)
	      else if( ij .eq. n0(iik) ) then
	         dx = ( grid(ij) - grid(ij - 1) )*fak(iik)
	      else if( ij .eq. n0(iik) + 1 ) then
	         dx = ( grid(ij+1) - grid(ij) )*fak(iik)
                 iik = iik + 1
              else
                 dx = ( grid(ij + 1) - grid(ij - 1) )*fak(iik)
              end if
              do id = 1, ndepth
                 wt( id, ij ) = dx*c*1e8/u/u
                 sum(id) = sum(id) + wt( id, ij )*profw(id)
              end do
           end do
           do ij = 1, ig
              do id = 1, ndepth
                 wt( id, ij ) = (kma(it) + 1)*wt( id, ij )/sum(id)
              end do
           end do

           summin = 1.E+36
           summax = 0.
           nsumax = 0
           nsumin = 0
           do id = 1, ndepth
              if( sum(id) .gt. summax ) then
                 summax = sum(id)
                 nsumax = id
              end if
              if( summin .gt. sum(id) ) then
                 summin = sum(id)
                 nsumin = id
              end if
           end do

           nf1(it) = ig

           write( 6, 9040 ) it, kma(it) + 1, nf, ig, u, dlam_d,
     >                      (grid(ig) - u)/(vdstd*u),
     >                      nsumax, summax/(kma(it) + 1),
     >                      nsumin, summin/(kma(it) + 1),
     >                      ( grid(ij) - u, ij = 1, ig )

           f = c*1e8/u
           bnu(it) = 1.4745279e-2*(2.997925e3/u)**3
	   do id = 1, ndepth
              bc0( id ) = bnu( it )/( exp(hkc/temp(id)/u) - 1.
     >                    )
           end do
           call wr2( f_opa, bc0, ndepth, chis, ndepth )
           call wr2( f_opa, bnu(it), 1, f, 1 )

C ***
C ******************************************************************************
C ***
C ***      lower boundary condition for transfer problem
C ***
           dbdtau = bc0(ndepth) - bc0(ndepth - 1)
           gr( it ) = g( i )/g( j )
           do 14 ij = 1, ig
              chim1 = chi( ndepth - 1, ij ) + sig( ndepth - 1, ij )*
     >                ( n(ndepth - 1, i) - gr(it)*n(ndepth - 1, j) )/
     >                rho( ndepth - 1 )
              chind = chi( ndepth, ij ) + sig( ndepth, ij )*
     >                ( n(ndepth, i) - gr(it)*n(ndepth, j) )/
     >                rho( ndepth )
              dtau = 0.5*( chim1 + chind + 
     >                     chis(ndepth - 1) + chis(ndepth) )*dm
              dbdtau = dbdtau/dtau
              do 13 imu = 1, nmu
                 bc( imu ) = bc0( ndepth ) + mu( imu )*dbdtau
13            continue
              call wr3( f_opa, chi(1,ij), ndepth, sig(1,ij), ndepth,
     >                  wt(1,ij), ndepth )
              call wr1( f_bound, bc, nmu )
14         continue
15      continue

        rewind f_opa
        rewind f_bound
        close( f_opa )
        close( f_bound )

9030    format( '1  Lambda spacing in the lines', //
     >   '  IT  KMA  NF  IG  dlam_D  lam_0  Max Doppler widths  NSUMAX',
     >   '  SUMMAX  NSUMIN  SUMMIN', /
     >   '  Distance of quadrature point from interval center in',
     >   ' Angstroms'
     >        )
9040    format( //1x, i3, 3i4, f12.3, f10.5, f10.3, i5, f10.6, i5,
     >          f10.6//(13(1x, f9.4)) )

        end
        subroutine check_ig( ig, ig_max, it )
        implicit none
        integer ig, ig_max, it

        if( ig .ge. ig_max ) then
           write( 6, * ) 'CHIGEN>> An internal limit ',
     >                   'was reached.'
           write( 6, * ) '         Too many frequency ',
     >                   'points to be generated for ',
     >                   'line #', it
           call exit
        end if

        end

	subroutine symize( it, vd, nf, grid, ig, line, n0, fak, in0 )
C ***
C ******************************************************************************
C ***
C ***	Remove those half-profiles which aren't needed and mark 
C ***	end of multiplet lines.
C ***
C ***	it	 > i	multiplet to look at
C ***	vd	 > r	max Doppler velocity
C ***	nf	 > i	number of points in half of single multiplet component
C ***			(assuming all components have the same number)
C ***	grid	>< r	wavelength grid where points are to be removed
C ***	ig	>< i	# of points in grid
C ***	line	 > l	multiplet has background lines
C ***	n0	 < i	ends of non-overlapping multiplet lines
C ***	fak	 < r	`integration weights'; 0.5 for asymmetric lines,
C ***			or 1 for symmetric ones (i.e., if points were removed)
C ***	in0	 < i	# of non-overlapping lines (.ge. 1)
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***   Arguments
C ***
	integer it, nf, ig, n0(*), in0
	real vd, grid(ig), fak(*)
	logical line

C ***
C ***	Global variables
C ***
	include 'MOD_SIZ.INC'
	include 'LINE.INC'
	include 'NNS.INC'

C ***
C ***	Local variables
C ***
	logical disjunct, u_disjunct
	integer ik, jk, ij, icen, i, j, k, ishift
	real last_cen, cen, f


	if( line ) then
	   in0 = 1
	   n0(in0) = ig
	   fak(in0) = 0.5
	else
	   in0 = 0
	   do ik = 0, kma(it)
C ***
C ***	      Figure out which lines are disjunct and
C ***	      which ones are ends of blends
C ***
	      disjunct = .true.
	      u_disjunct = .true.
	      do jk = 0, kma(it)
	         if( jk .ne. ik ) then
                    disjunct = disjunct .and.
     >                         abs( lamt(it,ik) - lamt(it,jk) ) .gt.
     >                         vd*( lamt(it,ik) + lamt(it,ik) )
	            if( lamt(it,jk) .gt. lamt(it,ik) ) then
                       u_disjunct = u_disjunct .and.
     >                              abs( lamt(it,ik) - lamt(it,jk) )
C ***                               ^^^ not required but might help optimizer
     >                              .gt.
     >                              vd*( lamt(it,ik) + lamt(it,ik) )
	            end if
	         end if
                 if( .not.disjunct .and. .not.u_disjunct ) go to 1
	      end do
1	      continue

	      if( u_disjunct ) then
C ***
C ***	         Find end of multiplet component
C ***
                 last_cen = 1e37
                 do ij = 1, ig         ! find point closest to line center
                    cen = abs( grid(ij) - lamt(it,ik) )
                    if( cen .le. last_cen ) then
                       last_cen = cen
                       icen = ij
                    else               ! stepping beyond => found it
                       go to 2
                    end if
                 end do
2                continue

	         in0 = in0 + 1
	         n0(in0) = icen + nf - 1
	         fak(in0) = 0.5
	      end if

	      if( disjunct ) then
C ***
C ***	         Remove symmetrical half of line if line is disjunct
C ***
	         ishift = nf - 1
                 do ij = icen, ig
                    grid( ij - ishift ) = grid(ij)
                 end do
                 ig = ig - ishift

	         do jk = 1, in0 - 1	! fix end points
	            if( n0(jk) .gt. n0(in0) ) then
	                n0(jk) = n0(jk) - ishift
	            end if
	         end do
	         n0(in0) = n0(in0) - ishift
	         fak(in0) = 1.
              end if
	   end do
C ***
C ***	   sort n0 and fak
C ***
	   do i = in0 - 1, 1, -1
	      do j = 1, i
	         if( n0(j) .ge. n0(j+1) ) then
	             k = n0(j)
	             n0(j) = n0(j+1)
	             n0(j+1) = k

	             f = fak(j)
	             fak(j) = fak(j+1)
	             fak(j+1) = f
	         end if
	      end do
	   end do
	end if


	end
