	subroutine chiscale( chisca, frequa, nfmax, it )
C ***
C ******************************************************************************
C ***
C ***	Get scale factor for continous opacity and read frequency grid.
C ***
C ***	chisca		 < r	scale factor
C ***	frequa(nfmax)	 < r	frequency grid in Doppler widths
C ***	nfmax		>< i	number of points in frequa
C ***	it		 > i	transition for which to return scale and frequa
C ***
C ***	Modifications:
C ***
C ***	19-MAY-1995 13:02:59.00		ML / IoA.  Taken from chigen and
C ***					repackaged as subroutine.
C ***	14-MAR-1996 15:08:51.18		ML / Bamberg.  Moved init of ntsc;
C ***                                   was skipped on EOF of ATOM.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	integer nfmax, it
	real chisca, frequa(nfmax)

C ***
C ***	Local variables
C ***
	include 'MOD_SIZ.INC'
	integer f_atom
	parameter( f_atom = 1 )

	logical first
	integer if, itsc, nfmax1, ntsc, tsc( m_lines )
	real opcsca


	save first, ntsc, tsc, opcsca

	data first /.true./

C ***
C ***	Code
C ***

	if( first ) then
	   first = .false.

           ntsc = 0
           nfmax1 = 0

           read( f_atom, *, end = 1 ) nfmax1
           if( nfmax1 .gt. 0 ) then
              nfmax = nfmax1
              read( f_atom, * ) ( frequa(if), if = 1, nfmax )
           end if
           write( 6, 9020 ) nfmax, ( frequa(if), if = 1, nfmax )

           read( f_atom, * ) ntsc
           if( ntsc .gt. m_lines ) then
	      write( 6, * ) 'Continous opacity scaling for too many ',
     >        		    'lines.  Not more than ', m_lines
	      call exit(1)
           else if( ntsc .gt. 0 ) then
              read( f_atom, * ) ( tsc(itsc), itsc = 1, ntsc )
              read( f_atom, * ) opcsca
              write( 6, 9000 ) ( tsc(itsc), itsc = 1, ntsc )
              write( 6, 9010 ) opcsca
           end if

1	   continue

	end if

        chisca = 1.
        do itsc = 1, ntsc
           if( it .eq. tsc(itsc) ) then
              write( 6, * ) it, itsc, tsc(itsc)
	      chisca = opcsca
	      go to 2
	   end if
	end do
	
2       continue

9000    format( ' ', 50('+'), 'Continuum opacity scaling', 50('+'),
     >        //' for transition no.', /(30i4) )
9010    format( /' Scaling factor is', f8.3,
     >        ' for all other:     1.000' )
9020    format( //' ', 30('-'),
     >  'Frequency quadrature points from line center in Doppler widths'
     >        , 30('-'), //' NFMAX', i4, //(12f10.3) )

	end
