#
#           M a k e f i l e   for generating the NLTE program system
#           ========================================================
#
#       Possible targets:
#
#          all                  Checks if anything in .bin needs to be
#                               rebuilt
#          install              Moves executables to .bin
#          clean                Removes executables from current directory
#          here                 Same as `all' but checks executables in
#                               current directory
#          ttau, atm...         Makes a single program only; checks like
#                               `here'
#          $(bindir)ttau ...    Makes a single program only; checks like
#                               `all'
#
#       Executables are left in current directory unless `install' is used.
#
#       Michael Lemke           11-MAR-1993 17:46:06.00
#
#   Modifications:
#
#        1-APR-1993 12:38:43.00 ML / UT Austin.  Added atm_f, a version of atm
#                               with more elements.  Needs to be made with
#                               "make atm_f" or "make $(bindir)atm_f"
#
#	 1-OCT-1993 12:27:16.00 ML / IoA Cambs.  Ported to AIX.  Added changes
#				for new code version
#
#	14-FEB-1994 18:24:50.00	ML / IoA Cambs.  Added hlinop + stark
#
#	29-MAR-1994 22:11:41.00	ML / IoA.  Added atm4 for KV printing 4 ionst.
#
#	21-DEC-1994 19:05:42.00 ML / IoA.  Changed rates routines for use
#				ATLAS9 matrices.  Keep old version as rates6
#
#	17-FEB-1995 14:19:43.00 ML / IoA.  Added rates_nlte.
#	29-APR-1996 14:48:37.16	ML / Bamberg.  Added abuscal
#    	18-AUG-1996 05:17:44.69	ML / Bamberg.  NOB stuff.  Targets nttau and natm
# ***	11-AUG-1997 17:40:57.67	ML / Bamberg.  nttau + natm included in all:
# ***	25-FEB-1998 22:15:30.03	ML / Bamberg.  But B + Be in atm instead of atm_f
#                               natm was doingthis anyway.  Use atm_f_routines
#                               for atm
# ***	20-MAR-1998 15:22:28.53	ML / Bamberg.  atm_qab target.
#	16-JUN-2004 21:58:31.35 ML / Stegaurach.  ptau_new dependency.
#
#
# $Id: descrip.mms,v 1.2 2004/06/16 20:01:12 michael Exp $
#

bindir = sc:

abuscal_routines = \
	abuscal.obj

ttau_routines = \
	ttau.obj, map1.obj

nttau_routines = \
	ttau_new.obj, map1.obj

atm_f_routines = \
	atm.obj,           iondis.obj,        ncharg.obj,   opalam.obj,        \
	ptau.obj,          qmol.obj,          quati1.obj,   qati2_boron.obj,   \
	t1.obj,            text.obj,          zeile.obj,    aal1bf.obj,        \
	ac1bf.obj,         aca1bf.obj,        aca2bf.obj,   acmi.obj,          \
	afe1bf.obj,        ah2p.obj,          ah2q.obj,     ahe1bf.obj,        \
	ahemff.obj,        ahmibf.obj,        ahmiff.obj,   ahylbf.obj,        \
	ahylff.obj,        amg1bf.obj,        amg2bf.obj,   an1bf.obj,         \
	ana1bf.obj,        ane1bf.obj,        ao1bf.obj,    araylff.obj,       \
	asi1bf.obj,        asi2bf.obj,        dchi.obj,     decom2.obj,        \
	fit.obj,           gauhbf.obj,        gauhff.obj,   merson.obj,        \
	pre.obj,           z.obj,             f.obj,        intep.obj,         \
	isrchfge.obj,      isrchfle.obj

natm_f_routines = \
	atm.obj,           iondis.obj,        ncharg.obj,   opalam.obj,        \
	ptau_new.obj,      qmol.obj,          quati1.obj,   qati2_boron.obj,   \
	t1.obj,            text.obj,          zeile.obj,    aal1bf.obj,        \
	ac1bf.obj,         aca1bf.obj,        aca2bf.obj,   acmi.obj,          \
	afe1bf.obj,        ah2p.obj,          ah2q.obj,     ahe1bf.obj,        \
	ahemff.obj,        ahmibf.obj,        ahmiff.obj,   ahylbf.obj,        \
	ahylff.obj,        amg1bf.obj,        amg2bf.obj,   an1bf.obj,         \
	ana1bf.obj,        ane1bf.obj,        ao1bf.obj,    araylff.obj,       \
	asi1bf.obj,        asi2bf.obj,        dchi.obj,     decom2.obj,        \
	fit.obj,           gauhbf.obj,        gauhff.obj,   merson.obj,        \
	pre.obj,           z.obj,             f.obj,        intep.obj,         \
	isrchfge.obj,      isrchfle.obj

atm_qab_routines = \
	atm.obj,           iondis.obj,        ncharg.obj,   opalam.obj,        \
	ptau.obj,          qmol_qab.obj,          quati1.obj,   qati2_boron.obj,   \
	t1.obj,            text.obj,          zeile.obj,    aal1bf.obj,        \
	ac1bf.obj,         aca1bf.obj,        aca2bf.obj,   acmi.obj,          \
	afe1bf.obj,        ah2p.obj,          ah2q.obj,     ahe1bf.obj,        \
	ahemff.obj,        ahmibf.obj,        ahmiff.obj,   ahylbf.obj,        \
	ahylff.obj,        amg1bf.obj,        amg2bf.obj,   an1bf.obj,         \
	ana1bf.obj,        ane1bf.obj,        ao1bf.obj,    araylff.obj,       \
	asi1bf.obj,        asi2bf.obj,        dchi.obj,     decom2.obj,        \
	fit.obj,           gauhbf.obj,        gauhff.obj,   merson.obj,        \
	pre.obj,           z.obj,             f.obj,        intep.obj,         \
	isrchfge.obj,      isrchfle.obj,      qab.obj

natm_qab_routines = \
	atm.obj,           iondis.obj,        ncharg.obj,   opalam.obj,        \
	ptau_new.obj,      qmol_qab.obj,      quati1.obj,   qati2_boron.obj,   \
	t1.obj,            text.obj,          zeile.obj,    aal1bf.obj,        \
	ac1bf.obj,         aca1bf.obj,        aca2bf.obj,   acmi.obj,          \
	afe1bf.obj,        ah2p.obj,          ah2q.obj,     ahe1bf.obj,        \
	ahemff.obj,        ahmibf.obj,        ahmiff.obj,   ahylbf.obj,        \
	ahylff.obj,        amg1bf.obj,        amg2bf.obj,   an1bf.obj,         \
	ana1bf.obj,        ane1bf.obj,        ao1bf.obj,    araylff.obj,       \
	asi1bf.obj,        asi2bf.obj,        dchi.obj,     decom2.obj,        \
	fit.obj,           gauhbf.obj,        gauhff.obj,   merson.obj,        \
	pre.obj,           z.obj,             f.obj,        intep.obj,         \
	isrchfge.obj,      isrchfle.obj,      qab.obj

atm4_routines = \
	atm4.obj,          iondis.obj,        ncharg.obj,   opalam.obj,        \
	ptau.obj,          qmol.obj,          quati1.obj,   qati2_boron.obj,   \
	t1.obj,            text.obj,          zeile.obj,    aal1bf.obj,        \
	ac1bf.obj,         aca1bf.obj,        aca2bf.obj,   acmi.obj,          \
	afe1bf.obj,        ah2p.obj,          ah2q.obj,     ahe1bf.obj,        \
	ahemff.obj,        ahmibf.obj,        ahmiff.obj,   ahylbf.obj,        \
	ahylff.obj,        amg1bf.obj,        amg2bf.obj,   an1bf.obj,         \
	ana1bf.obj,        ane1bf.obj,        ao1bf.obj,    araylff.obj,       \
	asi1bf.obj,        asi2bf.obj,        dchi.obj,     decom2.obj,        \
	fit.obj,           gauhbf.obj,        gauhff.obj,   merson.obj,        \
	pre.obj,           z.obj,             f.obj,        intep.obj,         \
	isrchfge.obj,      isrchfle.obj

rates6_routines = \
	rates.obj,         integ.obj,         intep.obj,    iondis.obj,       \
	isrchfge.obj,      isrchfle.obj,      josh6.obj,    linop.obj,        \
	map1.obj,          ncharg.obj,        opalam.obj,   parcoe.obj,       \
	qmol.obj,          quati1.obj,        quati2.obj,   rint.obj,         \
	wrop.obj,          data.obj,          aal1bf.obj,   ac1bf.obj,        \
	aca1bf.obj,        aca2bf.obj,        acmi.obj,     afe1bf.obj,       \
	ah2p.obj,          ah2q.obj,          ahe1bf.obj,   ahemff.obj,       \
	ahmibf.obj,        ahmiff.obj,        ahylbf.obj,   ahylff.obj,       \
	amg1bf.obj,        amg2bf.obj,        an1bf.obj,    ana1bf.obj,       \
	ane1bf.obj,        ao1bf.obj,         araylff.obj,  asi1bf.obj,       \
	asi2bf.obj,        dchi.obj,          decom2.obj,   deriv.obj,        \
	expint.obj,        gauhbf.obj,        gauhff.obj,   linopv9.obj,      \
	field.obj, integral.obj,	mintep.obj,	qqsort.obj

rates_routines = \
	rates.obj,         integ.obj,         intep.obj,    iondis.obj,       \
	isrchfge.obj,      isrchfle.obj,      josh.obj,     linop.obj,        \
	map1.obj,          ncharg.obj,        opalam.obj,   parcoe.obj,       \
	qmol.obj,          quati1.obj,        quati2.obj,   rint.obj,         \
	wrop.obj,          blockhj.obj,       aal1bf.obj,   ac1bf.obj,        \
	aca1bf.obj,        aca2bf.obj,        acmi.obj,     afe1bf.obj,       \
	ah2p.obj,          ah2q.obj,          ahe1bf.obj,   ahemff.obj,       \
	ahmibf.obj,        ahmiff.obj,        ahylbf.obj,   ahylff.obj,       \
	amg1bf.obj,        amg2bf.obj,        an1bf.obj,    ana1bf.obj,       \
	ane1bf.obj,        ao1bf.obj,         araylff.obj,  asi1bf.obj,       \
	asi2bf.obj,        dchi.obj,          decom2.obj,   deriv.obj,        \
	expint.obj,        gauhbf.obj,        gauhff.obj,   linopv9.obj,      \
	rfield.obj,	integral.obj,	mintep.obj,	qqsort.obj

rates_nlte_routines = \
	rates.obj,         integ.obj,     intep.obj,       iondis.obj,       \
	isrchfge.obj,      isrchfle.obj,  josh.obj,        linop.obj,        \
	map1.obj,          ncharg.obj,    opalam_nlte.obj, parcoe.obj,       \
	qmol.obj,          quati1.obj,    quati2.obj,      rint.obj,         \
	wrop.obj,          blockhj.obj,   aal1bf.obj,      ac1bf_nlte.obj,   \
	aca1bf.obj,        aca2bf.obj,    acmi.obj,        afe1bf.obj,       \
	ah2p.obj,          ah2q.obj,      ahe1bf.obj,      ahemff.obj,       \
	ahmibf.obj,        ahmiff.obj,    ahylbf.obj,      ahylff.obj,       \
	amg1bf.obj,        amg2bf.obj,    an1bf.obj,       ana1bf.obj,       \
	ane1bf.obj,        ao1bf.obj,     araylff.obj,     asi1bf.obj,       \
	asi2bf.obj,        dchi.obj,      decom2.obj,      deriv.obj,        \
	expint.obj,        gauhbf.obj,    gauhff.obj,      linopv9.obj,      \
	rfield.obj,	integral.obj,	mintep.obj,	qqsort.obj

start_routines = \
	start.obj,  atmos.obj,  chigen.obj,  h.obj,       \
	integ.obj,  iondis.obj, ncharg.obj,  opalam.obj,  \
	outsta.obj, parcoe.obj, qmol.obj,    quati1.obj,  \
	qati2_boron.obj, ratcal.obj, wrbin.obj,   aal1bf.obj,  \
	ac1bf.obj,  aca1bf.obj, aca2bf.obj,  acmi.obj,    \
	afe1bf.obj, ah2p.obj,   ah2q.obj,    ahe1bf.obj,  \
	ahemff.obj, ahmibf.obj, ahmiff.obj,  ahylbf.obj,  \
	ahylff.obj, amg1bf.obj, amg2bf.obj,  an1bf.obj,   \
	ana1bf.obj, ane1bf.obj, ao1bf.obj,   araylff.obj, \
	asi1bf.obj, asi2bf.obj, colrat.obj,  colsec.obj,  \
	dchi.obj,   decom2.obj, feclrt.obj,  fecsc.obj,   \
	gauhbf.obj, gauhff.obj, genclrt.obj, heclrt.obj,  \
	hecsc.obj,  heerr.obj,  map1.obj,    mgcsc.obj,   \
	bacsc.obj,  mgclrt.obj, gencsc.obj,  baclrt.obj,  \
	expint.obj, idx.obj,    incoll.obj,  integr.obj,  \
	isrchfge.obj, lget.obj, hlinop.obj,  stark.obj,   \
        chiscale.obj, get_sp_line.obj, insert.obj, gam4def.obj, \
        lineop.obj,   profpol.obj, sout.obj, stage.obj, intep.obj, \
	isrchfle.obj


eddfac_routines = \
	eddfac.obj,        inpedd.obj,        mati.obj,          wrbin.obj

gab_routines = \
	gab.obj,           idx.obj,           inpgab.obj,   newpage.obj,       \
	outgab.obj,        pops.obj,          wrbin.obj,    matinv.obj,        \
	sscal.obj,         isamax.obj

linear2_routines = \
	linear2.obj,       comp.obj,  dn.obj,    inplin.obj, lufac.obj, \
	matgen.obj,        solve.obj,         triinv.obj,    wrbin.obj, \
	gener.obj

.ifdef debug
FFLAGS = /debu/noop /real=64 /integ=64 /check=nooutput_con /warn=nousa
LFLAGS = /debug
.else
FFLAGS = /real=64 /integ=64 /check=nooutput_con /warn=nousa
LFLAGS = 
.endif


progs = abuscal.exe, ttau.exe, atm.exe, rates.exe, start.exe, eddfac.exe, \
        gab.exe, linear2.exe, natm.exe, nttau.exe, atm_qab.exe, natm_qab.exe

bin_progs = $(bindir)abuscal.exe, $(bindir)ttau.exe, $(bindir)atm.exe, \
            $(bindir)rates.exe, $(bindir)start.exe, \
	    $(bindir)eddfac.exe, $(bindir)gab.exe, $(bindir)linear2.exe, \
	    $(bindir)natm.exe, $(bindir)nttau.exe


all :    $(bin_progs)
	continue

install :
	- purge *.exe	! so BACKUP isn't confused
	- backup/log/del/new $(progs) $(bindir)

here :   $(progs)

clean :
	- purge $(progs) 2>/dev/null; exit 0

$(bindir)abuscal.exe :    $(abuscal_routines)
	@ $(MMS)  abuscal
$(bindir)nttau.exe :    $(nttau_routines)
	@ $(MMS)  nttau
$(bindir)natm.exe :     $(natm_f_routines)
	@ $(MMS)  natm
$(bindir)ttau.exe :    $(ttau_routines)
	@ $(MMS)  ttau
$(bindir)atm.exe :     $(atm_f_routines)
	@ $(MMS)  atm
$(bindir)atm_qab.exe :     $(atm_qab_routines)
	@ $(MMS)  atm_qab
$(bindir)atm_f.exe :   $(atm_f_routines)
	@ $(MMS)  atm_f
$(bindir)rates.exe :   $(rates_routines)
	@ $(MMS)  rates
$(bindir)rates6.exe :   $(rates6_routines)
	@ $(MMS)  rates6
$(bindir)rates_nlte.exe :   $(rates_nlte_routines)
	@ $(MMS)  rates_nlte
$(bindir)start.exe :   $(start_routines)
	@ $(MMS) start
$(bindir)eddfac.exe :  $(eddfac_routines)
	@ $(MMS)  eddfac
$(bindir)gab.exe :     $(gab_routines)
	@ $(MMS)  gab
$(bindir)linear2.exe : $(linear2_routines)
	@ $(MMS)  linear2

abuscal :   abuscal.exe
	continue

abuscal.exe : $(abuscal_routines)
	$(LINK) $(LFLAGS) /EXE=abuscal $(abuscal_routines), plt/l/sysexe

ttau :   ttau.exe
	continue

ttau.exe : $(ttau_routines)
	$(LINK) $(LFLAGS) /EXE=ttau $(ttau_routines)

nttau :   nttau.exe
	continue

nttau.exe : $(nttau_routines)
	$(LINK) $(LFLAGS) /EXE=nttau $(nttau_routines)



atm :    atm.exe
	continue

atm.exe : $(atm_f_routines)
	$(LINK) $(LFLAGS) /EXE=atm $(atm_f_routines), plt/l

atm_f :  atm_f.exe
	continue

atm_f.exe : $(atm_f_routines)
	$(LINK) $(LFLAGS) /EXE=atm_f $(atm_f_routines), plt/l


atm_qab :    atm_qab.exe
	continue

atm_qab.exe : $(atm_qab_routines)
	$(LINK) $(LFLAGS) /EXE=atm_qab $(atm_qab_routines), plt/l

natm :  natm.exe
	continue

natm.exe : $(natm_f_routines)
	$(LINK) $(LFLAGS) /EXE=natm $(natm_f_routines), plt/l

natm_qab :    natm_qab.exe
	continue

natm_qab.exe : $(natm_qab_routines)
	$(LINK) $(LFLAGS) /EXE=natm_qab $(natm_qab_routines), plt/l


rates : rates.exe
	continue

rates.exe : $(rates_routines)
	$(LINK) $(LFLAGS) /EXE=rates $(rates_routines)

rates6 : rates6.exe
	continue

rates6.exe : $(rates6_routines)
	$(LINK) $(LFLAGS) /EXE=rates6 $(rates6_routines)

rates_nlte : rates_nlte.exe
	continue

rates_nlte.exe : $(rates_nlte_routines)
	$(LINK) $(LFLAGS) /EXE=rates_nlte $(rates_nlte_routines)

start :  start.exe
	continue

start.exe : $(start_routines)
	$(LINK) $(LFLAGS) /EXE=start $(start_routines)

eddfac : eddfac.exe
	continue

eddfac.exe : $(eddfac_routines)
	$(LINK) $(LFLAGS) /EXE=eddfac $(eddfac_routines)

gab :   gab.exe
	continue

gab.exe : $(gab_routines)
	$(LINK) $(LFLAGS) /EXE=gab $(gab_routines)

linear2 : linear2.exe
	continue

linear2.exe : $(linear2_routines)
	$(LINK) $(LFLAGS) /EXE=linear2 $(linear2_routines)


# DO NOT DELETE THIS LINE - used by make depend
aal1bf.obj : []OP.INC 
ac1bf.obj : []OP.INC 
ac1bf_nlte.obj : []OP.INC []MOD_SIZ.INC []MODEL_RA.INC 
ac1bf_op.obj : []OP.INC []AC1BF1.INC []AC1BF2.INC []AC1BF3.INC 
aca1bf.obj : []OP.INC 
aca2bf.obj : []OP.INC 
acmi.obj : []OP.INC 
afe1bf.obj : []OP.INC 
ah2p.obj : []OP.INC 
ah2q.obj : []OP.INC 
ahe1bf.obj : []OP.INC 
ahemff.obj : []OP.INC 
ahmibf.obj : []OP.INC 
ahmiff.obj : []OP.INC 
ahylbf.obj : []OP.INC 
ahylff.obj : []OP.INC 
amg1bf.obj : []OP.INC 
amg2bf.obj : []OP.INC 
an1bf.obj : []OP.INC 
ana1bf.obj : []OP.INC 
ane1bf.obj : []OP.INC 
ao1bf.obj : []OP.INC 
asi1bf.obj : []OP.INC 
asi2bf.obj : []OP.INC 
atm.obj : []OPALION.INC []K.INC []OP.INC []INT.INC []RE.INC 
atm4.obj : []K.INC []OP.INC []INT.INC []RE.INC 
atmos.obj : []MOD_SIZ.INC []MODEL.INC []POP.INC []NNS.INC []LEVEL.INC []LINE.INC []OPAC.INC []OPALION.INC 
baclrt.obj : []MOD_SIZ.INC []NNS.INC []MODEL.INC []POP.INC []LEVEL.INC []LINE.INC []COLIS.INC 
bacsc.obj : []MOD_SIZ.INC []NNS.INC []LEVEL.INC []COLIS.INC 
chigen.obj : []MOD_SIZ.INC []NNS.INC []MODEL.INC []POP.INC []LEVEL.INC []LINE.INC []OPAC.INC 
chiscale.obj : []MOD_SIZ.INC 
comp.obj : []MOD_SIZ.INC 
dchi.obj : []OPALION.INC 
decom2.obj : []OPALION.INC 
dn.obj : []MOD_SIZ.INC 
eddfac.obj : []MOD_SIZ.INC 
f.obj : []RE.INC []INT.INC 
feclrt.obj : []MOD_SIZ.INC []MC_MULTI.INC []NNS.INC []MODEL.INC []POP.INC []LEVEL.INC []LINE.INC []COLIS.INC 
fecsc.obj : []MOD_SIZ.INC []MC_MULTI.INC []NNS.INC []LEVEL.INC []COLIS.INC 
fit.obj : []INT.INC 
gab.obj : []MOD_SIZ.INC 
gauhff.obj : []OP.INC 
genclrt.obj : []MOD_SIZ.INC []MC_MULTI.INC []NNS.INC []MODEL.INC []POP.INC []LEVEL.INC []LINE.INC []COLIS.INC 
gencsc.obj : []MOD_SIZ.INC []MC_MULTI.INC []NNS.INC []LEVEL.INC []COLIS.INC []MODEL.INC []POP.INC []LINE.INC 
gener.obj : []MOD_SIZ.INC 
heclrt.obj : []MOD_SIZ.INC []COLIS.INC []LINE.INC []LEVEL.INC []NNS.INC []MODEL.INC []POP.INC 
hecsc.obj : []MOD_SIZ.INC []COLIS.INC 
hlinop.obj : []OPALION.INC 
inpedd.obj : []MOD_SIZ.INC 
inpgab.obj : []MOD_SIZ.INC 
inplin.obj : []MOD_SIZ.INC 
iondis.obj : []OPALION.INC 
josh.obj : []MOD_SIZ.INC []MODEL_RA.INC []RAD_RATE.INC []OPAC_RAT.INC 
josh6.obj : []MOD_SIZ.INC []MODEL_RA.INC []RAD_RATE.INC []OPAC_RAT.INC 
linear2.obj : []MOD_SIZ.INC 
lineop.obj : []MOD_SIZ.INC []POP.INC []MODEL.INC []LINE.INC []OPALION.INC 
linop.obj : []MOD_SIZ.INC []MODEL_RA.INC []WAVELE_R.INC []OPAC_RAT.INC 
linopv9.obj : []MOD_SIZ.INC []MODEL_RA.INC []WAVELE_R.INC []OPAC_RAT.INC 
matgen.obj : []MOD_SIZ.INC 
merson.obj : []INT.INC 
mgclrt.obj : []MOD_SIZ.INC []LINE.INC []NNS.INC []MODEL.INC []LEVEL.INC []POP.INC []COLIS.INC 
mgcsc.obj : []MOD_SIZ.INC []NNS.INC []LEVEL.INC []COLIS.INC 
opalam.obj : []OPALION.INC []OP.INC []K.INC 
opalam_nlte.obj : []OPALION.INC []OP.INC []K.INC 
outgab.obj : []MOD_SIZ.INC 
outsta.obj : []MOD_SIZ.INC []NNS.INC []MODEL.INC []LEVEL.INC 
pops.obj : []MOD_SIZ.INC 
ptau.obj : []INT.INC []RE.INC []OPALION.INC 
ptau_new.obj : []INT.INC []RE.INC []OPALION.INC 
qati2_boron.obj : []OPALION.INC 
qmol.obj : []OPALION.INC 
quati1.obj : []OPALION.INC 
quati2.obj : []OPALION.INC 
ratcal.obj : []MOD_SIZ.INC []NNS.INC []MODEL.INC []LEVEL.INC []POP.INC 
rates.obj : []MOD_SIZ.INC []OPALION.INC []WAVELE_R.INC []RE.INC []MODEL_RA.INC []OPAC_RAT.INC []RAD_RATE.INC []WAVE_DAT.INC 
rfield.obj : []MOD_SIZ.INC []OPALION.INC []WAVELE_R.INC []RE.INC []MODEL_RA.INC []OPAC_RAT.INC []RAD_RATE.INC 
stage.obj : []MOD_SIZ.INC []NNS.INC []LEVEL.INC 
start.obj : []MOD_SIZ.INC []NNS.INC []LEVEL.INC []LINE.INC []COLIS.INC 
wrop.obj : []MOD_SIZ.INC []OPAC_RAT.INC []MODEL_RA.INC 
z.obj : []RE.INC 
zeile.obj : []RE.INC []INT.INC 
