	PROGRAM GAB
C ***
C ******************************************************************************
C ***
C ***   Geaenderte Bedeutung von IFTAU: Output fuer jede IFTAUte 
C ***   Tiefenstufe, falls IFTAU > 0; IFTAU = -1: Nur erste und letzte 
C ***   Tiefe, IFTAU = 0: kein Output.
C ***
C ***   Modified output, changed to character
C ***
C ***   11-JAN-1991 11:22:31.27
C ***
C ***	Modifications:
C ***
C ***	 9-FEB-1993 21:56:53.88		ML / UT Austin.  Changed some FORMATs 
C ***					to provide for more than 100 lines.
C ***	11-MAY-1995 12:10:03.00		ML / IoA.  Accomodate new OPA format
C ***	30-APR-1996 13:54:51.14		ML / Bamberg.  New ion stuff,
C ***                                   implicit none
C ***
C ******************************************************************************
	implicit none
C ***
C ***	Files:
C ***
	INTEGER DEPART, OPA, FIXRAD
	PARAMETER( DEPART = 1, FIXRAD = 20, OPA = 23 )
C ***
        INCLUDE 'MOD_SIZ.INC'

C ***
C ***	Local variables
C ***
	INTEGER I, IC, ID, IFDEPE, IFFILE, IFION, IFITER, IFLOGB, IFLPT,
     >          IFPLOT, IFRU, IFSB, IFTAU, II, IID, IJ, ILIN, ILOLD, IT,
     >          ITER, ITT, J, MAP(93), N0, N1, NCI, NCIM1, NKP1
C
      	REAL A(M_LEVELS,M_LEVELS), B, BB0, BCON, BNU(M_LINES), CHANG,
     >       CHIE(50), CHIOLD(50), DM, DUM, FFF, FREQ, H, SIG(50), SUM,
     >       SUM0(0:4), X, XAUX
	REAL BS(M_LEVELS+1), Z(M_LEVELS+1)
	REAL SL(M_LINES), BB(M_LINES), T0(M_LINES), TC(M_LINES),
     >	  CHI(50,M_LINES,2)
	CHARACTER BLANK, VERT, LINE*122
	CHARACTER*132 HEAD
	INTEGER NT0(M_LINES), NTC(M_LINES)
	INTEGER NBS(16), NZ(16), NP(16), NBB(16)

C ***
C ***	Global variables
C ***
	INTEGER LABEL, LOW, NDEPTH, NF1, NJ, NK, NL, NT, UP
	REAL GR
	COMMON /NNS/ NL, NK, NDEPTH, NJ, NT, NF1(M_LINES), LOW(M_LINES),
     >	  UP(M_LINES), GR(M_LINES), LABEL(M_LEVELS+2)

        INTEGER NXTION
        REAL M, N, RHO
	COMMON /MODEL/ M(50), RHO(50), NXTION(M_LEVELS), N(50,M_LEVELS)

	REAL RD, RU, NS
	COMMON /OUTS/ RU(50,M_LINES), RD(50,M_LINES), NS(50,M_LEVELS)

	REAL P, MAXX
	COMMON /TRANS/ P(M_LEVELS,50), MAXX

	EQUIVALENCE( RU(1,1), CHI(1,1,1) )
	EQUIVALENCE( NBS(1), NZ(1), NP(1), NBB(1) )


C ***
C ***	Functions
C ***
	integer mapc
	real xp
	integer idx, stage
	external idx, stage


	DATA BLANK, VERT /' ', '!'/
	DATA MAP /126, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 65, 66,
     >            67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79,
     >            80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 34, 35,
     >            36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 58,
     >            59, 60, 61, 62, 63, 64, 91, 92, 93, 94, 95, 96, 97,
     >            98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108,
     >	          109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119,
     >            120, 121, 122, 123, 124, 125/

	MAPC(I) = MAP( MOD( I, 93 ) + 1 )
C ***                          ^^
C ***                  Change this to 62 to get 98.39% compatibilty with old
C ***                  version (only upper case characters). Change 126 to 95
C ***                  in DATA MAP as well to get 100% compatibility.
C ***
	XP( X ) = EXP( 2.302585*X )


	READ( *, * ) IFLPT, IFFILE, IFITER, IFPLOT, IFDEPE, IFLOGB,
     >	  IFRU, IFION, IFTAU, IFSB
	CALL INPGAB( HEAD, ITER )
	IF( IFTAU .EQ. -1 ) IFTAU = NDEPTH
	CALL POPS( A, IFFILE )
	IF( IFITER .EQ. 1 ) ITER = ITER + 1
	IF( IFLPT .EQ. 0 ) THEN
C ***
C ***	   No lineprinter output, only info line if requested by IFPLOT
C ***
	   IF( IFPLOT .EQ. 1 ) THEN
	      WRITE( *, '(A, I3, A, I4, A, 1PE10.2)' )
     >	        ' GAB:    IFITER=', IFITER, ', ITERATION=', ITER,
     >	        ', MAX(DELTA N/N)=', MAXX
              WRITE(*, '('' '')' )
           END IF
	ELSE
C ***
C ***	   Lineprinter output
C ***
	   WRITE( *, '(''1'', A)' ) HEAD
	   WRITE( *, '(A, I5)' ) ' Iteration ', ITER
	   IF( IFPLOT .EQ. 1 ) THEN
C ***
C ***	      Plot of change in level population
C ***
	      WRITE( *, '(3A, 1PE12.4)' ) ' Plot of relative change in', 
     >          '  l e v e l  p o p u l a t i o n  --- scaling ',
     >	        'factor = ', MAXX
	      WRITE( *, '(10X, I3, 4(27X, I3))' ) ((I - 3)*5, I = 1, 5)
	      DO IID = 1, NDEPTH
	         ID = NDEPTH + 1 - IID
	         LINE = ' '
	         DO I = 2, 122, 30
	            LINE(I:I) = VERT
	         END DO
	         DO IT = 1, NK
	            IC = P(IT,ID)/MAXX*60. + 62.5
	            IC = MIN( MAX( IC, 2 ), 122 )
	            LINE(IC:IC) = CHAR(MAPC(IT))
                 END DO
	         WRITE( *, '( A, I5, 2X, A )' ) ' ID=', ID, LINE
              END DO
	      WRITE( *, '(''0'', 132(''-'') )' )
	      WRITE( *, '( (3X, 14(2X, A, '': '', A4)) )' ) 
     >          (CHAR(MAPC(I)), LABEL(I), I = 1, NK)
	      WRITE( *, '(X, 132(''-''))' )
	   END IF
           IF( IFLOGB .NE. 0 ) THEN
C ***
C ***	      Output of population numbers and departure coefficients
C ***
	      DO N0 = 1, NK, 7
	         N1 = MIN( NK, N0 + 6 )
                 CALL NEWPAGE( NDEPTH, IFLOGB, 2, N0 .EQ. 1 )
	         WRITE( *, '( A, 7(:, ''    LN('', I2, '')  LB('',
     >	           I2, '')'') )' ) ' ID', (I, I, I = N0, N1)
	         WRITE( *, '( 3X, 7(:, ''    ('', A4, '')  ('',
     >	           A4, '')'') )' ) (LABEL(I), LABEL(I), I = N0, N1)
	         DO ID =  1, NDEPTH
	            ILIN = 0
	            DO I = N0, N1
	               II = I - N0 + 1
	               Z(I) = N(ID,I)
	               IF( Z(I) .LE. 0. ) Z(I) = 1.0E-99
	               Z(I) = LOG10( Z(I) )
	               BS(I) = Z(I) - LOG10( NS(ID,I) )
	               IF( ABS( BS(I) ) .GE. 1 ) ILIN = 1
	               XAUX = 10000.0*BS(I)
	               NBS(II) = IFIX( XAUX + SIGN( 0.5, XAUX ) )
                    END DO
	            IF( ID .EQ. 1 .OR. ID .EQ. NDEPTH .OR. 
     >	              MOD( ID, IFLOGB ) .EQ. 0 ) THEN
	               IF( ID .EQ. 1 .OR. ID .EQ. NDEPTH .OR. 
     >	                 ILIN .EQ. 1 .OR. ILOLD .EQ. 1 ) THEN
                          WRITE( *, '(I3, 7(F10.4, F8.4))' ) ID,
     >	                    (Z(I), BS(I), I = N0, N1)
                       ELSE
	                  WRITE( *, '(I3, 7(F10.4, 3X, I5))' ) ID,
     >	                    (Z(I), NBS(I - N0 + 1), I = N0, N1)
                       END IF
                       ILOLD = ILIN
                    END IF
                 END DO
              END DO
           END IF
	   IF( IFRU .NE. 0 ) THEN
C ***
C ***	   Output of net radiative rates
C ***
	      DO N0 = 1, NT, 14
	         N1 = MIN( NT, N0 + 13 )
                 CALL NEWPAGE( NDEPTH, IFRU, 1, N0 .EQ. 1 )
	         WRITE( *, '(A, 14(:, '' NET('', I3, '')''))' ) ' ID',
     >	           (IT, IT = N0, N1)
	         DO ID = 1, NDEPTH
	            ILIN = 0
	            DO IT = N0, N1
	               ITT = IT - N0 + 1
	               I = LOW(IT)
	               J = UP(IT)
	               Z(IT) = 1. - N(ID,J)*RD(ID,IT)/N(ID,I)/RU(ID,IT)
	               IF( ABS( Z(IT) ) .GE. 1 ) ILIN = 1
	               XAUX = 100000.0*Z(IT)
	               NZ(ITT) = IFIX( XAUX + SIGN( 0.5, XAUX ) )
                    END DO
	            IF( ID .EQ. 1 .OR. ID .EQ. NDEPTH .OR. 
     >	              MOD( ID, IFRU ) .EQ. 0 ) THEN
	               IF( ID .EQ. 1 .OR. ID .EQ. NDEPTH .OR.
     >                   ILIN .EQ. 1 .OR. ILOLD .EQ. 1 ) THEN
	                  WRITE( *, '(I3, 14(F9.5))' ) ID, 
     >	                    (Z(IT), IT = N0, N1)
                       ELSE
	                  WRITE( *, '(I3, 14(3X, I6))' ) ID, 
     >	                    (NZ(IT - N0 + 1), IT = N0, N1)
	               END IF
	               ILOLD = ILIN
		    END IF
	         END DO
              END DO
	   END IF
	   IF( IFION .NE. 0 ) THEN
C ***
C ***	      Output of ionization equilibrium
C ***
	      REWIND FIXRAD
	      DO ID = 1, NDEPTH
	         DO J = 1, NK
	            CALL RE1( FIXRAD, A(1,J), NK )
	         END DO
	         READ( FIXRAD ) B
                 do i = 0, 4
	            SUM0(i) = 0.0
                 end do
	         DO I = 1, NL
	            NCI = NXTION(I)
	            NCIM1 = NCI - 1
	            DO J = 1, NCIM1
	               IF( I .NE. J ) A(I,I) = A(I,I) + A(J,I)
                    END DO
	            DUM = A(I,I)*N(ID,I)
	            P(I,ID) = DUM + A(I,NCI)*N(ID,NCI)
                    sum0(stage(i)) = sum0(stage(i)) + dum
                 END DO
	         DO I = 1, NL
	             P(I,ID) = P(I,ID)/SUM0(stage(i))
	         END DO
	      END DO
	      REWIND FIXRAD
	      CLOSE( FIXRAD )
	      DO N0 = 1, NL, 16
	         N1 = MIN( NL, N0 + 15 )
                 CALL NEWPAGE( NDEPTH, IFION, 3, N0 .EQ. 1 )
	         WRITE( *, '(3A, //, A, 16I8)' ) ' Contributions ',
     >	           'PJ of levels to  i o n i z a t i o n  e q u i l',
     >	           ' i b r i u m', ' ID', (I, I = N0, N1)
	         DO ID = 1, NDEPTH
	            ILIN = 0
 	            DO I = N0, N1
	               II = I - N0 + 1
	               IF( ABS( P(I,ID) ) .GE. 1 ) ILIN = 1
	               XAUX = 10000.0*P(I,ID)
	               NP(II) = IFIX( XAUX + SIGN( 0.5, XAUX ) )
	            END DO
	            IF( ID .EQ. 1 .OR. ID .EQ. NDEPTH .OR. 
     >	              MOD(ID, IFION) .EQ. 0 ) THEN
	               IF( ID .EQ. 1 .OR. ID .EQ. NDEPTH .OR. 
     >	                 ILIN .EQ. 1 .OR. ILOLD .EQ. 1 ) THEN
	                  WRITE( *, '(I3, 16F8.4)' ) ID, 
     >	                    (P(I,ID), I = N0, N1)
	               ELSE
	                  WRITE( *, '(I3, 16(3X, I5))' ) ID, 
     >	                    (NP(I - N0 + 1), I = N0, N1)
	               END IF
	               ILOLD = ILIN
	            END IF
                 END DO
              END DO
 	   END IF
	   IF( IFTAU .GT. 0 .OR. IFSB .NE. 0 ) THEN
C ***
C ***	      Preparation for tau line or S/B output
C ***
	      OPEN(UNIT = OPA, FILE = 'OPA', FORM = 'UNFORMATTED')
	      REWIND OPA
	      DO IT = 1, NT
	         N1 = NF1(IT)
	         I = LOW(IT)
	         J = UP(IT)
*	         CALL RE3( OPA, CHIOLD, NDEPTH, SIG, NDEPTH, CHIE,
*     >	           NDEPTH )
	         CALL RE2( OPA, SIG, NDEPTH, CHIE, NDEPTH )

	         CALL RE2( OPA, BNU(IT), 1, FREQ, 1 )

*	         CALL RE2( OPA, SIG, NDEPTH, BS, NDEPTH )
	         CALL RE3( OPA, chiold, ndepth, SIG, NDEPTH, BS, NDEPTH
     >                   )

	         DO ID = 1, NDEPTH
	            CHI(ID,IT,1) = CHIE(ID) + CHIOLD(ID) + 
     >	              SIG(ID)*(N(ID,I) - GR(IT)*N(ID,J))/RHO(ID)
	         END DO
	         DO IJ = 2, N1
*	            CALL RE2( OPA, SIG, NDEPTH, BS, NDEPTH )
	            CALL RE3( OPA, chiold, ndepth, SIG, NDEPTH, BS,
     >                        NDEPTH )
	         END DO
	         DO ID = 1, NDEPTH
	            CHI(ID,IT,2) = CHIE(ID) + CHIOLD(ID) + 
     >	              SIG(ID)*(N(ID,I) - GR(IT)*N(ID, J))/RHO(ID)
	         END DO
              END DO
	      REWIND OPA
	      CLOSE(OPA)
	      IF( IFTAU .GT. 0 ) THEN
C ***
C ***            Output of tau line
C ***
	         DO N0 = 1, NT, 7
	            N1 = MIN( NT, N0 + 6 )
                    CALL NEWPAGE( NDEPTH, IFTAU, 2, N0 .EQ. 1 )
C ***                                            ^
C ***                                            +Footline
	            WRITE( *, '(A, 7(:, ''  LT0('', I3, 
     >	              '')  Log Tc'') )' )  ' ID', (IT, IT = N0, N1)
C ***
	            ID = 1
	            DO IT = N0, N1
	               T0(IT) = LOG10( 0.5*M(ID)*CHI(ID,IT,1) )
	               TC(IT) = LOG10( 0.5*M(ID)*CHI(ID,IT,2) )
	               NT0(IT) = 0
	               NTC(IT) = 0
	               IF( T0(IT) .LE. 0. ) THEN
	                  NT0(IT) = ID
	                  NTC(IT) = ID
	               END IF
	            END DO
		    WRITE( *, '( I3, 7(X, F9.4, F8.4) )' ) ID, 
     >	              (T0(IT), TC(IT), IT = N0, N1)
C ***
	            DO ID = 2, NDEPTH
	               DM = 0.5*(M(ID) - M(ID - 1))
	               DO IT = N0, N1
	                  T0(IT) = LOG10( XP( T0(IT) ) +
     >	                           DM*(CHI(ID,IT,1) + CHI(ID - 1,IT,1)))
	                  TC(IT) = LOG10( XP( TC(IT) ) +
     >	                           DM*(CHI(ID,IT,2) + CHI(ID - 1,IT,2)))
	                  IF( T0(IT) .LE. 0. ) THEN
	                     NT0(IT) = ID
	                     NTC(IT) = ID
                          END IF
	               END DO
	               IF( MOD( ID, IFTAU ) .EQ. 0 .OR. ID .EQ. NDEPTH )
     >	                 WRITE( *, '( I3, 7(X, F9.4, F8.4))' ) ID, 
     >	                   (T0(IT), TC(IT), IT = N0, N1)
	            END DO
	            WRITE( *, '(''  N'', 7(X, I9, I8))' ) (NT0(IT),
     >	              NTC(IT), IT = N0, N1)
                 END DO
	      END IF
	      IF( IFSB .NE. 0 ) THEN
C ***
C ***	         Output of S/B
C ***
	         DO N0 = 1, NT, 14
	            N1 = MIN( NT, N0 + 13 )
                    CALL NEWPAGE( NDEPTH, IFSB, 2, N0 .EQ. 1 )
	            WRITE( *, '(A, 14(:, A, ''  L(S/B)'') )' )  ' ID',
     >	              (' ', IT = N0, N1)
	            WRITE( *, '(3X, 14(:, ''    ('', I3, '')'') )' )
     >	              (IT, IT = N0, N1)
	            DO ID = 1, NDEPTH
	               ILIN = 0
	               DO IT = N0, N1
	                  ITT = IT - N0 + 1
	                  I =  LOW(IT)
	                  J =  UP(IT)
	                  BB0 =  BNU(IT)
	                  H = BB0/(N(ID,I)/(GR(IT)*N(ID,J)) - 1.0E00)
	                  IF( H .LE. 0 ) H = 1.0E-99
	                  SL(IT) = LOG10( H )
	                  BB(IT) = SL(IT) - LOG10(
     >	                    BB0/(NS(ID,I)/(GR(IT)*NS(ID,J)) - 1.0E00) )
	                  IF( ABS( BB(IT) ) .GE. 1 ) ILIN = 1
	                  XAUX = 10000.0*BB(IT)
	                  NBB(ITT) = IFIX( XAUX + SIGN( 0.5, XAUX ) )
	               END DO
	               IF( ID .EQ. 1 .OR. ID .EQ. NDEPTH .OR.
     >	                 MOD( ID, IFSB ) .EQ. 0 ) THEN
	                  IF( ID .EQ. 1 .OR. ID .EQ. NDEPTH .OR.
     >	                    ILIN .EQ. 1 .OR. ILOLD .EQ. 1 ) THEN
	                     WRITE( *, '(I3, 14(F9.4))' ) ID, 
     >	                       (BB(IT), IT = N0, N1)
	                  ELSE
	                     WRITE( *, '(I3, 14(4X, I5))' ) ID, 
     >	                       (NBB(I - N0 + 1), I = N0, N1)
	                  END IF
	                  ILOLD = ILIN
	               END IF
                    END DO
                 END DO
	      END IF
 	   END IF
	   IF( IFPLOT .EQ. 1 ) THEN
C ***
C ***	      Output of departure plot
C ***
	      WRITE( *, '(''1'', A)' ) HEAD
	      WRITE( *, '( '' Iteration '', I5)' ) ITER
	      WRITE( *, '(A)' ) 
     >	        ' Plot  of   l o g   d e p a r t u r e s '
	      WRITE( *, '( 10X, F4.1, 5(16X, F4.1), 15X, F4.1 )' ) 
     >          (FFF, FFF = -2., 1., 0.5 )
	      DO IID = 1, NDEPTH
	         ID = NDEPTH + 1 - IID
	         LINE = ' '
	         DO I = 2, 122, 20
	            LINE(I:I) = VERT
	         END DO
	         BCON = N(ID,NK)/NS(ID,NK)
	         DO IT = 1, NK
	            CHANG = LOG10( ABS( N(ID,IT) )/NS(ID,IT) )
	            IF( IT .EQ. NK ) CHANG = LOG10( ABS( BCON ) )
	            IC = CHANG*40. + 82.5
	            IC = MIN( MAX( IC, 2 ), 122 )
	            LINE(IC:IC) = CHAR(MAPC(IT))
C                   IF( CHANG .GT. 0. ) LINE(IC - 1) = MINUS
	         END DO
	         WRITE( *, '( A, I5, 2X, A )' ) ' ID=', ID, LINE
	      END DO
	      WRITE( *, '(''0'', 132(''-''))' )
	      WRITE( *, '( (3X, 14(2X, A, '': '', A4)) )' ) 
     >          (CHAR(MAPC(I)), LABEL(I), I = 1, NK)
	      WRITE( *, '(X, 132(''-''))' )
	   END IF
           WRITE(*, '('' '')' )
	END IF
	IF( IFDEPE .EQ. 1 ) THEN
C ***
C ***	   Write DEPART.DAT
C ***
	   OPEN( DEPART, FILE = 'DEPART' )
	   REWIND DEPART
	   NKP1 = NK + 1
	   BS(NKP1) = 1.
	   LABEL(NKP1) = 4h LTE
	   WRITE( DEPART, '(I4, 2X, A)' ) NKP1, HEAD(:IDX(HEAD))
	   WRITE( DEPART, '(5(1X, A4))' ) (LABEL(I), I = 1, NKP1)
	   WRITE( DEPART, '(I8)' ) LABEL(NKP1 + 1)
	   DO ID = 1, NDEPTH
	      BCON = N(ID,NK)/NS(ID,NK)
	      DO I = 1, NL
	         BS(I) = N(ID,I)/NS(ID,I)
              END DO
	      BS(NK) = BCON
	      WRITE( DEPART, '(5E15.7)' ) (BS(I), I = 1, NKP1)
	   END DO
	   REWIND DEPART
	   CLOSE(DEPART)
	END IF
	CALL OUTGAB( HEAD, ITER )
	END
	function stage( level )
	implicit none
C ***
C ***	Returns ion stage of level #level.  0..3 for El I .. El IV
C ***
C ***	29-APR-1996 16:15:01.21		ML / Bamberg.  Created.
C ***

	integer stage, level

        include 'MOD_SIZ.INC'

	INTEGER LABEL, LOW, NDEPTH, NF1, NJ, NK, NL, NT, UP
	REAL GR
	COMMON /NNS/ NL, NK, NDEPTH, NJ, NT, NF1(M_LINES), LOW(M_LINES),
     >	  UP(M_LINES), GR(M_LINES), LABEL(M_LEVELS+2)

        INTEGER NXTION
        REAL M, N, RHO
	COMMON /MODEL/ M(50), RHO(50), NXTION(M_LEVELS), N(50,M_LEVELS)

	integer il


	stage = mod( label( nk + 2 ), 100 )
	
	il = nxtion(1)
	do while( il .le. level )
           stage = stage + 1
	   il = nxtion(il)
	end do

	end
