      FUNCTION GAUHBF( N, alam, zion2 )
      implicit none
C ***
C *****************************************************************************
C ***
C     GAUNT FACTOR:HYDROGENIC ION,LEVEL N
C     KARZAS&LATTER(1961)
C     ASSUMIN FREQUENCY-INDEPENDENT G=G AT THRESHOLD
C ***
C ***
C *** N		I >	quantum number
C *** ALAM	R >     wavelength  [A]
C *** zion2	R >     ion charge squared
C *** GAUHBF    R <     Gaunt factor
C ***
C ***
C ***
C *** 24-APR-1997 17:25:56.00	ML / Bamberg.  Added some frequency
C ***                           dependency from the Gingerich 1969 fit
C ***                           formula to the Karzas&Latter data, as in
C ***                           Kurucz' code and Uli's.
C ***                           However, this fit does not seem to
C ***                           reproduce the decline to higher energies
C ***                           but increases to infinity instead.  UV!
C ***
C *****************************************************************************
C ***
      integer n
      real alam, zion2, gauhbf

      real aln10, boltzk, hplanc, clight
      COMMON/CONST/ALN10,BOLTZK,HPLANC,CLIGHT
     
      integer m
      real G(15), ag(6), bg(6), cg(6)

      DATA(G(M),M=1,15)/0.7973,0.8761,0.9075,0.9247,0.9358,0.9436,
     1 0.9494,0.9540,0.9576,0.9606,0.9632,0.9653,0.9672,0.9689,0.9703/

      data ag /0.9916, 1.105, 1.101, 1.101, 1.102, 1.0986/
      data bg /2.719e13, -2.375e14, -9.863e13, -5.765e13, -3.909e13,
     >        -2.704e13/
      data cg /-2.268e30, 4.077e28, 1.035e28, 4.593e27, 2.371e27,
     >         1.229e27/
      
       
      if( n .ge. 7 ) then
         GAUHBF = G(N)
      else
         gauhbf = ag(n)/zion2 + 1.e-8*alam/clight*( bg(n) + 
     >            cg(n)*zion2*1.e-8*alam/clight )
      end if


      END
