        subroutine hlinop( lam, t, pele, ahline )
        implicit none
C ***
C ******************************************************************************
C ***
C ***	Computes crummy approximation for H line opacity.  Stolen from ATLAS9.
C ***
C ***	lam:	in	wavelength [] at which to compute opacity
C ***	t:	in	temperature [K]
C ***	pele:	in	electron pressure [dyn/cm^2]
C ***	ahline:	out	opacity
C ***
C ***
C ***	calls STARK and AHYLBF
C ***
C ***	14-FEB-1994 16:03:34.00		ML / IoA
C ***
C ******************************************************************************
C ***

C ***
C ***	Arguments
C ***
	real lam, t, pele, ahline


C ***
C ***	Global variables
C ***
	include 'OPALION.INC'

C ***
C ***	local variables
C ***
	integer m, m1, m2, mlast, mfreq, n
	real ehvkt, freq, kt, ktev, ne, bolt(4), oldt


C ***
C ***	Functions
C ***
	real stark, ahylbf

	save oldt, kt, ktev, ne, ehvkt, mlast, bolt
	data oldt /-5./

C ***
C ***	Code
C ***
        ahline = 0.
	freq = 2.997925e18/lam
        n = sqrt( 3.28805E15/freq )
        if( n .le. 0 .or. n .gt. 4 ) then
	   return
        else if( n .eq. 1 .and. freq .lt. 2.e15 ) then
           return
        else if( n .eq. 2 .and. freq .lt. 4.44e14 ) then
	   return
        end if


	if( t .ne. oldt ) then
	   kt = 1.38063e-16*t
	   ktev = kt/1.602192e-12
	   ne = pele/kt
	   ehvkt = exp( -freq/kt*6.6262e-27 )

           mlast = 1100./ne**.133333333
           do 1 m = 1, 4
              bolt( m ) = exp( -(13.595 - 13.595/(m*m))/ktev )*
     >                    2.*m*m*zetaj( jiz(1) )
1          continue
	   oldt = t
	end if
         
        mfreq = sqrt( 3.28805E15/(3.28805E15/(n*n) - freq) )
        m1 = mfreq
        m2 = m1 + 1
        m1 = max( m1, n + 1 )
        if( m1 .gt. 6 ) then
           if( m1 .gt. mlast ) then
              ahline = ahylbf( 1., lam*lam*lam, n )*
     >                 ( 1. - ehvkt )*bolt( n )*6.65246e-25
	      return

           else
              m1 = m1 - 1
              m2 = m2 + 3
              if( n .eq. 4 .and. m1 .le. 8 ) then
                 ahline = stark( 3, 4, freq, t, pele )*( 1. - ehvkt )*
     >                    bolt( 3 )
              end if
	   end if
	end if

        do 6 m = m1, m2
C ***   
C          ASSUMING FREQ APROXIMATELY FREQNM
C ***   
           ahline = ahline + stark( n, m, freq, t, pele )*
     >              ( 1. - ehvkt )*bolt(n)
6       continue
        end
