	subroutine insert( x, a, n )
C ***
C ******************************************************************************
C ***
C ***	Inserts point X into array A such that A is sorted in ascending order.
C ***
C ***	x	>  r	point to insert
C ***	a	>< r	sorted array
C ***	n	>< i	number of points in array, set to 0 before first call
C ***
C ***
C ***	Modifications:
C ***
C ***	22-MAY-1995 15:21:39.00		ML / IoA.  Created.
C ***	26-MAY-1995 17:01:30.00		ML / IoA.  Fuzzy compare for duplicates
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	real x
	integer n
	real a( n + 1 )

C ***
C ***	Local variables
C ***
	integer i, j



C ***
C *** 	Find location for new x
C ***
	do i = n, 1, -1
	   if( x .ge. a(i) ) go to 1
	end do
1	continue

C ***
C ***	Skip duplicates.  Need to test both array elements as
C ***	test above might have round off error
C ***
	if( abs(x - a(i+1)) .le. abs(x*1.e-14) ) return
	if( i .gt. 0 ) then
	   if( abs(x - a(i)) .le. abs(x*1.e-14) ) return	
	end if

C ***
C ***	Make room for x
C ***
	do j = n, i + 1, -1
	   a(j+1) = a(j)
	end do

C ***
C ***	Insert x
C ***
	a(i+1) = x
        n = n + 1

	end
