        subroutine linopv9( n, nsteps, stepwt, avemat )
C ***
C ******************************************************************************
C ***
C ***	Reading of ATLAS9 ODF for fixed microturbulence.
C ***
C ***	Stolen from ATLAS9.
C ***
C ***	23-MAR-1993 21:00:04.00		ML / UT Austin.
C ***	 7-MAR-1996 19:36:41.18		ML / Bamberg.  Set wlbeg such that no
C ***                                   rewind performed initially.  This is
C ***                                   to allow for reading from named pipe.
C ***	25-SEP-2001 21:51:56.00		ML / Stegaurach.  Declare wlbeg, wlend
C ***					as real*8.  (single/double precision 
C ***					issue.)
C ***
C ******************************************************************************
C ***
	implicit none
C ***
C ***	Arguments
C ***
	integer n, nsteps
	real stepwt, avemat

C ***
C ***	Global variables
C ***
	include 'MOD_SIZ.INC'

	include 'MODEL_RA.INC'

	include 'WAVELE_R.INC'

	include 'OPAC_RAT.INC'

C ***
C ***	Local variables
C ***
	real tenlog
	parameter( tenlog = 2.30258509299405 )

        integer*2 kap( 21, 56, 12 )
*        integer kap_packed( 21*56*12/4 )
	integer it, ip, iv, j
        real wt( 12 )
	real tl, plog, x, y, wave, stepsc

	integer n12
	real*8 wlbeg, wlend
        real*4 co1( m_depth ), co2( m_depth ), co3( m_depth ), 
     >         co4( m_depth ), co5( m_depth ), co6( m_depth ), a

        integer ipj( m_depth ), itj( m_depth ), ivj( m_depth )
	logical first

        real tabt( 56 ), tabp( 21 ), tabv( 5 )

C ***
C ***	Functions
C ***
	real xp
	save

	xp( x ) = exp( x*tenlog )

        data tabt /3.32, 3.34, 3.36, 3.38, 3.40, 3.42, 3.44, 3.46, 3.48,
     >       3.50, 3.52, 3.54, 3.56, 3.58, 3.60, 3.62, 3.64, 3.66, 3.68,
     >       3.70, 3.73, 3.76, 3.79, 3.82, 3.85, 3.88, 3.91, 3.94, 3.97,
     >       4.00, 4.05, 4.10, 4.15, 4.20, 4.25, 4.30, 4.35, 4.40, 4.45,
     >       4.50, 4.55, 4.60, 4.65, 4.70, 4.75, 4.80, 4.85, 4.90, 4.95,
     >       5.00, 5.05, 5.10, 5.15, 5.20, 5.25, 5.30/
        data tabp /-2., -1.5, -1., -.5, 0., .5, 1., 1.5, 2., 2.5, 3.,
     >       3.5, 4., 4.5, 5., 5.5, 6., 6.5, 7.0, 7.5, 8.0/
        data tabv /0., 1.D5, 2.D5, 4.D5, 8.D5/
        data first /.true./

        if( first ) then
           first = .false.
           do 5 j = 1, ndepth
              tl = min( max( 3.32, log10(temp(j)) ), 5.3 )
              do 1 it = 2, 56
                 if( tl .lt. tabt(it) ) go to 2
1             continue
              it = 56
2             continue

	      plog = min( max( -2.0, pglg(j) 
     >                       ), 8.0 )
              do 3 ip = 2, 21
                 if( plog .lt. tabp(ip) ) go to 4
3             continue
              ip = 21
4	      continue

C   13        VTUR=DMIN1(DMAX1(VTURB(J),0.D5),8.0D5)
C             DO 14 IV=2,5
C             IF(VTUR.LT.TABV(IV))GO TO 15
C   14        CONTINUE
C             IV=5

              ipj( j ) = ip
              itj( j ) = it
C             IVJ(J)=IV

              x = ( tl - tabt(it - 1) )/( tabt(it) - tabt(it - 1) )
              y = ( plog - tabp(ip - 1) )/( tabp(ip) - tabp(ip - 1) )
C             Z=(VTUR-TABV(IV-1))/(TABV(IV)-TABV(IV-1))

C             The steps have been scaled by 1000
              co1( j ) = ( 1. - x )*( 1. - y )*tenlog*.001
              co2( j ) = ( 1. - x )*y*tenlog*.001
              co3( j ) = x*( 1. - y )*tenlog*.001
              co4( j ) = x*y*tenlog*.001
C             CO5(J)=Z
C             CO6(J)=1.-Z

5          continue

           wt( 1 ) = 1./60.
           wt( 2 ) = 2./60.
           wt( 3 ) = 3./60.
           wt( 4 ) = 6./60.
           wt( 5 ) = 6./60.
           wt( 6 ) = 6./60.
           wt( 7 ) = 6./60.
           wt( 8 ) = 6./60.
           wt( 9 ) = 6./60.
           wt( 10 ) = 6./60.
           wt( 11 ) = 6./60.
           wt( 12 ) = 6./60.

           wlbeg = 0.	! suppress rewind on start
           wlend = 0.
        end if

        wave = 0.1*lambda
	if( wave .lt. wlbeg ) then      
           rewind 9
           wlend = 0.
        end if

        do while( wave .ge. wlend )

*           read( 9 ) wlbeg, wlend, kap_packed
*          call unpack_odf( kap, kap_packed, 21*56*12 )

          read( 9 ) wlbeg, wlend, kap

           if( wlend .gt. 9999. ) wlend = 1 000 000.

        end do

        nsteps = 12
        n12 = 13 - n
        stepwt = wt( n )
	if( lambda .ge. sclmin .and. lambda .le. sclmax ) then
           stepsc = scdf
        else
           stepsc = 1.
	end if

        do 7 j = 1, ndepth
           it = itj( j )
           ip = ipj( j )
C          IV=IVJ(J)

C          A=EXP((CO1(J)*KAP(IP-1,IT-1,N12,IV  )+
C     1       CO2(J)*KAP(IP  ,IT-1,N12,IV  )+
C     2       CO3(J)*KAP(IP-1,IT  ,N12,IV  )+
C     3       CO4(J)*KAP(IP  ,IT  ,N12,IV  ))*CO5(J)+
C     4      (CO1(J)*KAP(IP-1,IT-1,N12,IV-1)+
C     5       CO2(J)*KAP(IP  ,IT-1,N12,IV-1)+
C     6       CO3(J)*KAP(IP-1,IT  ,N12,IV-1)+
C     7       CO4(J)*KAP(IP  ,IT  ,N12,IV-1))*CO6(J))

           a = exp( co1(j)*kap(ip - 1, it - 1, n12) +
     >              co2(j)*kap(ip, it - 1, n12) +
     >              co3(j)*kap(ip - 1, it, n12) + 
     >              co4(j)*kap(ip, it, n12)
     >            )
           rline( j ) = stepsc*a*avemat
7       continue
        end
