      SUBROUTINE OPALAM(ALAM,TEMP,PELE,DENSNC,MODE,OKAPPA,OSIGMA)
C ***
C ******************************************************************************
C ***
C *** Modified to print readable absorber descriptions.
C ***
C ***
C ***   25-NOV-1991 23:17:25.27         ML / UT Austin   
C ***	25-APR-1996 18:28:23.23		ML / Bamberg.  OPALION.INC, 5 ion stages
C ***	 7-AUG-1997 18:52:18.26		ML / Bamberg.  DCHI on H edge wavelength
C ***
C ******************************************************************************
C ***
      include 'OPALION.INC'
      INCLUDE 'OP.INC'
      INCLUDE 'K.INC'
      COMMON/CONST/ALN10,BOLTZK,HPLANC,CLIGHT
      CHARACTER*16 NAM(40)
C ***
      PARAMETER( REAMIN = 1.E-37 )
C ***

      HNU=HPLANC*CLIGHT/ALAM/1.E-8
      AKT=BOLTZK*TEMP
      ALAM3=ALAM*ALAM*ALAM
      X=EXP(-HNU/AKT)
      STIMEM=1.-X
      BLAM=2.*HPLANC*CLIGHT*CLIGHT/(1./X-1.)*1.E20/ALAM3*1.E20/ALAM/ALAM
      DENSEL=PELE/AKT
      ATHOMS=6.65246E-25
      RYD=2.17992E-11
      ERGEV=1.602192E-12
      K=0
C
C     SCATTERING:K=1...KSCAT
C     THOMSON SCATTERING OF FREE ELECTRONS(REST FRAME)
      K=K+1
      NAMK(K)=-1
      OPAC(K)=DENSEL/DENSNC
C
C     RAYLEIGH SCATTERING OF HI,HEI,H2
C     HYDROGEN
      K=K+1
      J=JIZ(1)
      G=2.
      NAMK(K)=NAMJ(J)
      OPAC(K)=ARAYL(NAMJ(J),ALAM)*G*ZETAJ(J)
C     HELIUM
      K=K+1
      J=JIZ(2)
      G=1.
      NAMK(K)=NAMJ(J)
      OPAC(K)=ARAYL(NAMJ(J),ALAM)*G*ZETAJ(J)
C     MOLECULAR HYDROGEN
      K=K+1
      J1=JNEGI+1
      DO 10 J=J1,JMOL2
      IF(NAMJ(J).EQ.1000100)J2=J
   10 CONTINUE
      NAMK(K)=NAMJ(J2)
      OPAC(K)=ARAYL(NAMJ(J2),ALAM)*FRACJ(J2)
C
      KSCAT=K
C
C     TRUE ABSORPTION
C
C     FREE-FREE ABSORPTION:HYDROGEN
      K=K+1
      J=JIZ(1)
      NAMK(K)=NAMJ(J)
      OPAC(K)=AHYLFF(1.,ALAM,TEMP)*STIMEM*DENSEL*FRACJ(J+1)
C
C     FREE-FREE ABSORPTION:HELIUM THROUGH NICKEL
C     ASSUMING 4 STAGES PER ELEMENT:I,II,III,IV
      K=K+1
      A1=AHYLFF(1.,ALAM,TEMP)
      A2=AHYLFF(2.,ALAM,TEMP)
      A3=AHYLFF(3.,ALAM,TEMP)
      X=0.
      J1=JIZ(2)
      J2=JIZ(28)
      DO 20 J=J1,J2,5
   20 X=X+A1*FRACJ(J+1)+A2*FRACJ(J+2)+A3*FRACJ(J+3)
      NAMK(K)=NAMJ(J2)
      OPAC(K)=X*STIMEM*DENSEL
C
C     FREE-FREE ABSORPTION:NEGATIVE HYDROGEN ION
      K=K+1
      J=JIZ(1)
      NAMK(K)=-101
      OPAC(K)=AHMIFF(ALAM,TEMP)*2.*PELE*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:HYDROGEN
      K=K+1
      J=JIZ(1)
!      EI=RYD - ergev*4.98e-4*5040./temp*sqrt(pele)
      EI=RYD
C     HYDROGEN:N=1...14
      X=0.
      DO 60 N=1,14
         A2=FLOAT(N*N)
         EN=RYD*(1.-1./A2)
         HNUN=EI-EN
         N1=N
         IF(HNU.GE.HNUN)X=X+AHYLBF(1.,ALAM3,N1)*A2*EXP(-EN/AKT)
   60 CONTINUE
      NAMK(K)=NAMJ(J)
      OPAC(K)=X*STIMEM*2.*ZETAJ(J)
C     HYDROGEN:N=15
      K=K+1
      NAMK(K)=NAMJ(J)+15
      EN=EI*(1.-1./225.)
      HNUN=EI-EN
      OPAC(K)=0.
      IF(HNU.GE.HNUN)OPAC(K)=
     1 AHYLBF(1.,ALAM3,15)*225.*EXP(-EN/AKT)*STIMEM*2.*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:NEGATIVE HYDROGEN ION
      K=K+1
      J1=JATI+1
      DO 70 J=J1,JNEGI
      IF(NAMJ(J).EQ.-101)J2=J
   70 CONTINUE
      NAMK(K)=NAMJ(J2)
      OPAC(K)=AHMIBF(ALAM)*STIMEM*FRACJ(J2)
C
C     HYDROGEN QUASI-MOLECULE H2
      K=K+1
      NAMK(K)=1000100
      J=JIZ(1)
      OPAC(K)=AH2Q(ALAM,TEMP)*DENSNC*STIMEM*FRACJ(J)*FRACJ(J)
C
C     HYDROGEN MOLECULAR ION H2+
      K=K+1
      NAMK(K)=1000101
      J=JIZ(1)
      OPAC(K)=AH2P(ALAM,TEMP)*DENSNC*FRACJ(J+1)*2.*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:HELIUM I
      K=K+1
      J=JIZ(2)
      NAMK(K)=NAMJ(J)
      X=0.
      DO 75 M=1,9
      I=M
      CALL AHE1BF(ALAM,I,ALAMM,E,G,A)
      IF(ALAM.LE.ALAMM)X=X+A*G*EXP(-E*ERGEV/AKT)
   75 CONTINUE
      OPAC(K)=X*STIMEM*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:HELIUM II
      K=K+1
      J=JIZ(2)+1
      EI=RYD*4.
      X=0.
      DO 65 N=1,15
      A2=FLOAT(N*N)
      EN=EI*(1.-1./A2)
      HNUN=EI-EN
      N1=N
      IF(HNU.GE.HNUN)X=X+AHYLBF(16.,ALAM3,N1)*A2*EXP(-EN/AKT)
   65 CONTINUE
      NAMK(K)=NAMJ(J)
      OPAC(K)=X*STIMEM*2.*ZETAJ(J)
C
C     FREE-FREE ABSORPTION:NEGATIVE HELIUM ION
      K=K+1
      J=JIZ(2)
      NAMK(K)=-201
      OPAC(K)=AHEMFF(ALAM,TEMP)*ZETAJ(J)*PELE
C
C     BOUND-FREE ABSORPTION:NEGATIVE CARBON ION
      K=K+1
      J1=JATI+1
      DO 80 J=J1,JNEGI
      IF(NAMJ(J).EQ.-601)J2=J
   80 CONTINUE
      NAMK(K)=NAMJ(J2)
      OPAC(K)=ACMI(ALAM)*STIMEM*FRACJ(J2)
C
C     BOUND-FREE ABSORPTION:CARBON I
      K=K+1
      J=JIZ(6)
      NAMK(K)=NAMJ(J)
      X=0.
      DO 90 M=1,13
      I=M
      CALL AC1BF(ALAM,I,ALAMM,E,G,A)
      IF(ALAM.LE.ALAMM)X=X+A*G*EXP(-E*ERGEV/AKT)
   90 CONTINUE
      OPAC(K)=X*STIMEM*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:NITROGEN I
      K=K+1
      J=JIZ(7)
      NAMK(K)=NAMJ(J)
      X=0.
      DO 100 M=1,13
      I=M
      CALL AN1BF(ALAM,I,ALAMM,E,G,A)
      IF(ALAM.LE.ALAMM)X=X+A*G*EXP(-E*ERGEV/AKT)
  100 CONTINUE
      OPAC(K)=X*STIMEM*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:OXYGEN I
      K=K+1
      J=JIZ(8)
      NAMK(K)=NAMJ(J)
      X=0.
      DO 110 M=1,12
      I=M
      CALL AO1BF(ALAM,I,ALAMM,E,G,A)
      IF(ALAM.LE.ALAMM)X=X+A*G*EXP(-E*ERGEV/AKT)
  110 CONTINUE
      OPAC(K)=X*STIMEM*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:NEON I
      K=K+1
      J=JIZ(10)
      NAMK(K)=NAMJ(J)
      X=0.
      DO 120 M=1,1
      I=M
      CALL ANE1BF(ALAM,I,ALAMM,E,G,A)
      IF(ALAM.LE.ALAMM)X=X+A*G*EXP(-E*ERGEV/AKT)
  120 CONTINUE
      OPAC(K)=X*STIMEM*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:SODIUM I
      K=K+1
      J=JIZ(11)
      NAMK(K)=NAMJ(J)
      X=0.
      DO 130 M=1,5
      I=M
      CALL ANA1BF(ALAM,I,ALAMM,E,G,A)
      IF(ALAM.LE.ALAMM)X=X+A*G*EXP(-E*ERGEV/AKT)
  130 CONTINUE
      OPAC(K)=X*STIMEM*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:MAGNESIUM I
      K=K+1
      J=JIZ(12)
      NAMK(K)=NAMJ(J)
      X=0.
      DO 140 M=1,5
      I=M
      CALL AMG1BF(ALAM,I,ALAMM,E,G,A)
      IF(ALAM.LE.ALAMM)X=X+A*G*EXP(-E*ERGEV/AKT)
  140 CONTINUE
      OPAC(K)=X*STIMEM*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:MAGNESIUM II
      K=K+1
      J=JIZ(12)+1
      NAMK(K)=NAMJ(J)
      X=0.
      DO 150 M=1,2
      I=M
      CALL AMG2BF(ALAM,I,ALAMM,E,G,A)
      IF(ALAM.LE.ALAMM)X=X+A*G*EXP(-E*ERGEV/AKT)
  150 CONTINUE
      OPAC(K)=X*STIMEM*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:ALUMINIUM I
      K=K+1
      J=JIZ(13)
      NAMK(K)=NAMJ(J)
      X=0.
      DO 160 M=1,2
      I=M
      CALL AAL1BF(ALAM,I,ALAMM,E,G,A)
      IF(ALAM.LE.ALAMM)X=X+A*G*EXP(-E*ERGEV/AKT)
  160 CONTINUE
      OPAC(K)=X*STIMEM*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:SILICON I
      K=K+1
      J=JIZ(14)
      NAMK(K)=NAMJ(J)
      X=0.
      DO 170 M=1,5
      I=M
      CALL ASI1BF(ALAM,I,ALAMM,E,G,A)
      IF(ALAM.LE.ALAMM)X=X+A*G*EXP(-E*ERGEV/AKT)
  170 CONTINUE
      OPAC(K)=X*STIMEM*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:SILICON II
      K=K+1
      J=JIZ(14)+1
      NAMK(K)=NAMJ(J)
      X=0.
      DO 180 M=1,1
      I=M
      CALL ASI2BF(ALAM,I,ALAMM,E,G,A)
      IF(ALAM.LE.ALAMM)X=X+A*G*EXP(-E*ERGEV/AKT)
  180 CONTINUE
      OPAC(K)=X*STIMEM*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:CALCIUM I
      K=K+1
      J=JIZ(20)
      NAMK(K)=NAMJ(J)
      X=0.
      DO 190 M=1,3
      I=M
      CALL ACA1BF(ALAM,I,ALAMM,E,G,A)
      IF(ALAM.LE.ALAMM)X=X+A*G*EXP(-E*ERGEV/AKT)
  190 CONTINUE
      OPAC(K)=X*STIMEM*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:CALCIUM II
      K=K+1
      J=JIZ(20)+1
      NAMK(K)=NAMJ(J)
      X=0.
      DO 200 M=1,3
      I=M
      CALL ACA2BF(ALAM,I,ALAMM,E,G,A)
      IF(ALAM.LE.ALAMM)X=X+A*G*EXP(-E*ERGEV/AKT)
  200 CONTINUE
      OPAC(K)=X*STIMEM*ZETAJ(J)
C
C     BOUND-FREE ABSORPTION:IRON I
      K=K+1
      J=JIZ(26)
      NAMK(K)=NAMJ(J)
      X=0.
      DO 210 M=1,1
      I=M
      CALL AFE1BF(ALAM,I,ALAMM,E,G,A)
      IF(ALAM.LE.ALAMM)X=X+A*G*EXP(-E*ERGEV/AKT)
  210 CONTINUE
      OPAC(K)=X*STIMEM*ZETAJ(J)
C
C
      KABS=K
      OSIGMA=0.
      DO 40 K=1,KSCAT
   40 OSIGMA=OSIGMA+OPAC(K)
      OSIGMA=OSIGMA*ATHOMS
      J1=KSCAT+1
      OKAPPA=0.
      DO 42 K=J1,KABS
   42 OKAPPA=OKAPPA+OPAC(K)
      OKAPPA=OKAPPA*ATHOMS
C
C
C     PRINTOUT IF MODE=2
      IF( MODE .EQ. 2 ) THEN
         NAM(1) = 'Thomson scat.'
         NAM(2) = 'Ray. scat. H'
         NAM(3) = 'Ray. scat. He'
         NAM(4) = 'Ray. scat. H2'
         NAM(5) = 'f-f H'
         NAM(6) = 'f-f all but H'
         NAM(7) = 'f-f H -'
         NAM(8) = 'b-f H (n=1...14)'
         NAM(9) = 'b-f H (n=15...)'
         NAM(10) = 'b-f H -'
         NAM(11) = 'b-f H2'
         NAM(12) = 'b-f H2 +'
         NAM(13) = 'b-f He I'
         NAM(14) = 'b-f He II'
         NAM(15) = 'f-f He -'
         NAM(16) = 'b-f C -'
         NAM(17) = 'b-f C I'
         NAM(18) = 'b-f N I'
         NAM(19) = 'b-f O I'
         NAM(20) = 'b-f Ne I'
         NAM(21) = 'b-f Na I'
         NAM(22) = 'b-f Mg I'
         NAM(23) = 'b-f Mg II'
         NAM(24) = 'b-f Al I'
         NAM(25) = 'b-f Si I'
         NAM(26) = 'b-f Si II'
         NAM(27) = 'b-f Ca I'
         NAM(28) = 'b-f Ca II'
         NAM(29) = 'b-f Fe I'
         WRITE( 6, '(5(/), 2A, /,
     >              X, F10.1, F10.0, F10.3, 1P, 3E12.3, /, 
     >              A, /,
     >              A)' )
     >    '     Lambda      Temp    Log Pe     DENSNC    Stim. Em.',
     >    '     B lam', 
     >    ALAM, TEMP, LOG10(PELE), DENSNC, STIMEM, BLAM,
     >    '     K     NamK    L Opac    L Frac',
     >    ' Scattering:'
C
         DO K = 1, KABS
            IF( K .EQ. KSCAT + 1 ) WRITE( 6, '(A)' ) ' True Absorption:'
            WRITE( 6, '(X, I5, I9, 2F10.3, 4X, A)' ) K, NAMK(K),
     >       LOG10( MAX( REAMIN, OPAC(K) ) ),
     >       LOG10( MAX( REAMIN, OPAC(K)/((OSIGMA + OKAPPA)/ATHOMS) )
     >       ), NAM(K)
         END DO
         WRITE( 6, '(2A)' ) '0      Sigma       Kappa   Log (S+K) ',
     >    'Log Scat. frac. '
         WRITE( 6, '(X, 1P, 2E12.4, 0P, 2F10.3)' ) OSIGMA, OKAPPA,
     >    LOG10( OSIGMA + OKAPPA ), LOG10( OSIGMA/(OSIGMA + OKAPPA) )
      END IF
      END
