        PROGRAM PLODEP
	implicit none

	integer idepth, ilevel
	PARAMETER( IDEPTH = 50, ILEVEL = 100 )

	integer i, idmin, idmax, id, ima, l, lma, lmax, n, ndepth
	real d, blgmin, blgmax, xl, yl, xorg, yorg, xinc, yinc, xsize,
     >       ysize, xmin, xmax, dshlen, factor
        real B( IDEPTH, ILEVEL + 1 ), TAULG( IDEPTH )
	integer LABEL( ILEVEL + 2 ), LEV( ILEVEL + 1 )
        CHARACTER HEAD*80, DEP_FILE*255, ATM_FILE*255,
     >	  XTEXT*13, csleep*2, ident*132
        LOGICAL MANPOS, NO_ATM, idp
	integer fracol, ovrcol, isleep
	integer atm_f, dep_f
	parameter( atm_f = 12, dep_f = 13 )

	real xcm, ycm

	CALL PRGID( 'PLODEP', ' 16-MAY-1996 18:06:56.00 ' )
	CALL GPINIT( 'plodep.cmd', ' ', 0, D, D, D, D, D )
	ATM_FILE = 'JUNK'	! this is a hack to allow for empty file specs
	CALL GFILE( 'Atmosphrenfile', ATM_FILE, 'ATM.DAT' )
	NO_ATM = ATM_FILE .EQ. ' '
	CALL GFILE( 'Departure file', DEP_FILE, 'DEPART.DAT' )
	CALL GTEXT( 'berschrift', HEAD )
	CALL IGPAR( 'Tiefenstufen: MIN, MAX', 2, IDMIN, IDMAX, ID, ID, 
     >	  ID )
	CALL GPAR( 'log b: MIN, MAX', 2, BLGMIN, BLGMAX, D, D, D )
	LMA = ILEVEL + 1
	CALL GLIST( 'Welche Levels (1,3-7)', LEV, LMA, .TRUE., .TRUE. )

	CALL GPARNY( 'Automatisch beschriften', MANPOS )
	CALL GPAR( 'Gre Zeichnung [cm]: X, Y ( ohne Beschriftung )',
     >	  2, XL, YL, D, D, D )
	CALL GPAR( 'Mastabsfaktor', 1, FACTOR, D, D, D, D )
	call gparny( 'Plot id string', idp )

	call gpclos

	IF( NO_ATM ) THEN
	   NDEPTH = 50
	   XTEXT = 'Depth Point'
           XINC = 5.
	ELSE
           OPEN( UNIT = atm_f, STATUS = 'OLD', FILE = ATM_FILE
!     >           , READONLY
     >         )
           READ( atm_f, '(I7)' )IMA
           DO I = 1, IMA
              READ( atm_f, '()' )
	   END DO
           READ( atm_f, '(///1X, I4/1X//)' )NDEPTH
           READ( atm_f, '(1X, 5E14.6)' ) (TAULG( ID ), ID = 1, NDEPTH)
           CLOSE( atm_f )
	   XTEXT = 'log #t#&T5000'
	   XINC = 1.
	END IF

        OPEN( UNIT = dep_f, STATUS = 'OLD', FILE = DEP_FILE
!     >        , READONLY
     >      )
        READ( dep_f, '(I4, 2x, a)' ) LMAX, ident
        READ( dep_f, '(5(1X,A4))' ) (LABEL( L ), L = 1, LMAX)
        READ( dep_f, '(I8)' ) LABEL( LMAX + 1 )
        DO ID = 1, NDEPTH
	   READ( dep_f, '(5E15.7)' ) (B( ID, L ), L = 1, LMAX)
	END DO
        CLOSE( dep_f )

	DO ID = 1, NDEPTH
           IF( NO_ATM ) THEN
	      TAULG(ID) = ID
	   ELSE
	      TAULG(ID) = LOG10( TAULG(ID) )
	   END IF
	   DO L = 1, LMAX
	      B(ID,L) = LOG10( ABS(B(ID,L)) )
           END DO
	END DO

	if ( blgmin .eq. blgmax ) then	! automatic scaling
	   blgmin = 1e30
	   blgmax = -1e30
	   do id = idmin, idmax
	      do l = 1, min( lma, lmax )
                 if( lev(l) .ne. lmax - 1 ) then
	            blgmin = min( blgmin, b(id,lev(l)) )
	            blgmax = max( blgmax, b(id,lev(l)) )
	         end if
	      end do
	   end do
	   xsize = 0.1*(blgmax - blgmin)
           blgmin = blgmin - xsize
	   blgmax = blgmax + xsize
	end if

	CALL PLOTS( 1, 0, (XL + 5.)*FACTOR, (YL + 4.)*FACTOR )
	CALL PLTSYN( .TRUE. )
	CALL DFACT( FACTOR, FACTOR )

	call lib$get_symbol( 'SLEEP', csleep, l )
        if( l .ne. 0 ) then
	   read( csleep, *, iostat = l ) isleep
	   if( l .ne. 0 ) isleep = 0
        else
           isleep = 0
        end if

	XORG = 4.5
	YORG = 2.5
	XSIZE = XL
	YSIZE = YL
	XMIN = TAULG( IDMIN )
	XMAX = TAULG( IDMAX )
	YINC = 0.
        HEAD = HEAD
	FRACOL = 1
	OVRCOL = 1
	DSHLEN = 0.
	N = 0
	IF( IDP ) THEN
	   CALL DIAGR( XORG, YORG, XSIZE, YSIZE, XMIN, XMAX, BLGMIN,
     >	               BLGMAX, XINC, YINC, XTEXT, 'log b&ti', ' ',
     >                 FRACOL, OVRCOL, TAULG(IDMIN), B(IDMIN, LEV(1)),
     >                 N, DSHLEN )
	   CALL SYMBLK( XCM(XMIN), YCM(BLGMAX)+0.2, 0.3, IDENT, 0., 132)
	   CALL SYMBLK( XCM(XMIN), YCM(BLGMAX)+0.7, 0.3, HEAD, 0., 132 )
	ELSE
	   CALL DIAGR( XORG, YORG, XSIZE, YSIZE, XMIN, XMAX, BLGMIN,
     >	               BLGMAX, XINC, YINC, XTEXT, 'log b&ti', HEAD,
     >                 FRACOL, OVRCOL, TAULG(IDMIN), B(IDMIN, LEV(1)),
     >                 N, DSHLEN )
	END IF
	N = IDMAX - IDMIN + 1
	DO L = 1, MIN(LMA, LMAX)
           call newpen( l )
	   CALL OVER( TAULG(IDMIN), B(IDMIN,LEV(L)), N, 0. )
           IF( MANPOS ) THEN
              WRITE( IDENT, '(I3, 2X, A4)' ) LEV(L), LABEL(LEV(L))
              CALL SYMBLK( XCM(TAULG(IDMIN)), YCM(B(IDMIN,LEV(L))), 0.3,
     >                     IDENT(:9), 0., 9 )
           END IF
*	   IF( ISLEEP .GT. 0 ) THEN
*              CALL LIB$WAIT( FLOAT(ISLEEP) )
*              CALL TIDLE
*              WRITE( 6, '(I5, 3X, A4)' ) LEV(L), LABEL(LEV(L))
*           END IF
	END DO
	CALL PLTEND
	call exit(0)
	END
