        SUBROUTINE WROP( IDMIN, IDMAX, IDEL, LAMBDA, TEFF, GLOG )
C ***
C ******************************************************************************
C ***
C ***   Output of opacities as used by JOSH in RATES.
C ***
C ***   IDMIN:  First depth point for printing
C ***   IDMAX:  Last depth point
C ***   IDEL:   Increment
C ***   LAMBDA: Wavelength
C ***   TEFF:   Effective Temperature
C ***   GLOG:   log g
C ***
C ***    2-JUN-1988 18:50:56 
C ***	29-NOV-1999 16:24:23.00		ML / McA.  Format x -> 1x
C ***
C ******************************************************************************
C ***
        INTEGER PAGLEN, PAGE, PPAGE
        REAL LAMBDA
        LOGICAL NEW
C ***
        include 'MOD_SIZ.INC'
        PARAMETER( PAGLEN = 60 )
        include 'OPAC_RAT.INC'
        include 'MODEL_RA.INC'
        DATA PPAGE /PAGLEN/
        DATA PAGE /1/
        SAVE PAGE, PPAGE
C ***
        NEW = .TRUE.
        DO 1 ID = IDMIN, IDMAX, IDEL
           IF( PPAGE .GE. PAGLEN ) THEN
              WRITE( 6, '(1H1, ''O p a c i t i e s'',
     >          T38, ''Teff = '', F5.0, 3X, ''log g = '', F4.2, T91, 
     >          ''Page '', I2,
     >          /, 1H ,        ''================='',
     >          /, 1H0, ''Wavelength: '', F7.0, 
     >          /, 1H0, ''  ID  lg tau     Sigma       Kappa        '',
     >          ''Line       Sigma/(S+K+L)   Kappa/(S+K+L)   '',
     >          ''Line/(S+K+L)'', /)' ) TEFF, GLOG, PAGE, LAMBDA
              PPAGE = 8
              PAGE = PAGE + 1
           ELSE IF( NEW ) THEN
              WRITE( 6, '(//, '' Wavelength: '', F7.0, /)' ) LAMBDA
              PPAGE = PPAGE + 4
           END IF
           NEW = .FALSE.
           RTOT = RSICON(ID) + RKACON(ID) + RLINE(ID)
           WRITE( 6, 2 ) ID, LOG10(TAUREF(ID)), RSICON(ID), RKACON(ID), 
     >       RLINE(ID), RSICON(ID)/RTOT, RKACON(ID)/RTOT, RLINE(ID)/RTOT
           PPAGE = PPAGE + 1
1       CONTINUE
2       FORMAT( 1X, I4, 2X, F6.3, 1P, 3(3X, E9.3), 9X, F5.3, 11X, F5.3, 
     >    10X, F5.3 )
        RETURN
        END
