	subroutine plotscale( xdata, ydata, ndata )
C ***
C ******************************************************************************
C ***
C ***	Sets min/max ranges for plot -- allows for autoscale if min==max.
C ***
C ***	This used to be done by diagr but line id's require extra room.
C ***
C ***
C ***	31-MAY-1996 21:40:17.67		ML / Bamberg.  Created.
C ***	19-JUN-1996 12:34:38.38		ML / Bamberg.  Removed pointer artistic.
C ***                                   x/ydata variables must be set before
C ***                                   entry just like in rest of this stuff.
C ***	 3-OCT-2001 15:53:00.00		ML / Stegaurach.  Moved x/ydata to arg
C ***					list.
C ***
C ******************************************************************************
C ***
	implicit none
	integer ndata
	real xdata(ndata), ydata(ndata)

C ***
C ***	Global variables
C ***
	include 'RECT_SIZE.INC'


C ***
C ***   Local variables
C ***
	integer i
	real d


	if( xmin .eq. xmax ) then
           xmin =  1e28
	   xmax = -1e28
           do i = 1, ndata
              xmin = min( xmin, xdata(i) )
              xmax = max( xmax, xdata(i) )
           end do
           d = 0.1*(xmax - xmin)
           xmin = xmin - d
           xmax = xmax + d
           if( xmin .eq. xmax ) then	! Konstante Funktion
              xmin = xmin - 0.1*xmin
              xmax = xmax + 0.1*xmin
           end if
	end if

	if( ymin .eq. ymax ) then
	   ymin =  1e28
	   ymax = -1e28
           do i = 1, ndata
              ymin = min( ymin, ydata(i) )
              ymax = max( ymax, ydata(i) )
           end do
           d = 0.1*(ymax - ymin)
           ymin = ymin - d
           ymax = ymax + d
           if( ymin .eq. ymax ) then	! Konstante Funktion
              ymin = ymin - 0.1*ymin
              ymax = ymax + 0.1*ymin
           end if
	end if


	end
