     	subroutine resize( func, status )
C ***
C ******************************************************************************
C ***
C ***   $Id: resize.f,v 1.13 2004/02/09 07:53:12 michael Exp $
C ***
C ***	Resize the plot under cursor control.
C ***
C ***	On entry: No assumption about text/grafix plane
C ***   On exit:  grafix plane both planes visible
C ***
C ***	Modifications:
C ***
C ***	23-SEP-1994 20:25:11.00		ML / IoA.  Stolen from Spenew.
C ***	28-SEP-1994 17:00:07.00		ML / IoA.  Plot fit_mask via plotout(2)
C ***	29-SEP-1994 19:00:54.00		ML / IoA.  Added shift of window option
C ***	18-NOV-1994 18:18:16.00		ML / IoA.  Hardcopy, reset added
C ***	21-NOV-1994 19:42:15.00		ML / IoA.  x/ywindo, p logic modified
C ***	22-NOV-1994 12:20:49.00		ML / IoA.  Func added
C ***	31-MAY-1996 22:17:48.15		ML / Bamberg.  Line id/plotout(8) stuff
C ***	 3-JUN-1996 14:58:31.70		ML / Bamberg.  plotout(7) in hardcopy
C ***                                   only if fit
C ***	12-JUN-1996 13:56:42.97		ML / Bamberg.  Check for 8bit L's and
C ***					R's.  Xterm mouse seems to send this.
C ***                                   Movement by space/delete
C ***	28-JUN-1996 21:53:11.66		ML / Bamberg.  Exit main loop and return
C ***                                   if user function FUNC returns status < 0
C ***                                   This allowed to remove MON_CODES.INC.
C ***	 1-JUL-1996 19:41:25.12		ML / Bamberg.  Removed O option.
C ***	 9-AUG-1996 14:12:35.18		ML / Bamberg.  Added G option.
C ***	28-SEP-1996 18:58:56.66		ML / Bamberg.  Allow to bail out of 
C ***                                   G option with EOF (might not work on
C ***                                   all OSs)
C ***	20-FEB-1997 19:30:44.55		ML / Bamberg.  Make UDLR commands to
C ***                                   move less then lowercase udlr
C ***   23-OCT-2001 17:10:00.00		ML / Stegaurach.  Better scale factors
C ***                                   for move/zoom commands.  Measure option
C ***					in c commmand.
C ***    5-NOV-2002 19:23:00.00		ML / Stegaurach. Fix color of x/y marks.
C ***                                   Add BackSpace to act like Delete.
C ***					Format change in cursor position output.
C ***   21-NOV-2002 23:25:59.00         ML / Stegaurach.  Added check for 
C ***                                   CHAR(0) in main loop to prevent
C ***                                   infinite loop if screen device
C ***                                   lacks cursor.
C ***   30-JUL-2003 19:20:00.00		ML / Stegauarch.  Another format change.
C ***    6-AUG-2003 08:43:00.00         ML / Stegaurach.  Set window from two
C ***                                   corners (w command).
C ***    6-AUG-2003 22:01:00.00         ML / Stegaurach.  Common code from 
C ***                                   xwindo, ywindo, windo moved to new
C ***                                   windo_region; new subroutine beep.
C ***                                   New +/- commands to move through
C ***                                   previous views.
C ***    8-AUG-2003 23:58:00.00         ML / Stegaurach.  Renamed +/- commands
C ***                                   to f/b to move forward/backward in
C ***                                   history.  Removed old F command, make
C ***                                   w command plot immediately.  Make
C ***                                   history ring buffer work as ring buffer.
C ***                                   Simplified common /xwyw/.
C ***                                   Help text clarifications.
C ***   10-AUG-2003 21:28:00.00         ML / Stegaurach.  Disentangle x/y and w
C ***                                   commands by having x/y cancel a pending
C ***                                   w command.  Got rid of common /xwyw/
C ***   11-AUG-2003 21:50:00.00         ML / Stegaurach.  Crash fixed when
C ***                                   stepping back through history.
C ***                                   Beep for unrecognized zoom commands.
C ***                                   Minor help text reformats.
C ***	12-AUG-2003 21:22:00.00		ML / Stegaurach.  Bug fix on ring buffer
C ***					Help text reformatted.
C ***   17-AUG-2003 22:27:00.00         ML / Stegaurach.  Point logic
C ***                                   simplified (?).
C ***   25-AUG-2003 19:37:00.00         ML / Stegaurach.  Point logic was
C ***                                   flawed in pwindo.  Could not accept the
C ***                                   same point for both px1 and px2.  Fixed.
C ***                                   Still not pretty.
C ***    8-FEB-2004 23:41:18.00         ML / Stegaurach.  Statistics for C
C ***                                   command.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	external func
	integer status

C ***
C ***	Global variables
C ***
	include 'RESIZE.INC'
	include 'RECT_SIZE.INC'
	include 'ERASURE.INC'

C ***
C ***	Local variables
C ***
        real px1(2), px2(2), py1(2), py2(2), pw1(2), pw2(2)   ! 4 points

	integer nhist
	parameter( nhist = 20 )
	real xhmin(0:nhist-1), xhmax(0:nhist-1), 
     >       yhmin(0:nhist-1), yhmax(0:nhist-1)
	integer ihmin, ihmax, ih, iihmin, iihmax, iih

	logical speech, xzoom, yzoom, save_hist
	character*1 comand
	integer i, icall_x, icall_y, icall_w
	real h, x, y

C ***
C ***	Functions
C ***
	logical pwindo, erased_text


	icall_x = 0
	icall_y = 0
        icall_w = 0

	px1(1) = 1e28
	px1(2) = 1e28
	px2(1) = 1e28
	px2(2) = 1e28

 	py1(1) = 1e28
	py1(2) = 1e28
	py2(1) = 1e28
	py2(2) = 1e28

	pw1(1) = 1e28
	pw1(2) = 1e28
	pw2(1) = 1e28
	pw2(2) = 1e28

	speech = .true.
	ih = 0
	ihmin = 0
	ihmax = 0
	xhmin(ih) = xmin
	xhmax(ih) = xmax
	yhmin(ih) = ymin
	yhmax(ih) = ymax
	comand = ' '
        call func( 0, x, y, comand, status, speech )
	do while( comand .ne. 'q' .and. comand .ne. 'Q' .and.
     >            comand .ne. char(0) )
           if( speech ) then
	      call tplane( noErase, Both_planes )
              call func( 1, x, y, comand, status, speech )
1	      format( a18, 2x, a )
              write( stdout, '()' )
	      write( stdout, 1 ) 'Press  X', 'to set X limits'//
     >                           ' (press twice for full scale),'
	      write( stdout, 1 ) 'Y', 'to set Y limits (press'//
     >                           ' twice for full scale),'
	      write( stdout, 1 ) 'P', 'to PLOT using the new limits,'
	      write( stdout, 1 ) 'W', 'to get WINDOW limits from '//
     >                                'two opposite points'
              write( stdout, 1 ) ' ', '   (press twice for full scale),'
	      write( stdout, 1 ) 'L,R,U,D, l,r,u,d', 'to move '//
     >                           'in window LEFT, RIGHT, UP, DOWN'
              write( stdout, 1 ) ' ', '   (capital L,R... move less),'
	      write( stdout, 1 ) '<SPACE>/<DELETE>', 'to move in '//
     >                           'window left or right,'
	      write( stdout, 1 ) '0', 'to RESET window limits to '//
     >                           'inital values,'
	      write( stdout, 1 ) 'ZI, ZXI, ZYI', 'to ZOOM IN '//
     >                           '(whole, x, or y only),'
	      write( stdout, 1 ) 'ZO, ZXO, ZYO', 'to ZOOM OUT,'//
     >                           '(whole, x, or y only),'
	      write( stdout, 1 ) 'B', 'to move BACK in window '//
     >                           'history,'
	      write( stdout, 1 ) 'F', 'to move FORWARD in window '//
     >                           'history,'
	      write( stdout, 1 ) 'G', 'to GO to specific x positon,'
	      write( stdout, 1 ) 'CTRL/L', 'to redraw window,'
	      write( stdout, 1 ) 'C', 'to print CURSOR position' //
     >                            ' (capital C adds statistics),'
	      write( stdout, 1 ) 'H', 'to get HARDCOPY,'
	      write( stdout, 1 ) '?', 'to get this menu again,'
	      write( stdout, 1 ) 'Q', 'to QUIT resize mode.'
	      call gplane( 1, noErase, Both_planes )
	   end if

           speech = .false.
	   save_hist = .true.

           call gposu (x, y, comand)
           if( comand .eq. 'x' .or. comand .eq. 'X' ) then
C ***
C ***         Fenster in x-Richtung festlegen
C ***
              call xwindo( x, y, px1, px2 )
	      icall_x = icall_x + 1
           else if( comand .eq. 'y' .or. comand .eq. 'Y' ) then
C ***      
C ***         Fenster in y-Richtung festlegen
C ***
              call ywindo( x, y, py1, py2 )
	      icall_y = icall_y + 1
           else if( comand .eq. 'p' .or. comand .eq. 'P' ) then
C ***      
C ***         Fenster zeichnen
C ***
              if( pwindo( icall_x, icall_y, 
     >                    px1, py1, px2, py2 ) ) then
                 speech = erased_text()
                 icall_w = 0
              end if
           else if( comand .eq. 'w' .or. comand .eq. 'W' ) then
C ***      
C ***         Set window limits from two opposite corners.
C ***
              call windo( x, y, pw1, pw2 )
              icall_w = icall_w + 1
              if( icall_w .gt. 1 ) then
                 icall_x = 2
                 icall_y = 2
                 if( pwindo( icall_x, icall_y,
     >                       pw1, pw1, pw2, pw2 ) ) then
                    speech = erased_text()
                    icall_w = 0
                 else
                    stop 'wont happen'
                 end if
              end if
           else if( comand .eq. 'c' .or. comand .eq. 'C' ) then
C ***
C ***         Print cursor position
C ***         Extended statistics for C
C ***
              call pcurs( x, y, comand )
           else if( comand .eq. 'l' .or. comand .eq. 'L' .or.
     >              comand .eq. char(236) .or. comand .eq. char(204)
     >              .or.
     >              comand .eq. char(127) .or. comand .eq. char(8) )
     >     then
C ***
C ***	      shift view left by 70% or 35% of current window size
C ***
              if( comand .eq. 'L' ) then
                 h = 0.35*( xmax - xmin )
              else
                 h = 0.7*( xmax - xmin )
              end if
	      xmin = xmin - h
              xmax = xmax - h

	      call re_paint

	      speech = erased_text()
           else if( comand .eq. 'r' .or. comand .eq. 'R' .or.
     >              comand .eq. char(242) .or. comand .eq. char(210)
     >              .or.
     >              comand .eq. ' ' )
     >     then
C ***
C ***	      shift view right by 70% of current window size
C ***
              if( comand .eq. 'R' ) then
                 h = 0.35*( xmax - xmin )
              else
                 h = 0.7*( xmax - xmin )
              end if
	      xmin = xmin + h
              xmax = xmax + h

	      call re_paint

	      speech = erased_text()
           else if( comand .eq. 'u' .or. comand .eq. 'U' ) then
C ***
C ***	      shift view up by 70% of current window size
C ***
              if( comand .eq. 'U' ) then
                 h = 0.35*( ymax - ymin )
              else
                 h = 0.7*( ymax - ymin )
              end if
	      ymin = ymin + h
              ymax = ymax + h

              call re_paint

	      speech = erased_text()
           else if( comand .eq. 'd' .or. comand .eq. 'D' ) then
C ***
C ***	      shift view down by 70% of current window size
C ***
              if( comand .eq. 'D' ) then
                 h = 0.35*( ymax - ymin )
              else
                 h = 0.7*( ymax - ymin )
              end if
	      ymin = ymin - h
              ymax = ymax - h

	      call re_paint

	      speech = erased_text()
	   else if( comand .eq. 'z' .or. comand .eq. 'Z' ) then
C ***
C ***	      Zooming
C ***
              xzoom = .true.
	      yzoom = .true.
              call gposu (x, y, comand)
              if( comand .eq. 'x' .or. comand .eq. 'X' .or.
     >            comand .eq. 'y' .or. comand .eq. 'Y' ) then

                  xzoom = comand .eq. 'x' .or. comand .eq. 'X'
                  yzoom = comand .eq. 'y' .or. comand .eq. 'Y'
                  call gposu (x, y, comand)
	      end if

              if( comand .eq. 'i' .or. comand .eq. 'I' ) then
C ***
C ***		 zoom in
C ***
                 if( yzoom ) then
                    h = 0.35/1.7*( ymax - ymin )
	            ymin = ymin + h
                    ymax = ymax - h
	         end if

                 if( xzoom ) then
                    h = 0.35/1.7*( xmax - xmin )
	            xmin = xmin + h
                    xmax = xmax - h
	         end if

	         call re_paint
	         speech = erased_text()
              else if( comand .eq. 'o' .or. comand .eq. 'O' ) then
C ***
C ***            zoom out
C ***
                 if( yzoom ) then
                    h = 0.35*( ymax - ymin )
	            ymin = ymin - h
                    ymax = ymax + h
	         end if

                 if( xzoom ) then
                    h = 0.35*( xmax - xmin )
	            xmin = xmin - h
                    xmax = xmax + h
	         end if

	         call re_paint
	         speech = erased_text()
              else
                 call beep
              end if



           else if( comand .eq. 'g' .or. comand .eq. 'G' ) then
C ***
C ***         go to specific place
C ***
              call tplane( noErase, Both_planes )
              status = 1
              do while( status .gt. 0 )
	         write( stdout, '(a,$)' ) ' X position to go to: '
	         read( 5, *, iostat = status ) h
              end do
	      call gplane( 1, noErase, Both_planes )
              
              if( status .eq. 0 ) then	  ! allow to bail out with EOF
                 x = 0.5*( xmax - xmin )  ! half width of current window
                 xmin = h - x
                 xmax = h + x

	         call re_paint
	      end if

           else if( comand .eq. 'h' .or. comand .eq. 'H' ) then
C ***
C ***	      Hardcopy
C ***
	      itv = 3
              call re_paint

	      itv = 2
	      call re_paint

              speech = .true. !No idea what junk printing will do to the screen
           else if( comand .eq. '0' ) then
C ***
C ***	      Reset plot limits to initial values
C ***
	      xmin = xpmin
	      xmax = xpmax
	      ymin = ypmin
	      ymax = ypmax
              call re_paint

              speech = erased_text()
           else if( comand .eq. char(12) ) then
C ***
C ***	      refresh plot
C ***
	      call re_paint
	      speech = erased_text()

           else if( comand .eq. 'b' .or. comand .eq. 'B' ) then
C ***
C ***	      move back in window history
C ***
              iih = mod( ih - ihmin + nhist, nhist )
              iihmin = 0 ! == mod( ihmin - ihmin + nhist, nhist )
	      if( iih .le. iihmin ) then
	         call beep
	      else
	         ih = mod( ih - 1 + nhist, nhist )
	         xmin = xhmin(ih)
	         xmax = xhmax(ih)
	         ymin = yhmin(ih)
	         ymax = yhmax(ih)
	         call re_paint
	         speech = erased_text()
	      end if
	      save_hist = .false.

           else if( comand .eq. 'f' .or. comand .eq. 'F' ) then
C ***
C ***	      move forward in window history
C ***
              iih = mod( ih - ihmin + nhist, nhist )
              iihmax = mod( ihmax - ihmin + nhist, nhist )
	      if( iih .ge. iihmax ) then
	         call beep
	      else
	         ih = mod( ih + 1, nhist )
	         xmin = xhmin(ih)
	         xmax = xhmax(ih)
	         ymin = yhmin(ih)
	         ymax = yhmax(ih)
	         call re_paint
	         speech = erased_text()
	      end if
	      save_hist = .false.

	   else if( comand .eq. '?' ) then
C ***
C ***	      Help
C ***
	      speech = .true.
           else
C ***
C ***	      do something else
C ***
              call func( 2, x, y, comand, status, speech )
              if( status .lt. 0 ) return

           end if
	   if( save_hist .and.
     >         (xmin .ne. xhmin(ih) .or. xmax .ne. xhmax(ih) .or.
     >          ymin .ne. yhmin(ih) .or. ymax .ne. yhmax(ih))
     >       ) then
	      ih = mod(ih + 1, nhist)
	      ihmax = ih
	      if( ihmax .eq. ihmin ) ihmin = mod( ihmin + 1, nhist )
	      xhmin(ihmax) = xmin
	      xhmax(ihmax) = xmax
	      yhmin(ihmax) = ymin
	      yhmax(ihmax) = ymax
           end if
        end do
        end
        logical function pwindo( icall_x, icall_y,
     >                           px1, py1, px2, py2 )
C ***
C *********************************************************************|*******
C ***
C ***   Plot window
C ***
C ***   Return .false. if no plot made
C ***          .true. otherwise
C ***
C *********************************************************************|*******
C ***
        implicit none
        integer icall_x, icall_y
        real px1(2), py1(2), px2(2), py2(2)

	include 'RESIZE.INC'
	include 'RECT_SIZE.INC'


        if( icall_x .eq. 1 .or. icall_y .eq. 1 ) then
	   call beep
           pwindo = .false.
	else
           if( icall_x .gt. 1 ) then
	      xmin = min( px1(1), px2(1) )
	      xmax = max( px1(1), px2(1) )
           end if
	   if( icall_y .gt. 1 ) then
	      ymin = min( py1(2), py2(2) )
	      ymax = max( py1(2), py2(2) )
           end if

           if( icall_x .gt. 1 ) then ! separate in case px1 same arg as py1 etc.
	      icall_x = 0
              px1(1) = 1e28
              px1(2) = 1e28
              px2(1) = 1e28
              px2(2) = 1e28
	   end if
	   if( icall_y .gt. 1 ) then
	      icall_y = 0
              py1(1) = 1e28
              py1(2) = 1e28
              py2(1) = 1e28
              py2(2) = 1e28
	   end if

	   call re_paint

           pwindo = .true.
	end if

        end
        subroutine xwindo( x, y, p1, p2 )
C ***
C *********************************************************************|*******
C ***
C ***   Setzt Plotfenster in x-Richtung.
C ***   Zweimaliger Aufruf mit gleichen Parametern setzt es auf Defaultwerte
C ***
C *********************************************************************|*******
C ***
	implicit none

	real x, y
        real p1(2), p2(2)

        logical icall
        save icall
        data icall /.true./

	call get2lastpoints( x, y, p1, p2, icall, -10 )
        
	end
        subroutine ywindo( x, y, p1, p2 )
C ***
C *********************************************************************|*******
C ***
C ***   Setzt Plotfenster in y-Richtung.
C ***   Zweimaliger Aufruf mit gleichen Parametern setzt es auf Defaultwerte
C ***
C *********************************************************************|*******
C ***
	implicit none

	real x, y
        real p1(2), p2(2)

        logical icall
        save icall
        data icall /.true./

	call get2lastpoints( x, y, p1, p2, icall, -23 )
	end
        subroutine windo( x, y, p1, p2 )
C ***
C *********************************************************************|*******
C ***
C ***   Setzt Plotfenster von zwei gegenueberliegenden Ecken.
C ***
C *********************************************************************|*******
C ***
	implicit none

	real x, y
        real p1(2), p2(2)

        logical icall
        save icall
        data icall /.true./


	call get2lastpoints( x, y, p1, p2, icall, -24 )
	end
        subroutine get2lastpoints( x, y, p1, p2, icall, ipen )
C ***
C ******************************************************************************
C ***
C ***	Set plot window region in user coordinates.
C ***
C ***	    x, y:      R >  X, Y cursor coordinates
C ***       p1, p2     R <  two points (pN(1) = x, pN(2) = y)
C ***       icall      L <> to keep track of call
C ***       ipen       I >  number of symbol to plot as marker
C ***
C ******************************************************************************
C ***
	implicit none
	real x, y, p1(2), p2(2)
        logical icall
	integer ipen

	call newpen(1)
        call over( x, y, 1, real(ipen) )
        if( icall ) then
           p1(1) = x
           p1(2) = y
        else
           p2(1) = x
           p2(2) = y
        end if

        icall = .not.icall

        end
	subroutine pcurs( x, y, cmd )
C ***
C ******************************************************************************
C ***
C ***	Prints cursor position
C ***
C ***	 7-AUG-1991 23:36:26.70
C ***
C ******************************************************************************
C ***
	implicit none
	real x, y
        character cmd*(*)

	logical first

	real delta_x, delta_y, slope
	real x_last, y_last
	save x_last, y_last

	save first
	data first /.true./

	include 'RESIZE.INC'
	include 'ERASURE.INC'

	if( first .and. cmd .eq. 'C' ) then
	   x_last = x
	   y_last = y
	   first = .false.
	end if

	call tplane( noErase, Both_planes )
        delta_x = x - x_last
        delta_y = y - y_last
        slope = 1.e37
        if( delta_x .ne. 0 ) slope = delta_y/delta_x
	write( stdout, * ) 'Position: x: ', x, ' y: ', y
        write( stdout, * ) '   Delta: x: ', delta_x, ' y: ', delta_y,
     >                     ' Slope: ', slope
        if( .not.first .and. cmd .eq. 'C' ) then
           call statistics( x, y, x_last, y_last )
        end if
        write( stdout, '()' )
	call gplane( 1, noErase, Both_planes )
	x_last = x
	y_last = y
	end
	subroutine beep
	implicit none

C ***
C ***	Global variables
C ***
	include 'RESIZE.INC'
	include 'ERASURE.INC'

	call tplane( noErase, Single_plane )
	write( stdout, '(a,$)' ) char(7)
	call gplane( 1, noErase, Single_plane )
	end
