	subroutine re_paint
C ***
C ******************************************************************************
C ***
C ***	Redraw current screen view
C ***
C ***
C ***	If the pointer artistic is not available for your Fortran two
C ***	dimensional arrays must be created
C ***	
C ***		real xc(1:max_pkt, 1:max_curv)
C ***		real yc(1:max_pkt, 1:max_curv)
C ***	
C ***	and the other arrays must be declared as
C ***	
C ***		real xdata(1:max_pkt), ydata(1:max_pkt)
C ***		integer nc(1:max_curv), cc(1:max_curv)
C ***           real style(1:max_curv)
C ***	
C ***	These declarations go into RESIZE.INC.
C ***	
C ***	Then the copying below is done as
C ***	
C ***		do i = 1, ncurv
C ***		   do j = 1, nc(i)
C ***		      xdata(j) = xc(j,i)
C ***		      ydata(j) = yc(j,i)
C ***		   end do
C ***	           ndata = nc(i)
C ***	           ... as below
C ***		end do
C ***	
C ***	
C ***
C ***	 4-JUN-1996 20:24:55.02		ML / IoA.  Created.
C ***	19-JUN-1996 16:57:14.92		ML / Bamberg.  Added text option
C ***	 5-JUL-1996 21:29:19.66		ML / Bamberg.  ncurv.eq.0 case added
C ***    9-MAY-1997 00:00:02.00         ML / Stegaurach.  Made for Linux
C ***	13-JUN-1997 17:52:27.56		ML / Bamberg.  Hacked for line id's:
C ***					Pass xline, pline via common resize_id
C ***	 3-OCT-2001 14:33:11.00		ML / Stegaurach.  Accomodate again for
C ***                                   dynamic memory, changed call of plotout
C ***   15-DEC-2005 22:39:16.00         ML / Stegaurach.  Removed long standing
C ***                                   bug with last point of line id's.
C ***
C ******************************************************************************
C ***
	implicit none

	include 'RESIZE.INC'
	include 'RECT_SIZE.INC'
        include 'ID.INC'

	integer i, j, ia
	real dummy

#ifdef VMS
	include '($DSCDEF)'
	record /dscdef1/ text

        text.dsc$b_dtype = dsc$k_dtype_t
	text.dsc$b_class = dsc$k_class_s
#endif

C ***
C ***	Data structure of a curve:
C ***
	integer ndata		! no. of points in curve
	integer color		! color of curve
	real style		! style of curve

#if defined( CRAY_PTR ) 
	real xdata(*), ydata(*)
	pointer( p_xdata, xdata )
	pointer( p_ydata, ydata )
#elif defined( REF_PTR )
	integer p_xdata
	integer p_ydata
#endif

C ***
C ***	Functions
C ***
	integer ideref
	real deref
	external ideref, deref
	external resize_init	! block data


C ***
C ***	Code
C ***

	if( ncurv .eq. 0 ) then
C ***
C ***      Somewhat strange but see what we can do
C ***
	   if( xmin .ne. xmax .and. ymin .ne. ymax ) then
              call plotout( 1, dummy, dummy, 1, dummy, i )
	   else
	      write( *, * ) 'RE_PAINT>> Can''t plot - no data specified'
	      return
	   end if
	end if

C ***
C ***   All fine down here
C ***
	do i = 1, ncurv
#if defined( CRAY_PTR )
	   p_xdata = xc(i)
           p_ydata = yc(i)
	   ndata = nc(i)
           style = sc(i)
	   color = cc(i)
#elif defined( REF_PTR )
	   p_xdata = ideref( %val(pp_xdata), i )
           p_ydata = ideref( %val(pp_ydata), i )
	   ndata = ideref( %val(p_ndata), i )
           style = deref( %val(p_style), i )
	   color = ideref( %val(p_color), i )
#else
	   ndata = nc(i)
           style = sc(i)
	   color = cc(i)
#endif
#if defined( CRAY_PTR )
	   if( i .eq. 1 ) call plotout( 1, xdata, ydata, ndata, 
     >                                  style, color )
	   call plotout( 3, xdata, ydata, ndata, style, color )
#elif defined( REF_PTR )
	   if( i .eq. 1 ) call plotout( 1, %val(p_xdata), %val(p_ydata), 
     >                                  ndata, style, color )
	   call plotout( 3, %val(p_xdata), %val(p_ydata), 
     >                   ndata, style, color )
#else
	   if( i .eq. 1 ) call plotout( 1, xc(1,i), yc(1,i), ndata, 
     >                                  style, color )
	   call plotout( 3, xc(1,i), yc(1,i), ndata, style, color )
#endif
	end do

	do i = 1, ntext

#ifdef VMS
	   text.dsc$w_maxstrlen = text_len(i)
	   text.dsc$a_pointer = text_addr(i)
           call ptxt( xt(i), yt(i), %ref(text), sizet(i), loct(i),
     >                colt(i), coort(i) )
#else
#if defined( CRAY_PTR )
           call ptxt( xt(i), yt(i), %val(text_addr(i)), sizet(i),
     >                loct(i), colt(i), coort(i), %val(text_len(i)) )
#elif defined( REF_PTR )
           call ptxt( deref(%val(p_xt),i), deref(%val(p_yt),i), 
     >                %val(ideref(%val(p_text_a),i)), 
     >                deref(%val(p_sizet),i),
     >                ideref(%val(p_loct),i), ideref(%val(p_colt),i), 
     >                ideref(%val(p_coort),i), 
     >                %val(ideref(%val(p_text_l),i)) )
#else
           call ptxt( xt(i), yt(i), text_string(i), sizet(i),
     >                loct(i), colt(i), coort(i) )
#endif
#endif
	end do
	
	
	if( iline .gt. 0 ) then
           ia = iline + 1
           do i = 1, iline
              if( xline(i) .ge. xmin ) then
                 ia = i
                 exit
              end if
           end do
           do i = ia, iline
              if( xline(i) .ge. xmax ) exit
           end do
           i = min( i, iline )
           if( i .gt. ia ) then
	      call newpen( 1 )
	      call lplot( xline(ia), pline(ia), i-ia+1, .true.,
     >                    xmax, xmin, ymax, ymin )	! id
	   end if
	end if

	end
