	subroutine resize_add_lines( x, text, icol )
C ***
C ******************************************************************************
C ***
C ***	Routine to add spectral line id's for resize.
C ***
C ***	x		r >	x position (wavelength) of line
C ***	text		c >	line id to add
C ***	icol		i >	color index for text
C ***
C ***
C ***    7-OCT-2001 21:21:00.00		ML / Stegaurach.  Made.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***   Arguments
C ***
        character text*(*)
	real x
	integer icol

C ***
C ***	Gobal variables
C ***
	include 'RESIZE.INC'

C ***
C ***	Local variables
C ***
#if defined( CRAY_PTR ) || defined( REF_PTR )
	integer chunk
	parameter( chunk = 20 )	! chunks in which to allocate memory
#endif

	logical first /.true./
	integer status, i

! pointer size:  AXP/VAX:
#ifndef PTRSIZ
#ifdef __ALPHA
#define PTRSIZ 8
#else
#define PTRSIZ 4
#endif
#endif

#if defined( CRAY_PTR )
	real nxline(*)
	integer ncoll(*) 

	integer*4 npline_addr(*)
	integer*2 npline_len(*)

	pointer( npr_xline, nxline )
	pointer( npi_coll, ncoll )

	pointer( npc_pline_a, npline_addr )
	pointer( npc_pline_l, npline_len )
#elif defined( REF_PTR )
	integer*PTRSIZ npr_xline
	integer*PTRSIZ npc_pline_a
	integer*PTRSIZ npc_pline_l
	integer*PTRSIZ npi_coll
#endif


C ***
C ***	Functions
C ***
#if defined( CRAY_PTR ) || defined( REF_PTR )
	integer lib$get_vm, lib$free_vm
	external lib$get_vm, lib$free_vm
#endif	

	save first


C ***
C ***	Code
C ***
	if( first ) then
           first = .false.
	   nline = 0
           nculin = 0
	end if

	nline = nline + 1
#if defined( CRAY_PTR ) || defined( REF_PTR )
	if( nculin .lt. nline ) then

C ***
C ***      Get new memory
C ***
           i = nculin + chunk
	   status = lib$get_vm( 4*i, npr_xline )
	   if( status .ne. 1 ) call lib$signal( %val(status) )
	   status = lib$get_vm( 4*i, npi_coll )
	   if( status .ne. 1 ) call lib$signal( %val(status) )
	   status = lib$get_vm( 4*i, npc_pline_a )
	   if( status .ne. 1 ) call lib$signal( %val(status) )
	   status = lib$get_vm( 4*i, npc_pline_l )
	   if( status .ne. 1 ) call lib$signal( %val(status) )

#if defined( CRAY_PTR )
           do i = 1, nline - 1
C ***
C ***         copy the old data to the new location
C ***
              nxline(i) = xline(i) 
	      ncoll(i) = coll(i)
	      npline_addr(i) = pline_addr(i)
	      npline_len(i) = pline_len(i)
	   end do
#elif defined( REF_PTR )
C ***
C ***      copy the old data to the new location
C ***
           call arrcp( %val(pr_xline), %val(npr_xline), 1, nline-1)
	   call iarrcp( %val(pi_coll), %val(npi_coll), 1, nline-1)
	   call iarrcp( %val(pc_pline_a), %val(npc_pline_a), 1, nline-1)
	   call iarrcp( %val(pc_pline_l), %val(npc_pline_l), 1, nline-1)
#endif

           if( nculin .gt. 0 ) then
C ***
C ***         Free the old memory
C ***
	      status = lib$free_vm( 4*nculin, pr_xline )
	      if( status .ne. 1 ) call lib$signal( %val(status) )
	      status = lib$free_vm( 4*nculin, pi_coll )
	      if( status .ne. 1 ) call lib$signal( %val(status) )
	      status = lib$free_vm( 4*nculin, pc_pline_a )
	      if( status .ne. 1 ) call lib$signal( %val(status) )
	      status = lib$free_vm( 4*nculin, pc_pline_l )
	      if( status .ne. 1 ) call lib$signal( %val(status) )

           end if

C ***
C ***      Fix pointers
C ***      
	   pr_xline = npr_xline
	   pi_coll = npi_coll
	   pc_pline_a = npc_pline_a
	   pc_pline_l = npc_pline_l

           nculin = nculin + chunk	! remember what we've got
	end if

#if defined( CRAY_PTR )
        xline(nline) = x
	coll(nline) = icol

	pline_addr(nline) = %loc(text)  
	pline_len(nline) = len(text)
#elif defined( REF_PTR )
        call derefass( x, %val(pr_xline), nline )
        call iderefass( icol, %val(pi_coll), nline )
        call iderefass( %ref(%loc(text)), %val(pc_pline_a), nline )
        call iderefass( len(text), %val(pc_pline_l), nline )
#endif
#else
        if( nline .gt. max_text ) then
	    write( stdout, * ) 'RE_PAINT>>  Can''t add more text.',
     >                         '  Max # of strings is', max_text
            call exit
        end if

        xline(nline) = x
	coll(nline) = icol

        pline_string(nline) = text

#endif

	end
