	integer stdout
	parameter( stdout = 6 )

	integer lab_size
	parameter( lab_size = 80 )

	integer itv
	real xpmin, xpmax, ypmin, ypmax


C ***
C ***	Layout for data structure:
C ***
C ***   For a curve c:
C ***	
C ***	ndata: 		    I	number of points in curve
C ***	xdata(1:ndata):	    R	x values
C ***	ydata(1:ndata):	    R	y values
C ***	style		    R	line type
C ***	color		    I	color of curve
C ***
C ***	ncurv		    I   Number of curves
C ***	xc(1:ncurv)      p->R   points to xdata(1) for curve c
C ***	yc(1:ncurv)      p->R   points to ydata(1) for curve c
C ***	nc(1:ncurv)         N   number of points in curve c
C ***	sc(1:ncurv)	    R   line type of curve c	
C ***	cc(1:ncurv)         I   color of curve c
C ***
C ***
C ***	To make all of this dynamically allocatable pointers for
C ***	the above are passed via common:
C ***
C ***	p_xdata:	 p->R	points to xdata(1)
C ***	p_ydata:	 p->R	points to ydata(1)
C ***
C ***	pp_xdata:    p->p->R	points to p_xdata
C ***	pp_ydata:    p->p->R	points to p_ydata
C ***	p_ndata:	p->I	points to ndata
C ***	p_style		p->R	points to style
C ***	p_color		p->I	points to color
C ***
C ***
C ***	The calling program needs to allocate 
C ***
C ***
	integer ncu	! keep track of allocated memory
	integer ndata, ncurv, color
	real style

	real xdata(*), ydata(*)
	integer nc(*), cc(*)
	real sc(*)
	integer*8 xc(*), yc(*)	! AXP/VAX


	pointer( p_xdata, xdata )
	pointer( p_ydata, ydata )

	pointer( pp_xdata, xc )
	pointer( pp_ydata, yc )
	pointer( p_ndata, nc )
	pointer( p_style, sc )
	pointer( p_color, cc )

	common /my_data/ pp_xdata, pp_ydata, p_ndata, p_style,
     >                   p_color,
     >                   p_xdata, p_ydata, ndata, style, color, ncurv,
     >                   itv, xpmin, xpmax, ypmin, ypmax, ncu

	character xlab*(lab_size), ylab*(lab_size), tlab*(lab_size)
	common /my_cdata/ xlab, ylab, tlab



	integer ntext, ncutxt

	integer*4 text_addr(*)
	integer*2 text_len(*)

	real xt(*), yt(*), sizet(*)
	integer loct(*), colt(*), coort(*)

	pointer( p_xt, xt )
	pointer( p_yt, yt )
	pointer( p_sizet, sizet )
	pointer( p_loct, loct )
	pointer( p_colt, colt )
	pointer( p_coort, coort )

	pointer( p_text_a, text_addr )
	pointer( p_text_l, text_len )

	common /my_text/ p_xt, p_yt, p_sizet, p_loct, p_colt, p_coort,
     >                   p_text_a, p_text_l, ntext, ncutxt
