	subroutine resize_add_data( x, y, npkt, sty, icol )
C ***
C ******************************************************************************
C ***
C ***	Routine to add data arrays for resize.
C ***
C ***	This adds just one curve to the curves to be plotted and increments
C ***	ncurv (in common).
C ***
C ***	x(npkt)		r >	x values
C ***	y(npkt)		r >	y values
C ***	npkt		i >	number of points in curve
C ***	sty		r >	line style for curve
C ***	icol		i >	color index for curve
C ***
C ***
C ***	13-JUN-1996 12:21:03.02		ML / Bamberg.  Created.
C ***
C ******************************************************************************
C ***
	implicit none


C ***
C ***   Arguments
C ***
        integer npkt
	real x(npkt), y(npkt), sty
	integer icol

C ***
C ***	Gobal variables
C ***
	include 'RESIZE.INC'

C ***
C ***	Local variables
C ***
	integer chunk
	parameter( chunk = 20 )	! chunks in which to allocate memory

	logical first /.true./
	integer status, i

	integer nnc(*), ncc(*)
	real nsc(*)
	integer*8 nxc(*), nyc(*)	! AXP/VAX

	pointer( npp_xdata, nxc )
	pointer( npp_ydata, nyc )
	pointer( np_ndata, nnc )
	pointer( np_style, nsc )
	pointer( np_color, ncc )

C ***
C ***	Functions
C ***
	integer lib$get_vm, lib$free_vm
	external lib$get_vm, lib$free_vm
	

	save first


C ***
C ***	Code
C ***
	if( first ) then
           first = .false.
	   ncurv = 0
           ncu = 0
	end if

	ncurv = ncurv + 1
	if( ncu .lt. ncurv ) then

C ***
C ***      Get new memory
C ***
           i = ncu + chunk
	   status = lib$get_vm( 8*i, npp_xdata )
	   if( .not.status ) call lib$signal( %val(status) )
	   status = lib$get_vm( 8*i, npp_ydata )
	   if( .not.status ) call lib$signal( %val(status) )
	   status = lib$get_vm( 4*i, np_ndata )
	   if( .not.status ) call lib$signal( %val(status) )
	   status = lib$get_vm( 4*i, np_style )
	   if( .not.status ) call lib$signal( %val(status) )
	   status = lib$get_vm( 4*i, np_color )
	   if( .not.status ) call lib$signal( %val(status) )

           do i = 1, ncurv - 1
C ***
C ***         copy the old data to the new location
C ***
              nxc(i) = xc(i) 
	      nyc(i) = yc(i) 
	      nnc(i) = nc(i) 
	      ncc(i) = cc(i) 
	      nsc(i) = sc(i)
	   end do

           if( ncu .gt. 0 ) then
C ***
C ***         Free the old memory
C ***
	      status = lib$free_vm( 8*ncu, pp_xdata )
	      if( .not.status ) call lib$signal( %val(status) )
	      status = lib$free_vm( 8*ncu, pp_ydata )
	      if( .not.status ) call lib$signal( %val(status) )
	      status = lib$free_vm( 4*ncu, p_ndata )
	      if( .not.status ) call lib$signal( %val(status) )
	      status = lib$free_vm( 4*ncu, p_style )
	      if( .not.status ) call lib$signal( %val(status) )
	      status = lib$free_vm( 4*ncu, p_color )
	      if( .not.status ) call lib$signal( %val(status) )
           end if

C ***
C ***      Fix pointers
C ***      
	   pp_xdata = npp_xdata
           pp_ydata = npp_ydata
           p_ndata =  np_ndata 
           p_style =  np_style 
           p_color =  np_color 


           ncu = ncu + chunk	! remember what we've got
	end if

        xc(ncurv) = %loc(x(1))
	yc(ncurv) = %loc(y(1))
	nc(ncurv) = npkt
	cc(ncurv) = icol
	sc(ncurv) = sty

	p_xdata = %loc(x(1))	! not required but then stuff can be used
	p_ydata = %loc(y(1))	! by calling program


	end
