	subroutine cplot( x, y, ipen )
C ***
C ******************************************************************************
C ***
C ***	Like RZ routine.  Sets clip limits (ipen 997 and 998) and plots.
C ***
C ***	This is more cumbersome than one would wish because normal CALL PLOT
C ***   must not be affected by setting the clip limits.  Unfortunately,
C ***	PGPLOT does not have non-clipping DRAW/MOVE routines.
C ***
C ***	14-APR-1997 18:30:37.19
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	real x, y
	integer ipen

C ***
C ***	Functions
C ***

C ***
C ***	Local variables
C ***
!	include 'types.inc'

	real clip_max_x
	real clip_max_y
	real clip_min_x
	real clip_min_y
	real cm_max_x
	real cm_max_y
	real cm_min_x
	real cm_min_y
	real fact_x
	real fact_y
	real new_max_x
	real new_max_y
	real new_min_x
	real new_min_y
	real phys_max_x
	real phys_max_y
	real phys_min_x
	real phys_min_y
!	record /vector/ phys, cm, clip, new
!	record /point/ fact
!	save phys, cm, clip, fact
	save clip_max_x
	save clip_max_y
	save clip_min_x
	save clip_min_y
	save cm_max_x
	save cm_max_y
	save cm_min_x
	save cm_min_y
	save fact_x
	save fact_y
	save phys_max_x
	save phys_max_y
	save phys_min_x
	save phys_min_y

	if( ipen .eq. 997 .or. ipen .eq. 998 ) then
C ***
C ***	   Save some information for later -- cplot must be called consistently
C ***
	   call pgqvp( 1, phys_min_x, phys_max_x,
     >                 phys_min_y, phys_max_y )
	   call pgqwin( cm_min_x, cm_max_x, cm_min_y, cm_max_y )
           fact_x = (phys_max_x - phys_min_x)/(cm_max_x - cm_min_x)
           fact_y = (phys_max_y - phys_min_y)/(cm_max_y - cm_min_y)

           if( ipen .eq. 997 ) then
C ***      
C ***         set lower left corner limits
C ***      
              clip_min_x = x
              clip_min_y = y
           
           
           else if( ipen .eq. 998 ) then
C ***      
C ***         set upper right corner limits
C ***      
              clip_max_x = x
              clip_max_y = y
           end if
           
        else 

           new_min_x = (clip_min_x - cm_min_x)*fact_x + phys_min_x
           new_max_x = (clip_max_x - cm_min_x)*fact_x + phys_min_x
           new_min_y = (clip_min_y - cm_min_y)*fact_y + phys_min_y
           new_max_y = (clip_max_y - cm_min_y)*fact_y + phys_min_y

	   call pgvsiz( new_min_x, new_max_x, new_min_y, new_max_y )
	   call pgswin( clip_min_x, clip_max_x, clip_min_y, clip_max_y )

C ***
C ***	   The following doesn't set the origin, unlike PLOT.  Don't
C ***	   know what the original does.  PGDRAW/PGMOVE could be replaced
C ***	   with PLOT to achieve this but that would pretend to be generic
C ***      -- PLOT is affected by this exercise here more or less
C ***	   by coincidence only.
C ***
           if( abs(ipen) .eq. 3 ) then
C ***      
C ***         move
C ***      
              call pgmove( x, y )
           else if( abs(ipen) .eq. 2 ) then
C ***      
C ***         draw
C ***      
              call pgdraw( x, y )
           else if( ipen .eq. 999 ) then
C ***      
C ***         end.  not sure if original does this
C ***      
              call pltend
           end if

	   call pgvsiz( phys_min_x, phys_max_x,
     >                  phys_min_y, phys_max_y )
	   call pgswin( cm_min_x, cm_max_x, cm_min_y, cm_max_y )

	end if

	end
