	subroutine dashp( x, y, length )
C ***
C ******************************************************************************
C ***
C ***	Draw dashed line to point x,y with dash length length.
C ***
C ***	x	x coordinate [cm]
C ***	y	y coordinate [cm]
C ***	length	dash length [cm]
C ***
C ***	15-APR-1994 13:15:13.00
C ***
C ******************************************************************************
C ***
	implicit none

	real x, y, length

!	include 'types.inc'

!	record /point/ cur, inc, sig
	real cur_x, cur_y, inc_x, inc_y, sig_x, sig_y
	real alpha, fact
	integer pen
	data alpha /0./

	call where( cur_x, cur_y, fact )

	if( (y - cur_y .ne. 0.) .or. (x - cur_x .ne. 0.) ) 
     >                            alpha = atan2( y - cur_y, x - cur_x )
	inc_x = length*cos( alpha )
	inc_y = length*sin( alpha )

	sig_x = sign( 1., x - cur_x )
	sig_y = sign( 1., y - cur_y )

	pen = 2
        cur_x = cur_x + inc_x
	cur_y = cur_y + inc_y
        if( sig_x .gt. 0. ) then
           cur_x = min( cur_x, x )
        else
           cur_x = max( cur_x, x )
        end if
        if( sig_y .gt. 0. ) then
           cur_y = min( cur_y, y )
        else
           cur_y = max( cur_y, y )
        end if
	do while( sig_x*(x - cur_x) .ge. 0. .and.
     >            sig_y*(y - cur_y) .ge. 0. ) 
           if( sig_x .gt. 0. ) then
	      cur_x = min( cur_x, x )
	   else
	      cur_x = max( cur_x, x )
	   end if
           if( sig_y .gt. 0. ) then
	      cur_y = min( cur_y, y )
	   else
	      cur_y = max( cur_y, y )
	   end if
	   call plot( cur_x, cur_y, pen )
           cur_x = cur_x + inc_x
	   cur_y = cur_y + inc_y
           if( pen .eq. 2 ) then
	      pen = 3
	   else
	      pen = 2
	   end if
	end do

	end
