	subroutine plots( ich, idev, x, y )
	implicit none

C ***
C ***	Arguments
C ***
	integer ich, idev, ipen, lfn!: see entry below
	real x, y
	character fn*(*) ! entry pltfile

C ***
C ***	Global variables
C ***
!	include '($ssdef)'
!	include '($jpidef)'
	include 'pgpa.inc'

C ***
C ***	Functions
C ***
!	integer lib$getjpi, lib$sys_trnlog
        integer lnblnk
        integer pgbeg

C ***
C ***	Local variables
C ***
        character prompt*(*)
        parameter( prompt = 'Please, specify PGPLOT output device '//
     >                      '(0 for list):' )


	integer ierr, j
	integer ignore
	integer i, idv, l, status
	logical err, term
        character pgd*255, file_name*255, pgd1*255, ans*5, ext*4
	real f

	logical full, flag /.false./, clear_screen /.true./

!	include 'types.inc'

	real cm_max_x
	real cm_max_y
	real cm_min_x
	real cm_min_y
	real phys_max_x
	real phys_max_y
	real phys_min_x
	real phys_min_y
	real pix_cm_x
	real pix_cm_y
	real plot_size_cm_x
	real plot_size_cm_y
!	record /vector/ phys, cm, phys_clip
!	record /point/ plot_size_cm, pix_cm

!	save flag, full, plot_size_cm, clear_screen
	save flag, full, clear_screen
	save plot_size_cm_x
	save plot_size_cm_y
	save file_name


C ***
C ***	Generate output file name for postscript
C ***
!        ierr = lib$getjpi( jpi$_imagname,,,,file_name, i )
!        do while( file_name(i:i) .ne. '.' )
!           i = i - 1
!        end do
!        j = i - 1
!        do while( file_name(i:i) .ne. ']' )
!           i = i - 1
!        end do
!        file_name = file_name( i+1:j )
!        i = min( j - i + 1, 32 - 4 )

	call getarg( 0, file_name )
	if( index( file_name, '/' ) .gt. 0 ) then
	   do i = lnblnk(file_name), 1, -1
	      if( file_name(i:i) .eq. '/' ) go to 1
	   end do
1	   continue
	   file_name = file_name(i+1:)
	   call kleinb( file_name, pgd )
	   i = index( pgd, '.exe' )
	   if( i .gt. 0 ) file_name(i:) = ' '   ! chop off .exe
	end if

	plot_size_cm_x = x
	plot_size_cm_y = y

C ***
C ***	Get desired device and open it
C ***
C ***   We don't use PGPLOT's device listing capabilities because we also
C ***   want to list the numeric device equivalents.
C ***
        idv = idev
        write( pgd, *, iostat = status ) idv
	if( idv .eq. 0 ) then
            print *, prompt
            read( 5, '(a)', end = 99, iostat = status ) pgd
	end if
2	continue
        do while( pgd .eq. ' ' .or. pgd .eq. '0' .or. pgd .eq. '?'
     >            .or. status .ne. 0 )
!	   call pgldev
           print *, 'Device types recognized by PLOTS:'
	   print *
           print *, ' 10 /XTERM   (XTERM Tek terminal emulator)'
           print *, ' 11 /XSERVE  (A /XWINDOW window that persists '//
     >              'for re-use)'
           print *, ' 12 /XDISP   (pgdisp or figdisp server)'
           print *, ' 13 /XWINDOW (X window '//
     >              'window@node:display.screen/xw)'
           print *, ' 14 /CGW     (MS Windows black/white)'
           print *, ' 15 /GW      (MS Windows white/black)'
	   print *
           print *, ' -1 /NULL  (Null device, no output)'
           print *, ' -2 /CPS   (Colour PostScript file, landscape '//
     >              'orientation)'
           print *, ' -3 /VCPS  (Colour PostScript file, portrait '//
     >              'orientation)'
           print *, ' -4 /PS    (PostScript file, landscape '//
     >              'orientation)'
           print *, ' -5 /VPS   (PostScript file, portrait '//
     >              'orientation)'
           print *, ' -6 /GIF   (Graphics Interchange Format file, '//
     >              'landscape orientation)'
           print *, ' -7 /VGIF  (Graphics Interchange Format file, '//
     >              'portrait orientation)'
           print *, ' -8 /PPM   (Portable Pixel Map file, landscape '//
     >              'orientation)'
           print *, ' -9 /VPPM  (Portable Pixel Map file, portrait '//
     >              'orientation)'
           print *, '-10 /LATEX (LaTeX picture environment)'
           print *, '-11 /FILE  (PGPLOT graphics metafile)'
           print *
	   print *, prompt
           read( 5, '(a)', end = 99, iostat = status ) pgd
	end do

        read( pgd, *, iostat = status ) idv	! Transform numbers to PGPLOT
        if( pgd(:1) .eq. '/' ) status = 1       ! READ won't return error
                                                ! because / terminates * read
                                                ! (Standard F77)
        if( status .ne. 0 ) then
           ! all fine, got PGPLOT type string
           idv = -1
           status = 0
	else if( idv .eq. 10 ) then
           pgd = '/xterm'
        else if( idv .eq. 11 ) then
	   pgd = '/xserve'
        else if( idv .eq. 12 ) then
	   pgd = '/xdisp'
        else if( idv .eq. 13 ) then
	   pgd = '/xwindow'
        else if( idv .eq. 14 ) then
	   pgd = '/cgw'
        else if( idv .eq. 15 ) then
	   pgd = '/gw'
	else if( idv .eq. -1 ) then
	   print *, '[ Plot calls are dummy ]'
	   pgd = '/null'
	else if( idv .eq. -2 ) then
	   pgd = '/cps'
	else if( idv .eq. -3 ) then
	   pgd = '/vcps'
        else if( idv .eq. -4 ) then
	   pgd = '/ps'
        else if( idv .eq. -5 ) then
	   pgd = '/vps'
        else if( idv .eq. -6 ) then
	   pgd = '/gif'
        else if( idv .eq. -7 ) then
	   pgd = '/vgif'
        else if( idv .eq. -8 ) then
	   pgd = '/ppm'
        else if( idv .eq. -9 ) then
	   pgd = '/vppm'
        else if( idv .eq. -10 ) then
	   pgd = '/latex'
        else if( idv .eq. -11 ) then
	   pgd = '/file'
	else
	   print *, 'PLOTS>> Unknown PGPLOT device: ', pgd(:lnblnk(pgd))
           pgd = ' '
	   go to 2	! ugly
	end if

        call grossb( pgd, pgd1 )

        if( pgd1(:1) .eq. '/' ) then
C ***
C ***      Set output file name and extension
C ***
          if( index( pgd1, '/CPS' ) .eq. 1 .or.
     >        index( pgd1, '/VCPS' ) .eq. 1 .or.
     >        index( pgd1, '/PS' ) .eq. 1 .or.
     >        index( pgd1, '/VPS' ) .eq. 1
     >       ) then
              ext = '.ps'
              l = 3
           else if( index( pgd1, '/GIF' ) .eq. 1 .or.
     >              index( pgd1, '/VGIF' ) .eq. 1
     >            ) then
              ext = '.gif'
              l = 4
           else if( index( pgd1, '/PPM' ) .eq. 1 .or.
     >              index( pgd1, '/VPPM' ) .eq. 1
     >            ) then
              ext = '.ppm'
              l = 4
           else if( index( pgd1, '/LATEX' ) .eq. 1
     >            ) then
              ext = '.tex'
              l = 4
           else if( index( pgd1, '/FILE' ) .eq. 1
     >            ) then
              ext = '.pg'
              l = 3
           else
             l = 0
           end if
           if( l .gt. 0 ) then
              i = lnblnk(file_name)
              pgd = file_name(:i)//ext(:l)
              file_name = pgd     ! save for later to be returned by pltfile
              pgd = pgd(:i+l)//pgd1
           end if
        end if

	   
C ***   Opening the device is a bit complicated here.  PGPLOT gets the
C ***   window geometry with PGBEG.  We therefore want to delay the call
C ***   until after the user has answered about the full screen
C ***   representation.  Unfortunately, PGQINF won't return HARDCOPY
C ***   information for a closed device so we need to hardcode some
C ***   devices here.  The artistic below is supposed to ensure that this
C ***   will also work for devices unknow to this routine.


        term = idv .gt. 0 .or.      ! add other devices below if necessary
     >         index( '/XTERM/XSERVE/XDISP/XWINDOW/WINDOW/WINSERVE/'//
     >                'GW/CGW',
     >                pgd1(:lnblnk(pgd1)) ) .gt. 0

3       continue
	if( term ) then
           if( .not.flag ) then
	      print *, 'Do you want a full screen representation /Y/'
              read( 5, '(a)', end = 99 ) ans
	      full = ans. eq. 'y' .or. ans .eq. 'Y' .or. ans .eq. ' '
	   else
              full = .false.
           end if
        end if 

C ***
C ***   Make a first stab at opening the device
C ***
        status = pgbeg( 0, pgd, 1, 1 )
        if( status .ne. 1 ) then
C ***
C ***      Something's wrong with this device
C ***
           print *, 'PLOTS>> Device \'//pgd1(:lnblnk(pgd1))//
     >              '\ probably not configured in PGPLOT.'
           pgd = ' '
           do while( pgd .eq. ' ' .or. status .ne. 0 )
              print *, '        Press return to see list of configured'
     >                 //' devices or enter device.'
              read( 5, '(a)', end = 99, iostat = status ) pgd
              if( pgd .ne. ' ' ) then
                 go to 2      ! really ugly
              else
                 call pgldev
              end if
           end do
        end if  ! you won't get out of here unless status .eq. 1

C ***
C ***   Here we've got a working device
C ***
	call pgqinf( 'HARDCOPY', ans, l )    ! What device have we got?
        if( term .and. ans(:l) .eq. 'YES' ) then     ! more oops
           term = .false.
           print *, 'PLOTS>> Internal error.  PGPLOT claims this '//
     >              'device is not a terminal.'
           print *, '        Continuing anyway...'
        end if

        call pgsvp( 0., 1., 0., 1. )   ! get rid of margins
        if( term ) then
	   if( flag ) call pgask( .false. )
           if( .not. full ) then
	      call pgqvp( 1, phys_min_x, phys_max_x, 
     >                       phys_min_y, phys_max_y )
!              phys_min_x = 0.
!              phys_min_y = 0.
              f = min( (phys_max_x - phys_min_x)/plot_size_cm_x,
     >                 (phys_max_y - phys_min_y)/plot_size_cm_y )
              call pgvsiz( phys_min_x, 
     >                     phys_min_x + f*plot_size_cm_x, 
     >                     phys_min_y,
     >                     phys_min_y + f*plot_size_cm_y )

              f = f*plot_size_cm_y/(phys_max_y - phys_min_y)
           else
              f = 1.
           end if

	else
           if( ans(:l) .eq. 'NO' ) then     ! guessed wrong above
         print *, 'oops'
              call pgend                    ! try again with closed device
              term = .true.
              go to 3
           end if
           call pgpap( plot_size_cm_x/2.54,
     >                 plot_size_cm_y/plot_size_cm_x )
	   call pgvsiz( 0., plot_size_cm_x/2.54, 0., plot_size_cm_y/2.54 )
	end if



C ***
C *** Update common block /pgpa/
C ***
	fact_x = 1.
        fact_y = 1.
        cursor_x = 0.5*plot_size_cm_x            ! center of plot area
        cursor_y = 0.5*plot_size_cm_y            ! center of plot area
                    
C ***
C ***	Make Mongo use cm
C ***
	call pgswin( 0., plot_size_cm_x, 0., plot_size_cm_y )
C ***
C ***	and set physical clip limits in case of physical plot area 
C ***	larger than what is required
C ***

C ***
C ***	set line type to solid
C ***
!	call set ltype( 0 )

C ***
C ***	Set background color to white, foreground to black
C ***
C ***	Must be done before pgeras in order to have X11 update
C ***	the display correctly
C ***
!	status = lib$sys_trnlog( 'PGPLOT_BACKGROUND', l, ans )
!	if( status .eq. ss$_notran ) call pgscr( 0, 1., 1., 1. )  ! background
!	status = lib$sys_trnlog( 'PGPLOT_FOREGROUND', l, ans )
!	if( status .eq. ss$_notran ) call pgscr( 1, 0., 0., 0. )  ! foreground

        ans = ' '
	call getenv( 'PGPLOT_BACKGROUND', ans )
	if( ans .eq. ' ' ) call pgscr( 0, 1., 1., 1. )  ! background
        ans = ' '
	call getenv( 'PGPLOT_FOREGROUND', ans )
	if( ans .eq. ' ' ) call pgscr( 1, 0., 0., 0. )  ! foreground

        if( idv .gt. 0 ) then
C ***
C ***	   Has some ugly effect in postscript
C ***
	   if( clear_screen ) call pgeras	!page
	   clear_screen = .true.
	end if

	return
99	call exit


	entry plot5( x, y, ipen )
C ***         =====

	flag = ipen .eq. 5
	return


	entry plot_noerase
C ***	      ============

	clear_screen = .false.
	return


	entry pltend
C ***         ======

	call pgqvp( 2, phys_min_x, phys_max_x, phys_min_y, phys_max_y )
        call pgqinf( 'DEVICE', ans, l )
        call pgend
        call grossb( ans(:l), ans(:l) )
        if( index( '/NULL', ans(:l) ) .ne. 1 .and. .not.flag ) then
	   print *, 'Total plot-length (cm) : ',
     >             min( plot_size_cm_x, 0.1*(phys_max_x - phys_min_x) )
	   print *, '   Maximum height (cm) : ',
     >             min( plot_size_cm_y, 0.1*(phys_max_y - phys_min_y) )
	   print *, 'This is a  P G P L O T  plot.'
	   print *
	end if
	return


	entry pltfile( fn, lfn )
C ***         =======
C ***
C ***	Return file name of current or, if there is no open device,
C ***   last opened device.
C ***
C ***	fn:	c <	file name
C ***   lfn: 	I <	number of chars in file_name
C ***

	fn = file_name
	lfn = lnblnk(fn)
	return

	end
