	subroutine symblk( x, y, size, itext, theta, nchar )
	entry symbol( x, y, size, itext, theta, nchar )
C ***
C ******************************************************************************
C ***
C ***	Attempt to make this work with mongo and the diagr system.
C ***
C ***	x:	[cm]  lower left corner of string
C ***	y:	[cm]  lower left corner of string
C ***	size:	[cm]  height of characters
C ***	itext:        string to plot
C ***   theta: 	      angle of string (see what mongo can do)
C ***	nchar:	      number of chars in string, ignored as in Kalhoff's stuff
C ***
C ***	 9-APR-1997 15:57:50.90		ML / Bamberg.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	real x, y, size, theta
	character*(*) itext
	integer nchar

C ***
C ***	Functions
C ***
	integer lnblnk

C ***
C ***	Global variables
C ***
	include 'pgpa.inc'

C ***
C ***	Local variables
C ***
	real arc
	parameter( arc = 3.1415926535897932/180. )

!	include 'types.inc'
!	record /vector/ lim
        real lim_min_x, lim_max_x, lim_min_y, lim_max_y
	
	integer nch
	real expand
	character*1024 mongo_text	! just a guess

	real f, xch, xbox(4), ybox(4)
	real xu, yu, atheta, last_atheta, last_dheight, shift
	real dlength

	save last_atheta, last_dheight, xu, yu

	data last_atheta, last_dheight  /0., 0./

C ***
C ***	Code
C ***

	atheta = arc*theta
	shift = sin( atheta - last_atheta )*last_dheight ! shift for 999. to
							 ! avoid overlap
	if( x .eq. 999. ) then
	   xu = xu + cos( last_atheta )*shift	! make room for new character
	else
	   xu = x
	end if
	if( y .eq. 999. ) then
	   yu = yu + sin( last_atheta )*shift
	else
	   yu = y
	end if
	call plot( xu, yu, 3 )


C ***	The fact_x/y business is a simple attempt to do something clever
C ***	Mongo can't scale fonts in x and y independently.

!	call setexpand( f*mongo_def*size*0.5*(fact_x + fact_y) )

	call symk2mon( itext, mongo_text )

	call pgsch( 1. )		! set current size to PGPLOT default
        call pgqwin( lim_min_x, lim_max_x, lim_min_y, lim_max_y ) ! some pos.
	call pgqtxt( lim_min_X, lim_min_y, 0., 0., 'M', XBOX, YBOX )
					! get size of letter M
        xch = ybox(2) - ybox(1)		! in cm
	xch = xch/1.375			! there's some fudge factor in PGPLOT

	f = size/xch   			! compute ratio for PGPLOT
	call pgsch( f*fact_y )          ! factor expansion in (can't be done
					! for x and y independently)

        nch = lnblnk( mongo_text )
	call pgptxt( xu, yu, theta, 0., mongo_text(:nch) )  ! plot the string


	call pgqtxt( lim_min_X, lim_min_y, 0., 0., mongo_text(:nch),
     >               xbox, ybox )	! figure last position
        dlength = xbox(4) - xbox(2)
	xu = xu + dlength*cos(atheta)
	yu = yu + dlength*sin(atheta)
	last_atheta = atheta
	last_dheight = size

	call plot( xu, yu, 3 ) 		! set pen to end of string

	end
