	subroutine symk2mon( symblk, mongo )
C ***
C ******************************************************************************
C ***
C ***	Conversion routine for converting SYMBLK strings to MONGO strings.
C ***
C ***	SYMBLK:	character*(*) 	> SYMBLK type string (see Kalhoff software)
C ***	MONGO:	character*(*)   < MONGO type string - must not be same as SYMBLK
C ***
C ***	Make sure MONGO is long enough - routine adds many characters but exits
C ***	silently if not enough space found.
C ***
C ***	Compile -xl on Shitix
C ***
C ***	 2-SEP-1993 16:55:09.00		ML/ IoA Cambs.  Created.
C ***   14-AUG-1997 22:17:23.32         ML / Bamberg.  Take out %loc check for
C ***                                   Fujitsu Vp300
C ***
C ***
C ******************************************************************************
C ***
	implicit none
C ***
C ***	Arguments
C ***
	character*(*) symblk, mongo

C ***
C ***	Local variables
C ***
	integer i, j, k
	integer level
	character code
	logical greek

	integer lnblnk


!	if( %loc(symblk) .eq. %loc(mongo) ) then
!	   write( *, * ) 'symk2mon>  Illegal call.  Arguments must be ',
!     >                   'two different variables.'
!	   call exit(2)
!	end if

	mongo = ' '
	greek = .false.
	level = 0
	j = 0
	i = 1
	do while ( i .le. len( symblk ) )
           if( symblk(i:i) .eq. '&' ) then
              i = i + 1
	      call kleinb( symblk(i:i), code )
              if( code .eq. 't' ) then
C ***           
C ***            subscript
C ***           
                 do while( level .gt. 0 )
                    j = j + 2
                    if( j .gt. len(mongo) ) then
	               go to 1
	            end if
                    mongo(j-1:j) = '\d'
                    level = level - 1
	         end do
                 j = j + 2
                 if( j .gt. len(mongo) ) then
                    go to 1
                 end if
                 mongo(j-1:j) = '\d'
                 level = level - 1
              else if( code .eq. 'h' ) then
C ***           
C ***            superscript
C ***           
                 do while( level .lt. 0 )
                    j = j + 2
                    if( j .gt. len(mongo) ) then
	               go to 1
	            end if
                    mongo(j-1:j) = '\u'
                    level = level + 1
	         end do
                 j = j + 2
                 if( j .gt. len(mongo) ) then
                    go to 1
                 end if
                 mongo(j-1:j) = '\u'
                 level = level + 1
              else if( code .eq. 'm' ) then
C ***           
C ***            ordinary script (center position)
C ***           
                 do while( level .gt. 0 )
                    j = j + 2
                    if( j .gt. len(mongo) ) then
	               go to 1
	            end if
                    mongo(j-1:j) = '\d'
                    level = level - 1
	         end do
                 do while( level .lt. 0 )
                    j = j + 2
                    if( j .gt. len(mongo) ) then
	               go to 1
	            end if
                    mongo(j-1:j) = '\u'
                    level = level + 1
	         end do
              else if( code .eq. '&' ) then
C ***           
C ***            ampersand
C ***
                 j = j + 1
                 if( j .gt. len(mongo) ) then
                    go to 1
                 end if
                 mongo(j:j) = '&'
              else
C ***           
C ***            ignore other codes - no proper Mongo equivalent
C ***           
              end if
	   else if( symblk(i:i) .eq. '#' ) then
C ***
C ***	      Greek
C ***
              greek = .not. greek
           else if( symblk(i:i) .eq. '\' ) then
C ***
C ***	      Mongo's backslash, triple it
C ***
              j = j + 2
              if( j .gt. len(mongo) ) then
                 go to 1
              end if
              mongo(j-1:j) = '\\'
	   else
      	      if( greek ) then
	         call greek_char( mongo, j, symblk(i:i) )
	      else
                 j = j + 1
                 if( j .gt. len(mongo) ) then
                    go to 1
                 end if
                 mongo(j:j) = symblk(i:i)
	      end if
	   end if
           i = i + 1
	end do
	go to 2
1	continue
	write( 101, * ) 'Character String Overflow In Symk2mon when',
     >                  ' converting'
	write( 101, * ) symblk(:lnblnk(symblk))
2       end
	subroutine greek_char( mongo, j, symblk )
C ***
C ******************************************************************************
C ***
C ***	Converts symblk greek chars to mongo stuff.
C ***
C ***	 2-SEP-1993 19:35:48.00		ML / IoA Cambs.  Created.
C ***
C ******************************************************************************
C ***
	implicit none

C ***
C ***	Arguments
C ***
	character*(*) mongo, symblk*1
	integer j

C ***
C ***	Local variables
C ***
	character*(*) no_trans_greek, swap_chars_greek
        character*12 swap_trans_greek
        parameter( no_trans_greek = 'abdefgiklmnoprstwz'//
     >                              'ABDEFGIKLMNOPRSTWZ' )
	parameter( swap_chars_greek = 'chjqxyCHJQXY' )
        data       swap_trans_greek  /'xyqhcuXYQHCU'/

	character*(*) swap_chars_roman, swap_trans_roman*6
	parameter( swap_chars_roman = 'UVuv' )
     	data       swap_trans_roman  /'~=<>'/

	integer i



	if( index( no_trans_greek, symblk ) .ne. 0 ) then
C ***
C ***	   no translation required
C ***
           j = j + 3
	   if( j .gt. len(mongo) ) go to 1
           mongo(j-2:j) = '\g'//symblk
	else if( index( swap_chars_greek, symblk ) .ne. 0 ) then
C ***
C ***	   translate, but still in greek
C ***
           j = j + 3
	   if( j .gt. len(mongo) ) go to 1
           i = index( swap_chars_greek, symblk )
           mongo(j-2:j) = '\g'//swap_trans_greek( i:i )
	else if( index( swap_chars_roman, symblk ) .ne. 0 ) then
C ***
C ***	   the hairy stuff, translate, but no greek equivalent in mongo,
C ***	   so take corresponding roman char
C ***
           j = j + 1
           if( j .gt. len(mongo) ) go to 1
           i = index( swap_chars_roman, symblk )
           mongo(j:j) = swap_trans_roman(i:i)
        else   
C ***
C ***      still hairy, take roman char for rest (no translation required)
C ***
           j = j + 1
           if( j .gt. len(mongo) ) go to 1
           mongo(j:j) = symblk
	end if
	go to 2
1	continue
	write( 101, * ) 'Character String Overflow In Greek_char'
2	end
